GNU bug report logs - #46299
28.0.50; Value of tab-bar-show not respected in new frames.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Bastian Beischer <bastian.beischer@HIDDEN>; Keywords: fixed; Done: Juri Linkov <juri@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug marked as fixed in version 28.0.50, send any further explanations to 46299 <at> debbugs.gnu.org and Bastian Beischer <bastian.beischer@HIDDEN> Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 24 Feb 2021 18:47:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 24 13:47:57 2021
Received: from localhost ([127.0.0.1]:35928 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lEzCX-0001lI-Lg
	for submit <at> debbugs.gnu.org; Wed, 24 Feb 2021 13:47:57 -0500
Received: from relay9-d.mail.gandi.net ([217.70.183.199]:56987)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>)
 id 1lEzCW-0001l1-AS; Wed, 24 Feb 2021 13:47:56 -0500
X-Originating-IP: 91.129.96.116
Received: from mail.gandi.net (m91-129-96-116.cust.tele2.ee [91.129.96.116])
 (Authenticated sender: juri@HIDDEN)
 by relay9-d.mail.gandi.net (Postfix) with ESMTPSA id BE431FF804;
 Wed, 24 Feb 2021 18:47:48 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN> <87sg5xwskc.fsf@HIDDEN>
 <87pn11z2n6.fsf@HIDDEN> <878s7pdlsi.fsf@HIDDEN>
 <87im6sffct.fsf@HIDDEN> <87tuqchvv4.fsf@HIDDEN>
 <87a6s32a8i.fsf@HIDDEN>
Date: Wed, 24 Feb 2021 20:46:36 +0200
In-Reply-To: <87a6s32a8i.fsf@HIDDEN> (Juri Linkov's message of "Tue, 
 16 Feb 2021 19:28:43 +0200")
Message-ID: <87zgztjrkr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

tags 46299 fixed
close 46299 28.0.50
thanks

> Thanks, now your patch is pushed to master.

It seems now everything works well, so I''m closing this bug report.
Please reopen if you have more ideas.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 16 Feb 2021 17:30:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 16 12:30:27 2021
Received: from localhost ([127.0.0.1]:41471 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lC4B8-0007Vu-LI
	for submit <at> debbugs.gnu.org; Tue, 16 Feb 2021 12:30:26 -0500
Received: from relay1-d.mail.gandi.net ([217.70.183.193]:27781)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lC4B7-0007Vd-3j
 for 46299 <at> debbugs.gnu.org; Tue, 16 Feb 2021 12:30:25 -0500
X-Originating-IP: 91.129.98.178
Received: from mail.gandi.net (m91-129-98-178.cust.tele2.ee [91.129.98.178])
 (Authenticated sender: juri@HIDDEN)
 by relay1-d.mail.gandi.net (Postfix) with ESMTPSA id BE1E7240009;
 Tue, 16 Feb 2021 17:30:17 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN> <87sg5xwskc.fsf@HIDDEN>
 <87pn11z2n6.fsf@HIDDEN> <878s7pdlsi.fsf@HIDDEN>
 <87im6sffct.fsf@HIDDEN> <87tuqchvv4.fsf@HIDDEN>
Date: Tue, 16 Feb 2021 19:28:43 +0200
In-Reply-To: <87tuqchvv4.fsf@HIDDEN> (Bastian Beranek's message of "Tue, 16
 Feb 2021 16:31:59 +0100")
Message-ID: <87a6s32a8i.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> "frame-local variables".
>
> Right, that would be the idea. Is there precedent for this? It seems to
> be the easiest way forward, but I don't know if this is considered
> acceptable.

Window-local tab-line.el uses window-parameter all over the place,
so for frame-local tab-bar.el it's natural to use frame-parameter.

>> Is this acceptable?

Yes, I agree with your reasoning in previous messages.

>> Proposed patch is attached.
>
> I made a mistake in that patch: In (frame-parameter ... ) the first
> argument should have been "frame" not "nil". Please find a fixed
> version attached.

Thanks, now your patch is pushed to master.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 16 Feb 2021 15:32:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 16 10:32:12 2021
Received: from localhost ([127.0.0.1]:41255 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lC2Ki-0001um-64
	for submit <at> debbugs.gnu.org; Tue, 16 Feb 2021 10:32:12 -0500
Received: from mail-ej1-f47.google.com ([209.85.218.47]:35066)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lC2Kg-0001pW-MN
 for 46299 <at> debbugs.gnu.org; Tue, 16 Feb 2021 10:32:11 -0500
Received: by mail-ej1-f47.google.com with SMTP id g5so13727615ejt.2
 for <46299 <at> debbugs.gnu.org>; Tue, 16 Feb 2021 07:32:10 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:user-agent:date
 :message-id:mime-version;
 bh=d77x7uQwpP4SamDKCBpeocfvP7VekTm0/CpSBnIJ0qw=;
 b=TEOKg5SdErU1C8oUQgcZPtMu/CxvXadZq9P1rRnd8XkVdXMqCSL5r9HPDgx8cyQhpy
 4gCbrw+udR/1QrSgj97TJRS4VcZ1/EYimssIYOuN37vfhwCKVA9ruV6FeyzRKkGCxR5Y
 NJl2kKeMPvDIZve1wN/SHgjFsnLBN0AWNlODh7Ww+GDBpFVw24QO2aIcXwcKE4xud9hY
 +7hBWcIkyFHlZtRLWoc4nmF+YteLprjeZzZtEcHQIR39sldoCfZTPvZBLsPho3Jsk6SH
 DAHi0bWP1tdbjjDnwwGTMZSapUiCIjkq0J88OI41nxTvcGnp6oUMfO07rxDog/lqXOnl
 qsOg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references
 :user-agent:date:message-id:mime-version;
 bh=d77x7uQwpP4SamDKCBpeocfvP7VekTm0/CpSBnIJ0qw=;
 b=nwfGL1dFHLbcZrdHiwhaS5Yy5fWHPyoowKlAJjsrOawSJqIXQA1+U6QVsvbyGx3bR5
 SzkN1Yl9jU763FnFQhqJ8TOlOdBUch6RvQFZtQq+3riBhHBB3wMfeqZC8B3vXsfUNHry
 8NZL+JWZ+edAafW5wqF9HITW9lw9RZtAtA94GbNqgOs/aR5Mqm/s4t5EaDoWH/OlY3to
 o3i5UvoJih2Oc74loECvyTvcuE6ndm9lV7DVDO3F030SucE2X/VPMmR8a//Yb8hsroDU
 ugurx7OraGj9qVjlJgGUtefCdcmB+YAb2lWMTmzAFL7tHsQRpqgsiOvT4TPMTYYnzcVO
 mZVQ==
X-Gm-Message-State: AOAM530EXj1L2gzxo+Y9gJkrXZDZzHNNhyWSiMr0UdQ/vWsT/VTAoKge
 OYVUY5SB2mg/FOH2CLR6Dz0Ku3EzlDhjFg==
X-Google-Smtp-Source: ABdhPJxSVv55v4Pxc4oPyEpMjQBcxDIlLjEoycRpqsL3IYoJMjrd/IrNNoheSC+zIV+exeENMyGSmg==
X-Received: by 2002:a17:906:82da:: with SMTP id
 a26mr2754271ejy.447.1613489523941; 
 Tue, 16 Feb 2021 07:32:03 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id qk14sm14045170ejb.13.2021.02.16.07.32.02
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 16 Feb 2021 07:32:02 -0800 (PST)
From: Bastian Beranek <bastian.beischer@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
In-Reply-To: <87im6sffct.fsf@HIDDEN> (Bastian Beranek's message of "Tue, 16
 Feb 2021 11:59:14 +0100")
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN> <87sg5xwskc.fsf@HIDDEN>
 <87pn11z2n6.fsf@HIDDEN> <878s7pdlsi.fsf@HIDDEN>
 <87im6sffct.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Date: Tue, 16 Feb 2021 16:31:59 +0100
Message-ID: <87tuqchvv4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Bastian Beranek <bastian.beischer@HIDDEN> writes:

> Is this acceptable?
>
> Proposed patch is attached.
>

I made a mistake in that patch: In (frame-parameter ... ) the first
argument should have been "frame" not "nil". Please find a fixed
version attached.


--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline;
 filename=0001-lisp-tab-bar.el-Fix-behavior-of-toggle-frame-tab-bar.patch

From d4d40915ad6537fdd11555dfed2273303c564fb9 Mon Sep 17 00:00:00 2001
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Tue, 16 Feb 2021 11:35:35 +0100
Subject: [PATCH] * lisp/tab-bar.el: Fix behavior of toggle-frame-tab-bar (bug
 #46299)

(toggle-frame-tab-bar): Add frame parameter to protect tab bar state.
(tab-bar--update-tab-bar-lines): Check parameter.
---
 lisp/tab-bar.el | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 4e47ae2c10..f0210e1a42 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -161,7 +161,8 @@ tab-bar--update-tab-bar-lines
                          (t frames))))
     ;; Loop over all frames and update default-frame-alist
     (dolist (frame frame-lst)
-      (set-frame-parameter frame 'tab-bar-lines (tab-bar--tab-bar-lines-for-frame frame))))
+      (unless (frame-parameter frame 'tab-bar-lines-keep-state)
+        (set-frame-parameter frame 'tab-bar-lines (tab-bar--tab-bar-lines-for-frame frame)))))
   (when (eq frames t)
     (setq default-frame-alist
           (cons (cons 'tab-bar-lines (if (and tab-bar-mode (eq tab-bar-show t)) 1 0))
@@ -233,7 +234,9 @@ toggle-frame-tab-bar
   (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)"
   (interactive)
   (set-frame-parameter frame 'tab-bar-lines
-                       (if (> (frame-parameter frame 'tab-bar-lines) 0) 0 1)))
+                       (if (> (frame-parameter frame 'tab-bar-lines) 0) 0 1))
+  (set-frame-parameter frame 'tab-bar-lines-keep-state
+                       (not (frame-parameter frame 'tab-bar-lines-keep-state))))
 
 (defvar tab-bar-map (make-sparse-keymap)
   "Keymap for the tab bar.
-- 
2.30.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 16 Feb 2021 10:59:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 16 05:59:25 2021
Received: from localhost ([127.0.0.1]:39521 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBy4i-000172-W4
	for submit <at> debbugs.gnu.org; Tue, 16 Feb 2021 05:59:25 -0500
Received: from mail-ed1-f54.google.com ([209.85.208.54]:44429)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBy4g-00016o-F3
 for 46299 <at> debbugs.gnu.org; Tue, 16 Feb 2021 05:59:24 -0500
Received: by mail-ed1-f54.google.com with SMTP id g3so9059998edb.11
 for <46299 <at> debbugs.gnu.org>; Tue, 16 Feb 2021 02:59:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=xIB1kzeIv/6urXSLvtNziDtD+CM5pEVY4GhK70SxMsk=;
 b=WVUZj12eTDg/ReYN4Wna1RIBVXqC3TQd1T0YhAk/Rs2+fq4I9WfONreoPVzMbd0vTC
 blohYkfX9xuyHkcuXl69fMqq3F/HnrC+TP1g54Y9krbIZhsZ66im00lDgvEGsHlQRfRy
 kHlbk4D6iwJK9+hX8ATm+JkDtOfZKAFlmhIv0Vcrc9/OxMCPd9zQbmt8m2YUp+Vex7+u
 BxWJypYNonQYskZYMinRfsQZW3IVZV1iJ19YFT+7AavzzJ0FmrbykkaQxZ7bdQnbPkte
 5eTS3M0y7Es8qWzLWCe2Lp1WRNOZpIrPfOgeToUYkmaa2iJ5tbWKcorQ8B0M+3kHoWOb
 bXZQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=xIB1kzeIv/6urXSLvtNziDtD+CM5pEVY4GhK70SxMsk=;
 b=DWt2/jgS5gy685LHAH6IAURBCvEmh2RXxB1GBB6NVY3k/q5++Y2cOOOufpcA2ySEAH
 /so2uDiVMGfcxrN50oXOTkxBIQYq5/pk1U7rBveM4rEMhvRWmCgwzAiThY90gsg701dx
 43WBfWn3q3XAB37+FA5pySxjF+Mxa07fWS5GNrl0kLdkrXsHJf96SBNC5XZyd08o4hiA
 bLWZZnyzUOccMoCgKrM7D1PYdYA4i1CFAtJkZSrDVoIL9gJtQyBesmRuO+BPfnozjzSn
 P0NW7NG3djRRy4Xo9Ye7Fau/+6F8cDbuMxtNaqejjOh+ofgS094asPmMlVo/LRu4Gi1y
 XqvQ==
X-Gm-Message-State: AOAM532AArCiZE3oeaoSsEH038EttqrhNWvu0W6+hyMxhO1n3jDNfjRo
 3D3lWi5uoxfWPMrh+uGoxANuExQocZTLyA==
X-Google-Smtp-Source: ABdhPJwMFObtW6dpeNjVmIHqrWZ4Ath6hX44xmm6oaVDQdhBkRZ8Mlt3FQzkizaeY7arfgND0Ic3Bw==
X-Received: by 2002:a05:6402:b2d:: with SMTP id
 bo13mr20029387edb.280.1613473156222; 
 Tue, 16 Feb 2021 02:59:16 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id y22sm4945197ejq.122.2021.02.16.02.59.14
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 16 Feb 2021 02:59:15 -0800 (PST)
From: Bastian Beranek <bastian.beischer@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
References: <871rdv4xog.fsf@HIDDEN> <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN> <87sg5xwskc.fsf@HIDDEN>
 <87pn11z2n6.fsf@HIDDEN> <878s7pdlsi.fsf@HIDDEN>
Date: Tue, 16 Feb 2021 11:59:14 +0100
In-Reply-To: <878s7pdlsi.fsf@HIDDEN> (Bastian Beranek's message of "Mon, 15
 Feb 2021 23:10:53 +0100")
Message-ID: <87im6sffct.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Bastian Beranek <bastian.beischer@HIDDEN> writes:

> But how to go back? It seems that tab-bar-show should go back to "1" (in
> order to make it a real toggle, i.e. it undoes itself). However, that
> means that after the second toggle-frame-tab-bar the tab-bar will either
> be shown or not, depending on the number of tabs opened at that specific
> time. We have to consider that the user created or closed tabs in
> between, so that means that there will be situations in which
> toggle-frame-tab-bar does not really seem to do anything... For example:
>
> - 1 tab (tab bar hidden)
> - create tab -> 2 tabs (tab bar shown)
> - toggle-frame-tab-bar (tab bar hidden)
> - close tab (tab bar hidden)
> - toggle-frame-tab-bar (tab bar still hidden, because only 1 tab)

I think what we could do is:

a) always toggle the current visibility: That seems to be a must, it
   would be confusing otherwise.

b) The first time toggle-frame-tab-bar is called, add a notice to the
   frame parameters that prevents tab-bar--update-tab-bar-lines from
   changing that frames tab-bar visibility. This means that after the
   toggle the tab-bar visibility keeps its state until
   toggle-frame-tab-bar is called again.

c) When it is called a second time toggle-frame-tab-bar sets the new
   frame parameter to nil and flips the visibility again (see a).

d) Then the tab-bar--update-tab-bar-lines logic will be active again,
   but only after a new tab is created or closed on that frame.

This prevents the problem listed in my last mail, in the last step the
tab-bar will be shown after toggling (although tab-bar-show is 1 and
there is only one tab), but then once you create more tabs or close tabs
it will revert to the usual behavior.

Is this acceptable?

Proposed patch is attached.

--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline;
 filename=0001-Fix-behavior-of-toggle-frame-tab-bar-bug-46299.patch

From 5f158962c1bc63c10ebaa49357a16e45664d5579 Mon Sep 17 00:00:00 2001
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Tue, 16 Feb 2021 11:35:35 +0100
Subject: [PATCH] Fix behavior of toggle-frame-tab-bar (bug #46299)

* lisp/tab-bar.el (toggle-frame-tab-bar): Add frame attribute to
protect tab bar state from changing.
(tab-bar--update-tab-bar-lines): Check for new attribute
---
 lisp/tab-bar.el | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 4e47ae2c10..2fa34385f1 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -161,7 +161,8 @@ tab-bar--update-tab-bar-lines
                          (t frames))))
     ;; Loop over all frames and update default-frame-alist
     (dolist (frame frame-lst)
-      (set-frame-parameter frame 'tab-bar-lines (tab-bar--tab-bar-lines-for-frame frame))))
+      (unless (frame-parameter frame 'tab-bar-lines-keep-state)
+        (set-frame-parameter frame 'tab-bar-lines (tab-bar--tab-bar-lines-for-frame frame)))))
   (when (eq frames t)
     (setq default-frame-alist
           (cons (cons 'tab-bar-lines (if (and tab-bar-mode (eq tab-bar-show t)) 1 0))
@@ -233,7 +234,9 @@ toggle-frame-tab-bar
   (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)"
   (interactive)
   (set-frame-parameter frame 'tab-bar-lines
-                       (if (> (frame-parameter frame 'tab-bar-lines) 0) 0 1)))
+                       (if (> (frame-parameter frame 'tab-bar-lines) 0) 0 1))
+  (set-frame-parameter frame 'tab-bar-lines-keep-state
+                       (not (frame-parameter nil 'tab-bar-lines-keep-state))))
 
 (defvar tab-bar-map (make-sparse-keymap)
   "Keymap for the tab bar.
-- 
2.30.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 16 Feb 2021 10:41:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 16 05:41:25 2021
Received: from localhost ([127.0.0.1]:39488 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBxnI-0000h2-VG
	for submit <at> debbugs.gnu.org; Tue, 16 Feb 2021 05:41:25 -0500
Received: from mail-ed1-f45.google.com ([209.85.208.45]:33659)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBxnF-0000gm-U0
 for 46299 <at> debbugs.gnu.org; Tue, 16 Feb 2021 05:41:23 -0500
Received: by mail-ed1-f45.google.com with SMTP id c6so11547955ede.0
 for <46299 <at> debbugs.gnu.org>; Tue, 16 Feb 2021 02:41:21 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=SoWy+kHdTcVBrowAJOaHXohqCOy7Wf4Z0vjL7HHQt2Q=;
 b=tOoNpLaHNGxT4lxj4kSLkmBhlP7CTUXoQYqtxlnGMoMstZjdkYtrTkONmOdChnyE1m
 Eta+a4Fr5EyYPaMszvvNJtmIp6vEEN/5g3n0h67WF8yLjngpvzERc0HbFksUL2KOshKJ
 /rSWIk2NnvvXO55W/59MUZqYhrkaJboIXyN7qVv+vqdirSQE1MzS/VxsVFgy8E9ktyUF
 Xq4Godj0vnPFRmfWhp99CHOp4pUO4CNWlr1009LQcuRgpdVloXJqPKLP/1sw0ssOtIO7
 lT27AU/T5LecCtBayFfW0K8Ealu0a1Mj0kVeNlsr1iDcd88+M4Epo7vpYiXQQJiN3/Te
 z9oQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=SoWy+kHdTcVBrowAJOaHXohqCOy7Wf4Z0vjL7HHQt2Q=;
 b=DPN41QX5u03m4Yro26k8i/cSb3mxwgnsQ5NGJmUJtRWk2tQnUvGTjmc3KiPj33v7fP
 QqAbA0mAJQhSAdISusPGKyR8ErJyZUbNT35jFHn+pL3uOARsm4tagvz7HQjcwdPKMn4P
 4WLOPgkFTUjJyXzSn0oiR6usTHVdCYC9AaOasihVypm5r5m/1QjrUvDi4BIk0B6Kihg6
 u8pC6c5TOcN9sKlRM3lPJp2JQgEnx8Q8NA9xgQbQ2iMprjJ/PH3hdD2xcxF5njiMK9Zh
 IzF8lzgHyNziwdKySalVKbWP+HHQr/fSANI0A1izww8PKFPwyby7lflVMR1IlOINctwJ
 cPQg==
X-Gm-Message-State: AOAM533G5cTBlJG6CM4O5OyODbDmr+Z5Z8tbzOshTHliwCztZjJVZsf5
 VI56/RjZqxWZM/oxchqbeP8=
X-Google-Smtp-Source: ABdhPJxXV+I3XZS2M8aSXbKD4DL6umbU60AGx9mOvbR6fNvgeydSO1KUX0fH1wNH1/PRHhUQt1p4GA==
X-Received: by 2002:a05:6402:d:: with SMTP id
 d13mr20381792edu.274.1613472075935; 
 Tue, 16 Feb 2021 02:41:15 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id x17sm11366128edq.42.2021.02.16.02.41.15
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 16 Feb 2021 02:41:15 -0800 (PST)
From: Bastian Beranek <bastian.beischer@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
 <871rdjrbcf.fsf@HIDDEN> <87pn12mrsb.fsf@HIDDEN>
 <83r1lh9wta.fsf@HIDDEN>
 <CAK9AuB9rFpfQoRjM-TN6h8AJbDbKddAPr4p9T7ncjrPxtfZ4zQ@HIDDEN>
 <83mtw59vk9.fsf@HIDDEN>
Date: Tue, 16 Feb 2021 11:40:58 +0100
In-Reply-To: <83mtw59vk9.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 15 Feb
 2021 17:53:26 +0200")
Message-ID: <87lfbofg79.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:
>
> I see the problem on GNU/Linux, but not on MS-Windows.

Interesting. I will report a new bug for this issue.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 16 Feb 2021 02:09:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 21:09:08 2021
Received: from localhost ([127.0.0.1]:39060 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBpnY-0004dh-8A
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 21:09:08 -0500
Received: from userp2120.oracle.com ([156.151.31.85]:46430)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1lBpnV-0004d9-27
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 21:09:07 -0500
Received: from pps.filterd (userp2120.oracle.com [127.0.0.1])
 by userp2120.oracle.com (8.16.0.42/8.16.0.42) with SMTP id 11G24umC050305;
 Tue, 16 Feb 2021 02:08:59 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=from : to : cc :
 subject : date : message-id : references : in-reply-to : content-type :
 content-transfer-encoding : mime-version; s=corp-2020-01-29;
 bh=FQ6pUIG8r0pGIs6c71t8CvvW6QaPFe3vIIkImGlCr/I=;
 b=hsT1nUfz+3qjAnGntxalqkV3SUBQX9wcJCCYWSKXvh7OsR0JId8lX3VgkLZoDw9vBTLR
 9bOkYKnFcN0qNdMvSJZ/sfaaJyl42GQCtR7OiAFfyozcD9JDjv17jm6YkfShqS+5G+F1
 HQ0h0P6sXxPU6ZmXhxxTdkfHmURsVdwzZPBUCcIocbOLMolVnCwHnPJ92b1VRuN8HsPl
 K9GMgT9Z6UH+/8TgqISdutqr6DGKTZIjcIUzo7xx++XZOJRwLzP5CRlynvC3HOkGg0GO
 vzfLtVixfnewkEY13/8OHFWfjGma0FNYD7KIp30or+/JRqNrc8lTWa8gzp4yniYjXrTd jA== 
Received: from userp3030.oracle.com (userp3030.oracle.com [156.151.31.80])
 by userp2120.oracle.com with ESMTP id 36p7dnd9xv-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 16 Feb 2021 02:08:58 +0000
Received: from pps.filterd (userp3030.oracle.com [127.0.0.1])
 by userp3030.oracle.com (8.16.0.42/8.16.0.42) with SMTP id 11G1xwDa190270;
 Tue, 16 Feb 2021 02:08:58 GMT
Received: from nam12-dm6-obe.outbound.protection.outlook.com
 (mail-dm6nam12lp2172.outbound.protection.outlook.com [104.47.59.172])
 by userp3030.oracle.com with ESMTP id 36prpw77yt-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 16 Feb 2021 02:08:58 +0000
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=fnOGep4foF4SO+uV9FOBxAY1427VPNp1v2Mse/Ng63x/JIq/Jy6sLJA43/PAuFHv/+m9EpgkKJqVoYtLsJhMKGzkYApoykTKs/a2K3PerQTQCKpkmF2ZpQ8Iu2RVINIuyPAVWbusUyn3ytqaxdoCSADYrSNWAVZc1fyPan5G4L4RYOWJhK4zLH+kyBUSOkD64lwsNn0IkKIvvLOFJ2pFpXs785DQvJIY+wKMjM+IlX7VZyKxeARbl6LfrDL1umVRamWO63RkkUyOyy4xYKjfE5Du2vwflu+4X4gUsiZyIxStai56E4OZfjRzV8uT+SqRKJe7Yy1JWpkM2DH13oBXVA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=FQ6pUIG8r0pGIs6c71t8CvvW6QaPFe3vIIkImGlCr/I=;
 b=ecEvFtwph1cMm5DNcTSp8pjwc8VZeK2/0aYnXsnohZ7ikurR7aeBUW0sxlkZLueZrUIFGd90XFIokZNyVfCE5LNdwf2HxVXS6ZpJS6fm2ZuxJkejM1qQ28WXZd5VTLCd84/pPdNEBa/4VyDZDbdIaSCQU3J0Upnf2LVTc2H6aM6DRdzvogtcfd/Fu2BPkHUwdLALvyI+PDHdEmXik5tjammlc3UTDtupRz9njUqXMPeAD+E1eTPXoPSkSrvfEUMNUkb7QriyI63iFAuFOW/hXTF4AOfsWic5sjVYjc1bN3Zt71faeHoT/HNaQ8nlp+/EHtJrKavCyXFP8Nkp8w+fMQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=oracle.com; dmarc=pass action=none header.from=oracle.com;
 dkim=pass header.d=oracle.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=oracle.onmicrosoft.com; s=selector2-oracle-onmicrosoft-com;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=FQ6pUIG8r0pGIs6c71t8CvvW6QaPFe3vIIkImGlCr/I=;
 b=h2c/3KEx088GbG+OxdRdeMgCqO7z7yW165Lx0eO4qXojRJJ/m7mL0EjMCW5BwMNMFlOx/YkE04j+NI50jkj9kx6TbmedGqj6slK/8s3YVCEcALHktqvgCyCaHhdXzetuzcJmc0QVQ5LjwbZIUiFMXGiCjcoddhFE49cTRR487A0=
Received: from SA2PR10MB4474.namprd10.prod.outlook.com (2603:10b6:806:11b::15)
 by SA2PR10MB4634.namprd10.prod.outlook.com (2603:10b6:806:114::9)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3846.27; Tue, 16 Feb
 2021 02:08:56 +0000
Received: from SA2PR10MB4474.namprd10.prod.outlook.com
 ([fe80::b8d2:db6d:3e4b:d315]) by SA2PR10MB4474.namprd10.prod.outlook.com
 ([fe80::b8d2:db6d:3e4b:d315%5]) with mapi id 15.20.3846.041; Tue, 16 Feb 2021
 02:08:56 +0000
From: Drew Adams <drew.adams@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>, Juri Linkov <juri@HIDDEN>
Subject: RE: [External] : bug#46299: 28.0.50; Value of tab-bar-show not
 respected in new frames.
Thread-Topic: [External] : bug#46299: 28.0.50; Value of tab-bar-show not
 respected in new frames.
Thread-Index: AQHXA+edLOlfvgunXkuzmQM/d+VDxapaA0Fg
Date: Tue, 16 Feb 2021 02:08:56 +0000
Message-ID: <SA2PR10MB44745324195528AAAFF7BD9EF3879@HIDDEN>
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN> <87sg5xwskc.fsf@HIDDEN>
 <87pn11z2n6.fsf@HIDDEN> <878s7pdlsi.fsf@HIDDEN>
In-Reply-To: <878s7pdlsi.fsf@HIDDEN>
Accept-Language: en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
authentication-results: gmail.com; dkim=none (message not signed)
 header.d=none;gmail.com; dmarc=none action=none header.from=oracle.com;
x-originating-ip: [73.170.83.28]
x-ms-publictraffictype: Email
x-ms-office365-filtering-correlation-id: 06b373e4-e009-4957-cbcb-08d8d21fd10f
x-ms-traffictypediagnostic: SA2PR10MB4634:
x-microsoft-antispam-prvs: <SA2PR10MB4634507483B7A0E3F5CAA13FF3879@HIDDEN>
x-ms-oob-tlc-oobclassifiers: OLM:5236;
x-ms-exchange-senderadcheck: 1
x-microsoft-antispam: BCL:0;
x-microsoft-antispam-message-info: TrRXIv2G+T4qeuImo0NwvaFL9WnEfAMOGzeBEgBE3/puZYnlNmOj+RontmtP2PPdjifL/L22nFx2WBDAGvOlOOgVvXDRbIN7jZwaTUR8ybql9gFwlcVdmYLkqqzEREgCxmBMNKNplMcgneXWxoQqEgSS3ZwVh2r3zH74V/EpFMlZk9BHQN2Y43iOpLLqd1q8EH2jLG0ChvCeU7xpZpX2a5Sa1A9BKNMf1iBGDxt39BrcvXEY3DBUaIsweslTmmWEnxuWpgwwyovKBbupaxl9RXTCAwEYAqytFMWn2owpGGzPVa/GOyNPNwM18p4RmGTsPEu2Q5JO7k12Xa9h52rR/wUAC40nktVR+LN+rJRkXtcNw1ZTTbnY3NAM2tp3fZcADrJBgYLmvfGzj6bB0nCuUJ74nfdey9Yj3EgnWWHxmOuvLava5sBvDBvRDSLJuiPRB0E0SNzPItY6atp+/Oh/Q24ccQjJ7577r1McRMRVfTQU/rrRHzf4xpi3aZqnomzqox6NaiemEguy36qF6TURUg==
x-forefront-antispam-report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:SA2PR10MB4474.namprd10.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(346002)(396003)(136003)(366004)(39860400002)(376002)(9686003)(2906002)(478600001)(52536014)(186003)(6506007)(33656002)(55016002)(7696005)(86362001)(44832011)(76116006)(64756008)(66946007)(4326008)(316002)(110136005)(8676002)(71200400001)(8936002)(66446008)(66556008)(66476007)(26005)(5660300002)(4744005);
 DIR:OUT; SFP:1101; 
x-ms-exchange-antispam-messagedata: =?us-ascii?Q?EPugNWDsm7VQkj7JjlIVhv9Bf6RApQsjHIDAcIyXFjc+DsgoVr4om2g4r4po?=
 =?us-ascii?Q?T5R3JW+LyqIxTacCZTi2EZNS98BchsOcui35Q69du9OR1PCemb0fpXRxxNWM?=
 =?us-ascii?Q?nfTTSKN/y7Slcn0FuHWWT5ZiEOteZuLfYksFaTohfYLxKKXeCGQQ4t1oNR90?=
 =?us-ascii?Q?xQadVooq7lQ2wluKVryhjiPgkh+jINHdvZvNq1xYLN5ziZ7dwtupnyfnkb6p?=
 =?us-ascii?Q?bAy3IkTxjt0VVVcwyIRLrZ+eE2IG672vUkEUEWr11HwzOhAkqW246MkHa6Gi?=
 =?us-ascii?Q?NskRZOamzc3oX9Q8mcE2zN8MjhjYHV2HaYTfqKxqsf3WqIgzS+i+pblwnAea?=
 =?us-ascii?Q?HxrQwukyiw+xlgPfEVVstfu0y3NQd7MX97ofoEDV3WiIC7WI5aAcW0j2Lcb9?=
 =?us-ascii?Q?LHNDSH2f3MICwjYd09ujqE8yYAk+vt29dydqDSAUOO2jG7sBxwrWhBT9AspA?=
 =?us-ascii?Q?pnXYGlsceZ+SDYmvUfJXNrzz3nN2vKjr483B3Qd1OQVMzaPhPepNyVqjhw4M?=
 =?us-ascii?Q?p7CSmXRV3tyLTpryo86Fr+mvE4/JHQtxVCLbxXXZe8KtZnnv5HBQ6ekvpZXW?=
 =?us-ascii?Q?F1NDCYbB3bMp+cESkbzsiTxbQvCA8+bvbxnIjmVZ56ZCvK2FDE2+Pupsz7Iq?=
 =?us-ascii?Q?LDOK3atYFMK0na3TVN/5IKIukwGxKJaYFmkjRv0CGMcJOCq+D1aQhIs6CiKu?=
 =?us-ascii?Q?RbMZR9XGJ3AUGXI8TpvfpiB/0isN8wLoTLS3kkmE5CZFuXOqXlu6crLxI9Lt?=
 =?us-ascii?Q?Uh2PJFGBpMBfrrfUpuwKFOGfc/yxgmiTY5SRunDOGGkkNnlvCzvWaVRM1JMX?=
 =?us-ascii?Q?ArJV3oTIbnyHlG4wPCnSoazbOfKf2la4ZpH92bGK+JQBEFS/PCYJNIKt8kOl?=
 =?us-ascii?Q?lyWdPYb6G9qeR3HgCRKwGacwJA6ngYpL+PdL24pSAkXPiBpO0MgRqRKawiUf?=
 =?us-ascii?Q?BkTJfMlvnLhAt84WliIcNzQ9oKZ6UBAw7Bz1mu6wo1eqbv5Jbjm0g+5TWNgp?=
 =?us-ascii?Q?Wad0SNoVcES9qnPGReZvoeEck4vwm/0Th3zpa5jsqyNkUxHafbwLkj3/syJa?=
 =?us-ascii?Q?eha2h7eCFqzOdsd1NyoSeZhA7uOeXcB1pqpHjdcaLwX28+gAJVSxipO+4ogz?=
 =?us-ascii?Q?Ft6WRyasWpW1CZcQ3J8GBhJtqfkKpTadWly0WHW3IUa70UanxguuIkSgKmp3?=
 =?us-ascii?Q?4AZ2QEaUyxB9mm8aqqd844AqNVmyobfkalX0gehP5RwNf+8cNYGxIxS3bjLa?=
 =?us-ascii?Q?GT3HqOHPXQ3arqiIwjku2H0taNX31NA27UUxoj13keDyp5r7CKhgwsTinRCy?=
 =?us-ascii?Q?ST8=3D?=
x-ms-exchange-transport-forked: True
Content-Type: text/plain; charset="us-ascii"
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-OriginatorOrg: oracle.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-AuthSource: SA2PR10MB4474.namprd10.prod.outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 06b373e4-e009-4957-cbcb-08d8d21fd10f
X-MS-Exchange-CrossTenant-originalarrivaltime: 16 Feb 2021 02:08:56.5530 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Hosted
X-MS-Exchange-CrossTenant-id: 4e2c6054-71cb-48f1-bd6c-3a9705aca71b
X-MS-Exchange-CrossTenant-mailboxtype: HOSTED
X-MS-Exchange-CrossTenant-userprincipalname: Mo3GOsdZ+iA3widwrQk6GV+BTfS1G/kZ0ci3gzwoZJpS/g3sWIzLoIJUG6gOvEkcky1A1p/A1JDT/UMrwVp0BA==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: SA2PR10MB4634
X-Proofpoint-Virus-Version: vendor=nai engine=6200 definitions=9896
 signatures=668683
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 bulkscore=0
 mlxlogscore=999
 phishscore=0 adultscore=0 mlxscore=0 suspectscore=0 malwarescore=0
 spamscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.12.0-2009150000 definitions=main-2102160018
X-Proofpoint-Virus-Version: vendor=nai engine=6200 definitions=9896
 signatures=668683
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 bulkscore=0
 suspectscore=0 mlxscore=0
 phishscore=0 spamscore=0 adultscore=0 clxscore=1011 impostorscore=0
 priorityscore=1501 lowpriorityscore=0 malwarescore=0 mlxlogscore=999
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.12.0-2009150000
 definitions=main-2102160018
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 46299
Cc: "46299 <at> debbugs.gnu.org" <46299 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> > Good idea.  Actually frame parameters could
> > serve as a kind of "frame-local variables".

I haven't followed this thread.  Just happened
to see that comment.

Frame parameters are already, in effect,
frame-local "variables".  Just as symbol
properties are symbol-local "variables".
And text properties are char-local "variables".
And overlay properties are buffer position-local
"variables".

Nothing new about this.  At least that's how
I've always looked at it.

But perhaps you are doing something slightly
different/new, or there wouldn't be any reason
to say "could serve" - frame parameters do
serve as a kind of frame-local variables.  (We
just don't call them "variables".)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 22:11:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 17:11:15 2021
Received: from localhost ([127.0.0.1]:38860 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBm5L-00079l-EU
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 17:11:15 -0500
Received: from mail-ej1-f48.google.com ([209.85.218.48]:33925)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBm5G-00079V-A9
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 17:11:14 -0500
Received: by mail-ej1-f48.google.com with SMTP id hs11so13714952ejc.1
 for <46299 <at> debbugs.gnu.org>; Mon, 15 Feb 2021 14:11:10 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=W/8IRdKlSd6r6B++xT0xJHPZwyVQ5AScfpcXbukUKus=;
 b=iA1p01aF/zC87ImEGQcgLQJFQSpsoLFjIMa4n4IGKcOALtbrrud1ttEaCBM6NM2Qgi
 UFCF3QNtzdW6qdaHu97Do4TJVmCKbLVXRviQeVHTQqDjXqWazGedjC3sXZy6r2rJ8KIf
 CtxgMKrHcVB+0WQMXj4JTJB2Wyngq1ykSaImXRmHr/Z5B+pMiOUDiCzSxJB4mF2SVIXf
 CfLdxxNo4LN6y+231s38RDHRUSar7G0KuZBYXN/0wOY72ucCtKiptWykkqfOTFUGsrjZ
 vifovq7uaABZmHITGrQwxjwoYGb6FuAsQ3/2KZ9RlcnGfzRre0PWjdOQlAH+y92KClAa
 +MMQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=W/8IRdKlSd6r6B++xT0xJHPZwyVQ5AScfpcXbukUKus=;
 b=mqF5pJ+HMIq9TD5EfpwzWZW+alk2RncZFNwj2NJBlm8DeFdnYKugQ27Kog5TLR0Zpa
 8NbWHLYKLyXm1lvp3CiZJ5USCflsK9963msznUY8IO1i1i4RtsPA174VpY+0G0C7ub7N
 ZAif3UerHEDwspUQbt2INAU9+Sai7Ave0p6Meu2Rs+oR2q6wYXqC4KBaivAEjehGdrKx
 5XGrQzEg2HQOJ7takb3aR4HyQhDG5I974IkYCqRr8fKwJGkwp/4UCbqd5JwDBsUZJB1l
 /Mg7E64NlgdRUy44Hf464gFWvRquraOQ9valT1kCtQh1XC6IYGyPG63yOrTbtl3d1cOn
 o2tw==
X-Gm-Message-State: AOAM531cWsBxZDM1YD5ddUy5iGl5KQMshTwTo9Kdfi9U5Zc94zO66jVx
 wRWSTwvLF96mSW7pEW9xJdAniyVd9JNIgw==
X-Google-Smtp-Source: ABdhPJw1s6OtnEqKFCwBFE2dv9TmCfSLQtvYtFBg/Qt7PzMVVYoJyNthyjoG38JDacWH6WTyYDBI6Q==
X-Received: by 2002:a17:906:d19b:: with SMTP id
 c27mr17990310ejz.234.1613427064287; 
 Mon, 15 Feb 2021 14:11:04 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id v13sm11591404ede.5.2021.02.15.14.11.03
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 15 Feb 2021 14:11:03 -0800 (PST)
From: Bastian Beranek <bastian.beischer@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN> <87sg5xwskc.fsf@HIDDEN>
 <87pn11z2n6.fsf@HIDDEN>
Date: Mon, 15 Feb 2021 23:10:53 +0100
In-Reply-To: <87pn11z2n6.fsf@HIDDEN> (Juri Linkov's message of "Mon, 
 15 Feb 2021 19:01:17 +0200")
Message-ID: <878s7pdlsi.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Juri Linkov <juri@HIDDEN> writes:

> Sorry, this failed in one of the previous versions of the patch,
> but works fine in the last version of your patch pushed to master.
> So there is no problem, sorry for false alarm.
>

Good. Thanks!

> Good idea.  Actually frame parameters could serve as a kind of
> "frame-local variables".
>

Right, that would be the idea. Is there precedent for this? It seems to
be the easiest way forward, but I don't know if this is considered
acceptable. Another option would be a global alist variable that maps
frames to the value.

>> Note that I'm not yet suggesting that we do it exactly as the above,
>> this has other issues - toggling twice does leave the do-not-change
>> frame parameter in place for example, so it's not the same as doing
>> nothing.
>
> Also toggling once should handle two cases:
>
> 1. while tab-bar-lines is enabled in all frames, it should disable
>    tab-bar-lines in the specified frame;
>
> 2. while tab-bar-lines is disabled in all frames, it should enable
>    tab-bar-lines in the specified frame.

That much is clear. The only question is what should happen if
tab-bar-show is 1 initially and then toggle-frame-tab-bar is used:

- If there is more than 1 tab, the tab-bar will be shown before. Then
  toggle-frame-tab-bar should disable it.

- If there is only 1 tab, the tab-bar will not be shown before. Then
  toggle-frame-tab-bar should enable it.

But how to go back? It seems that tab-bar-show should go back to "1" (in
order to make it a real toggle, i.e. it undoes itself). However, that
means that after the second toggle-frame-tab-bar the tab-bar will either
be shown or not, depending on the number of tabs opened at that specific
time. We have to consider that the user created or closed tabs in
between, so that means that there will be situations in which
toggle-frame-tab-bar does not really seem to do anything... For example:

- 1 tab (tab bar hidden)
- create tab -> 2 tabs (tab bar shown)
- toggle-frame-tab-bar (tab bar hidden)
- close tab (tab bar hidden)
- toggle-frame-tab-bar (tab bar still hidden, because only 1 tab)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 17:07:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 12:07:39 2021
Received: from localhost ([127.0.0.1]:38620 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBhLX-0005rU-9h
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 12:07:39 -0500
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:35919)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lBhLV-0005rG-Al
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 12:07:38 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay5-d.mail.gandi.net (Postfix) with ESMTPSA id A6AE81C000B;
 Mon, 15 Feb 2021 17:07:28 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN> <87sg5xwskc.fsf@HIDDEN>
Date: Mon, 15 Feb 2021 19:01:17 +0200
In-Reply-To: <87sg5xwskc.fsf@HIDDEN> (Bastian Beranek's message of "Mon, 15
 Feb 2021 11:09:39 +0100")
Message-ID: <87pn11z2n6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> Before your patch, I did nothing with the enabled tab-bar,
>> but now it disables the tab-bar, and doesn't enable it again later,
>> because tab-bar-show is let-bound to nil.
>
> Could you please describe the desired behavior of tab-switcher in a few
> more words? I can't see anything wrong with it if I try it out here,

Sorry, this failed in one of the previous versions of the patch,
but works fine in the last version of your patch pushed to master.
So there is no problem, sorry for false alarm.

> although I can sort of see what you're getting at: While the
> tab-swicher is active there should be no tab bar, and it should return
> when it is finished?

Maybe this could provide a nice visual effect, but the problem
is that it's not easy to detect the moment when it is finished.

I often use tab-switcher to create a new tab, and sometimes instead
of selecting an existing tab from the tab list, I change the mind
and switch to another buffer in the same new tab.

> What I see is that the tab-bar just stays on all the time, with a
> temporary tab for the tab-switcher itself. I have tab-bar-show
> customized to "1" here.

This is fine.

> Side question: Why does tab-switcher need to create a tab for its
> purpose? Doesn't it make more sense to use a regular buffer for that?

This is to emulate window switching feature that exists on most window managers:
all windows are unselected when the window switcher is activated.

>> A good solution would be to add a new choice value to tab-bar-show.
>> Something like 'do-not-change-tab-bar-lines', but shorter.
>> Then when let-bound, it should do nothing with the tab-bar-lines.
>
> Wouldn't it make more sense to have a different variable for that?
> Because tab-bar-show is a defcustom and we wouldn't want to expose this
> special value to users, right?

Exposing such value to users is fine, but anyway it seems there is
no need to add a new value or variable.

>> Also this is related to another problem:
>> What if the user wants to manually enable the tab bar on one frame only
>> without enabling tab-bar-mode?  Currently it's possible with
>>
>>   (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)
>>
>> But tab-bar--update-tab-bar-lines will disable it sooner or later.
>> Customizing to the same value like 'do-not-change-tab-bar-lines'
>> will solve this problem as well.
>
> That's true. I can see how tab-bar--update-tab-bar-lines can interfere
> with toggle-frame-tab-bar.
>
> But I think we would need a frame dependent variable to fix this. We
> can't use a global single variable, because toggle-frame-tab-bar is not
> supposed to change the behavior of tabs on other frames. I have to think
> about a good solution for a bit longer. Is attaching a new parameter to
> frames similiar to this a possibility?

Good idea.  Actually frame parameters could serve as a kind of
"frame-local variables".

> Note that I'm not yet suggesting that we do it exactly as the above,
> this has other issues - toggling twice does leave the do-not-change
> frame parameter in place for example, so it's not the same as doing
> nothing.

Also toggling once should handle two cases:

1. while tab-bar-lines is enabled in all frames, it should disable
   tab-bar-lines in the specified frame;

2. while tab-bar-lines is disabled in all frames, it should enable
   tab-bar-lines in the specified frame.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 15:53:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 10:53:34 2021
Received: from localhost ([127.0.0.1]:38555 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBgBp-00040r-OM
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 10:53:33 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54036)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lBgBo-00040f-6b
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 10:53:32 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59669)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lBgBg-00084s-O7; Mon, 15 Feb 2021 10:53:25 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2512
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lBgBf-0006dh-Hd; Mon, 15 Feb 2021 10:53:24 -0500
Date: Mon, 15 Feb 2021 17:53:26 +0200
Message-Id: <83mtw59vk9.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
In-Reply-To: <CAK9AuB9rFpfQoRjM-TN6h8AJbDbKddAPr4p9T7ncjrPxtfZ4zQ@HIDDEN>
 (message from Bastian Beranek on Mon, 15 Feb 2021 16:32:24 +0100)
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
References: <871rdv4xog.fsf@HIDDEN> <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
 <871rdjrbcf.fsf@HIDDEN> <87pn12mrsb.fsf@HIDDEN>
 <83r1lh9wta.fsf@HIDDEN>
 <CAK9AuB9rFpfQoRjM-TN6h8AJbDbKddAPr4p9T7ncjrPxtfZ4zQ@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Bastian Beranek <bastian.beischer@HIDDEN>
> Date: Mon, 15 Feb 2021 16:32:24 +0100
> Cc: Juri Linkov <juri@HIDDEN>, 46299 <at> debbugs.gnu.org
> 
> > >   (set-frame-parameter nil 'tab-bar-lines 0)
> > >   (set-frame-parameter nil 'tab-bar-lines 1)
> > >   (set-frame-parameter nil 'tab-bar-lines 0)
> > >
> > > that breaks the menu bar.
> >
> > It doesn't break the menu bar here.  What kind of breakage are we
> > talking about, and in what Emacs configuration?
> 
> For this to trigger you need to put those lines in a .el file (say
> foo.el) and run emacs in text mode and load that file:
> 
> emacs -nw -Q -l foo.el
> 
> For me there is no menu-bar anymore and using this emacs instance
> quickly reveals visual glitches (mode line jumping around for
> example). A good way to provoke this is to create a few tabs with C-x
> t 2.

I see the problem on GNU/Linux, but not on MS-Windows.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 15:32:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 10:32:48 2021
Received: from localhost ([127.0.0.1]:38519 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBfrk-0003V2-3H
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 10:32:48 -0500
Received: from mail-qv1-f47.google.com ([209.85.219.47]:45120)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBfri-0003Un-Rl
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 10:32:47 -0500
Received: by mail-qv1-f47.google.com with SMTP id p6so3271408qvm.12
 for <46299 <at> debbugs.gnu.org>; Mon, 15 Feb 2021 07:32:46 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=Ao1YQojQ7nKjNSGm+iDGUQG7gY+FvzhWQ2dNetbkKNI=;
 b=L118Hl0tcY61/s4y/xRTu6K7yUyCaFM2nG8BgVV6C1jdNu+g3ieYA75mn6qtMgcAVS
 wlgS6I1DMNup6oUfjmZv0aAYmYjgaG8IkGLks7bXBNtHYx8QvF7Gr/DpkZnAhBCA0vlK
 Ax2hYNg5dQZK/Og3BA/VWSCi2pmRcSP4+2qMLIMqjDN6fu4CezgRnjmMlgWIC8k3Ga54
 gbEpXOjxtXAxSTb1Mkphc+MUA2blSR9g0IADeyKWHKJa6I/cQqwXpuR2Yw+MSr9PbxAj
 qiPglOjt9wHnyTTB0iMcX6tCQb6bvA9ACkBCqQ8polR87Qso2tbbFO9FkI9zPOpZPGF6
 J2jQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=Ao1YQojQ7nKjNSGm+iDGUQG7gY+FvzhWQ2dNetbkKNI=;
 b=nPHuQCkD9mYV8x/WuaHY9E16Vd6hEwN10Ebloj7CGRDfgP3p4Jvu7y0bgPDrNJO60s
 0x/kVdKtqaZVugcf7SjPiDJYOY9YP4Hf+MNgirN0s9KjMCZmxniPNLSs3tbidT65j1Mm
 R7DE6Uf1fXWJTFGOwgfoMppWMwWrfVThJXbc4J+AU/u1nWs+Dca8+iX5+wEp159ZRvpd
 szpoWKZb+hZK/ChS9OQDd1nrZOuzIG8v2/lbREU0aEK9bnBEFWiXr3bfPi1RoGQpOo6a
 JXkMzIzG8OoySuRTQUeKaTm4aayD9uhrnxxAE7HUv4nf+w40YP7A5q8J+gcw01wLztHD
 lw9w==
X-Gm-Message-State: AOAM531sQLVS1DoWJlWMOHTCjE+K9AaS+ZvuDyoaalK8HB1jzV1FgDiW
 hDUXT42TUk9Vx3VroEwaNYZSJQQXEXd0/PN4TdsaXBdwzPt31g==
X-Google-Smtp-Source: ABdhPJzv2azwp5OUa/sv+UpcqvEDvyIKRBt3+eb1NSYj/DoFcS14alD6pOSsIccqv4JZFJvkvUUk2728e2UL4kdkNWE=
X-Received: by 2002:a0c:da8b:: with SMTP id z11mr15251029qvj.0.1613403160998; 
 Mon, 15 Feb 2021 07:32:40 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
 <871rdjrbcf.fsf@HIDDEN> <87pn12mrsb.fsf@HIDDEN>
 <83r1lh9wta.fsf@HIDDEN>
In-Reply-To: <83r1lh9wta.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Mon, 15 Feb 2021 16:32:24 +0100
Message-ID: <CAK9AuB9rFpfQoRjM-TN6h8AJbDbKddAPr4p9T7ncjrPxtfZ4zQ@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Mon, Feb 15, 2021 at 4:26 PM Eli Zaretskii <eliz@HIDDEN> wrote:
>
> > From: Juri Linkov <juri@HIDDEN>
> > Date: Sun, 14 Feb 2021 20:44:20 +0200
> > Cc: 46299 <at> debbugs.gnu.org
> >
> > More low-level test case:
> >
> >   (set-frame-parameter nil 'tab-bar-lines 0)
> >   (set-frame-parameter nil 'tab-bar-lines 1)
> >   (set-frame-parameter nil 'tab-bar-lines 0)
> >
> > that breaks the menu bar.
>
> It doesn't break the menu bar here.  What kind of breakage are we
> talking about, and in what Emacs configuration?

For this to trigger you need to put those lines in a .el file (say
foo.el) and run emacs in text mode and load that file:

emacs -nw -Q -l foo.el

For me there is no menu-bar anymore and using this emacs instance
quickly reveals visual glitches (mode line jumping around for
example). A good way to provoke this is to create a few tabs with C-x
t 2.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 15:26:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 10:26:29 2021
Received: from localhost ([127.0.0.1]:38513 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBfld-0003K4-B1
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 10:26:29 -0500
Received: from eggs.gnu.org ([209.51.188.92]:43560)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lBflb-0003Js-3a
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 10:26:28 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59108)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lBflV-0002vL-Aa; Mon, 15 Feb 2021 10:26:21 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4827
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lBflU-00014r-Fw; Mon, 15 Feb 2021 10:26:21 -0500
Date: Mon, 15 Feb 2021 17:26:25 +0200
Message-Id: <83r1lh9wta.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-Reply-To: <87pn12mrsb.fsf@HIDDEN> (message from Juri Linkov on
 Sun, 14 Feb 2021 20:44:20 +0200)
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
References: <871rdv4xog.fsf@HIDDEN> <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
 <871rdjrbcf.fsf@HIDDEN> <87pn12mrsb.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, bastian.beischer@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Juri Linkov <juri@HIDDEN>
> Date: Sun, 14 Feb 2021 20:44:20 +0200
> Cc: 46299 <at> debbugs.gnu.org
> 
> More low-level test case:
> 
>   (set-frame-parameter nil 'tab-bar-lines 0)
>   (set-frame-parameter nil 'tab-bar-lines 1)
>   (set-frame-parameter nil 'tab-bar-lines 0)
> 
> that breaks the menu bar.

It doesn't break the menu bar here.  What kind of breakage are we
talking about, and in what Emacs configuration?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 10:12:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 05:12:36 2021
Received: from localhost ([127.0.0.1]:37331 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBars-0001Jm-DX
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:12:36 -0500
Received: from mail-wr1-f45.google.com ([209.85.221.45]:36890)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBarq-0001JW-M8
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:12:35 -0500
Received: by mail-wr1-f45.google.com with SMTP id v15so8181675wrx.4
 for <46299 <at> debbugs.gnu.org>; Mon, 15 Feb 2021 02:12:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=/JZxUfzy4WXMt5fgc6C6HTb6FWnC1GVSlOkMHaZ0RkA=;
 b=o00kZb4SIkwGZiEhT10PXKKAdemjMOAsdo/5rpPgP5R2bp+GuJBq6jXRFLe6gFgm/t
 YYY7fG7Mc77fGmP7ikuJNpq+7Tjy4x6aL4lLxWi/RoK6n+Wnrppt6oOvpAezPtFvD/p/
 jZAJ0fyFhH3hqormJfonXqRK9fjVNQ8Uf7IJwJ3WqyZAy2yYVsGmrOoCzIli6U8MEzbE
 XOloXGMr6Jphq4KRVTfolKsvfLCG0VU48PUCKU37Zy202+PyY13+0YUL4lGgcmZFiw88
 sub57zhBRM8ibVV134cf1XLJguZVh/1FRDH6oDSbc4kobqGtzGUT8ifYBagFaQQKfWKe
 rd9w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=/JZxUfzy4WXMt5fgc6C6HTb6FWnC1GVSlOkMHaZ0RkA=;
 b=Ij2RmFzAgXv3eQ6Wzj21AlT/Ysp0FzJb7fyVBWTy6qKFr5m65NyMeYTq6+yzd8fE7D
 2puTHjcHOaWbLtSBI2FQmK8Vmz1pwCpqqdAGP9CkyBvHzbnqWLCPx/1WXvaWLmI58KCQ
 w4ZN0vUvxnJ7c6VDdFRM3JAN8QKaZ+PlTf1IGKcpnXrW/ZeXJ9q/eooVkaWvCIsmm5Xi
 HRG143i5yoROb0X3uLTE/LvRhg69wZuDYWU88T5astc92CR7LYT6Zqm2pEyD6/ji5cRG
 MfHGjnbWHpbk1YuyU8rIV+TPkrxzhIHAj3iHMn2xxthJUP0dRsRS7YndFqQV6StNvHnd
 r6ug==
X-Gm-Message-State: AOAM5324OStYqPLh0hX6cTHZeX6J9vjcRwgR8LqvDNewoIZG4upvZP1+
 j1kG/BzxOVj1xXrMmDtjTa1I0llsDsz5HQ==
X-Google-Smtp-Source: ABdhPJxIh1giLDQwpIhGMUrk+ySZIq2JfRG0T9EYCRaUZWzJkwsUIV9MajinywhLyodZ5Dr8PjzKEA==
X-Received: by 2002:adf:df88:: with SMTP id z8mr18007438wrl.39.1613383948683; 
 Mon, 15 Feb 2021 02:12:28 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id p16sm26730271wmj.3.2021.02.15.02.12.27
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 15 Feb 2021 02:12:28 -0800 (PST)
From: Bastian Beranek <bastian.beischer@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
References: <871rdv4xog.fsf@HIDDEN> <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN>
 <c7481c5c-d55d-b135-087f-f8ff3cdb2e4b@HIDDEN>
Date: Mon, 15 Feb 2021 11:12:27 +0100
In-Reply-To: <c7481c5c-d55d-b135-087f-f8ff3cdb2e4b@HIDDEN> (martin rudalics's
 message of "Mon, 15 Feb 2021 09:16:40 +0100")
Message-ID: <87pn11wsfo.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

>> What if the user wants to manually enable the tab bar on one frame only
>> without enabling tab-bar-mode?  Currently it's possible with
>>
>>    (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)
>
> As a rule, this should be done by setting the 'tab-bar-lines' parameter
> of that frame to non-zero, leaving it at zero for all other frames.
>
> 'toggle-frame-tab-bar' should stick to that rule.
>
> martin

This is the case. But the problem is that there is now a new function
which restores the value of tab-bar-lines to its original value,
whenever tabs are created or closed, or whenever tab-bar-mode is
switched off and on, for example.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 10:09:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 05:09:49 2021
Received: from localhost ([127.0.0.1]:37304 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBapA-0001EZ-Os
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:09:49 -0500
Received: from mail-wr1-f46.google.com ([209.85.221.46]:34614)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBap8-0001EN-Sg
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:09:47 -0500
Received: by mail-wr1-f46.google.com with SMTP id n4so5188238wrx.1
 for <46299 <at> debbugs.gnu.org>; Mon, 15 Feb 2021 02:09:46 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=ol/LgpEwxLvYQHG9qaTesHzL4Por1GpocitwuIVOAr8=;
 b=SnhDcQ/A9uMYG38IIXmmvamuMVe+c+H+Pcn8o5QXtMYnXiJr9Ykl5TVA0B38QAlzIN
 mjTwt2Fzp4TKGlT/8PplhloszP/rLGiG8iqccPdYsnOtktNUtJLC6+C53/fjOR027c83
 ek8yjKVpVNBx560qqAl/F353541JZdnHTPYURSSTjZ320ORA9LheC4/k51bp60KVUBEU
 Ca9E3wwl8qmXvT4hu50AX2POtCrxRWF27yNmlJ2MzpbIeDBD5lbbhIa61qccEjlb+5Yd
 zobGIoRQChIkBBOP7PMPbTlvvG0G75PC2E9TaDwscSojB1XPHOkXQ4PN7llp0BBfWZcy
 6E1Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=ol/LgpEwxLvYQHG9qaTesHzL4Por1GpocitwuIVOAr8=;
 b=be59Q3ritttHJtSfUThLr3hZoY0R9d1q2Aj7QaggMrXZQEgcUvb3+rQpoBiFK/bVn5
 nO0rKIrn6EwLXgEzF+qwU12WjHyUy6O9czeO0NB/0H6WAnvVqwvyOl+cFoWloYcTsGQG
 S/3yvrg4CXomG7D66CRgCe7Tw+hXQuSiAxqspy6OgeqG6CUMQJWGyE6wejHD75lUcv0p
 /MgLGz6zeseB0rXbAFc1zdngpsB7rDBu09nilLibruepQYCb1NcudcCvV+P/zHkQT0O6
 MPXZN7g64sXNwLJ8v2zygiUiCW+AfjIo7jzs0fE+OvlN0Zf3bWFGYjmsSp1OhAkInqzU
 THiw==
X-Gm-Message-State: AOAM532enHhE7sJIwZaJ3L9Gg11OE0iy8cPofqoXWz7/+F625CMo+peB
 Qdk4vNYlLT+f2Qys0LfdCemJywSLjfZyvQ==
X-Google-Smtp-Source: ABdhPJztH6ej0KWJgt6eeWqPrlceVKmxz/oBXi5JxrQYSm3jhbyZyuGUQVFfBHl70ojrJApVyiNHyA==
X-Received: by 2002:a5d:6404:: with SMTP id z4mr17875112wru.103.1613383780924; 
 Mon, 15 Feb 2021 02:09:40 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id v5sm217279wmh.2.2021.02.15.02.09.39
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 15 Feb 2021 02:09:40 -0800 (PST)
From: Bastian Beranek <bastian.beischer@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
References: <871rdv4xog.fsf@HIDDEN> <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN>
Date: Mon, 15 Feb 2021 11:09:39 +0100
In-Reply-To: <87im6ulbzz.fsf@HIDDEN> (Juri Linkov's message of "Sun, 
 14 Feb 2021 20:50:40 +0200")
Message-ID: <87sg5xwskc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Juri Linkov <juri@HIDDEN> writes:

> Thanks, now your patch is pushed to master.

Thanks!

>
> While using it, I noticed a new problem.
> There is this code in 'tab-switcher':
>
>     (let ((tab-bar-new-tab-choice t)
>           ;; Don't enable tab-bar-mode if it's disabled
>           (tab-bar-show nil))
>       (tab-bar-new-tab))
>
> Before your patch, I did nothing with the enabled tab-bar,
> but now it disables the tab-bar, and doesn't enable it again later,
> because tab-bar-show is let-bound to nil.
>

Could you please describe the desired behavior of tab-switcher in a few
more words? I can't see anything wrong with it if I try it out here,
although I can sort of see what you're getting at: While the
tab-swicher is active there should be no tab bar, and it should return
when it is finished?

What I see is that the tab-bar just stays on all the time, with a
temporary tab for the tab-switcher itself. I have tab-bar-show
customized to "1" here.

Side question: Why does tab-switcher need to create a tab for its
purpose? Doesn't it make more sense to use a regular buffer for that?

> A good solution would be to add a new choice value to tab-bar-show.
> Something like 'do-not-change-tab-bar-lines', but shorter.
> Then when let-bound, it should do nothing with the tab-bar-lines.

Wouldn't it make more sense to have a different variable for that?
Because tab-bar-show is a defcustom and we wouldn't want to expose this
special value to users, right?

>
> Also this is related to another problem:
> What if the user wants to manually enable the tab bar on one frame only
> without enabling tab-bar-mode?  Currently it's possible with
>
>   (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)
>
> But tab-bar--update-tab-bar-lines will disable it sooner or later.
> Customizing to the same value like 'do-not-change-tab-bar-lines'
> will solve this problem as well.

That's true. I can see how tab-bar--update-tab-bar-lines can interfere
with toggle-frame-tab-bar.

But I think we would need a frame dependent variable to fix this. We
can't use a global single variable, because toggle-frame-tab-bar is not
supposed to change the behavior of tabs on other frames. I have to think
about a good solution for a bit longer. Is attaching a new parameter to
frames similiar to this a possibility?

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 4e47ae2c10..cbda0c032b 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -161,7 +161,8 @@ tab-bar--update-tab-bar-lines
                          (t frames))))
     ;; Loop over all frames and update default-frame-alist
     (dolist (frame frame-lst)
-      (set-frame-parameter frame 'tab-bar-lines (tab-bar--tab-bar-lines-for-frame frame))))
+      (unless (frame-parameter frame 'tab-bar-lines-do-not-change)
+        (set-frame-parameter frame 'tab-bar-lines (tab-bar--tab-bar-lines-for-frame frame)))))
   (when (eq frames t)
     (setq default-frame-alist
           (cons (cons 'tab-bar-lines (if (and tab-bar-mode (eq tab-bar-show t)) 1 0))
@@ -233,7 +234,8 @@ toggle-frame-tab-bar
   (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)"
   (interactive)
   (set-frame-parameter frame 'tab-bar-lines
-                       (if (> (frame-parameter frame 'tab-bar-lines) 0) 0 1)))
+                       (if (> (frame-parameter frame 'tab-bar-lines) 0) 0 1))
+  (set-frame-parameter frame 'tab-bar-lines-do-not-change t))
 
 (defvar tab-bar-map (make-sparse-keymap)
   "Keymap for the tab bar.

Note that I'm not yet suggesting that we do it exactly as the above,
this has other issues - toggling twice does leave the do-not-change
frame parameter in place for example, so it's not the same as doing
nothing.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 10:08:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 05:08:19 2021
Received: from localhost ([127.0.0.1]:37300 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBanj-0001CT-Fr
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:08:19 -0500
Received: from mout.gmx.net ([212.227.15.18]:41223)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lBanh-0001C7-M8
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:08:18 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1613383690;
 bh=Z5YJ7TCRX7VKUu6rNtwg1HjJz5Vsw79XwiRiGk8PoH4=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=a1Yps33ffGhLNrxHt2RMqdMHCHu7iczYXE8v+VVaOt+z6Yxz9daHyzCN7KXnzHgU7
 vrhuR4u2uXnFWHdZMixhTPsKvzW/+qdf7g81Q4wN6P3UbuE11S0BGryIaBLQa/cJkW
 Z0yxrbIw1A7+qlJEIKkU4/YkMQBOY9COhtfT+vEk=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.110]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1N33Ed-1lsrjD3N6r-013LFR; Mon, 15
 Feb 2021 11:08:10 +0100
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
To: Juri Linkov <juri@HIDDEN>
References: <871rdv4xog.fsf@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN>
 <c7481c5c-d55d-b135-087f-f8ff3cdb2e4b@HIDDEN>
 <87ft1x1yxy.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <389754a7-bdbc-ae32-555f-7cd7e588fcba@HIDDEN>
Date: Mon, 15 Feb 2021 11:08:10 +0100
MIME-Version: 1.0
In-Reply-To: <87ft1x1yxy.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:YXgB+ZOKTmG6Obh5zR3rgWfqZCIysRHym01Ka0pu2z6qRk1uHO9
 AAuMf5SGjFSDdmjzXPo4zTqX07tDRr+VO4O7Qqydd9717Q+JItMgQjd1FEFtI0IShYlUYAO
 kqHunbwGLLsbWjjJbULRbizBo1044T+MwWNbP1+7fOYD1LJu68m+gORHnUBp9tcPmRPEdkN
 Jh5A+mUWzmpmFSv9Z8NnA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:y1zWooGKEv8=:3UfzZZxQeWRsqO+iiueiYF
 MBw0hyBWap4ubGZREx1X9FzM/tGWEWFsFeNDpcugodFDjQk63ZDQMNzlx2ZrVhakBcHOFAsjl
 8pVgHPoc4qvTUyyo6A/Kl09H/jx2OEw5VsafcaKhDsAUTFb961nxLlJCVD/LjPabwSdL7/aZT
 +U1iDe0UZ5uqdieFAQmtdjxVXAj9DWKs5JkKiZnrNbjeOYetL9OCvoY03k8T0y+RQuMdgqftA
 HTuNdAEYOtze+ZQDJPVo9C9E2rtMTsM0JTCwOhFpQ3eZs2m2+Kzz379dY6WYgzmaPc3PJOVql
 x8mvT6oRgJ33t8Gzwv2M3f0B3DOrgQqD9SHTXANqvpXVP47fnc6gpqOtb2iwZP3gycT7pVpfy
 8t3gsq/2peK3ezuUzwEAur9j1Erb0U0rbqjUE6ma//9w+rElKFYTdM4e3r8BAVqxK5ZMKr3K0
 RHTVy0LMibLcMy1VdVjI9hIHg5lgoJVLxdefQcEf5pwtte+xBXoxl868l3VgEQqrq5BmA5eGT
 zTjWyoNCqtIsYXxoZGgIXk7nLk/hy1bA+1TrGluzIo0L6qd8BWPAtVdXzX8EXvNqehFGQOJ4r
 KesrWYndEA1SkI2geKyoIiiyTfJDAy/o4qiN44miTUgA26t9CuUCdLf9twpWszyEWn3QO3Yaj
 vbBr+35dNaHUIiwybkIZaFj6o27x0sHwBgNB/4sVq3DRkylHeC/84Otf783c9EDsfvkf5vMW/
 Qy+7Qd9GwgUjTFa63uL4FAlwyquLXw4I8ymBdYbI+V9o+y/tCv86AcKkl/BLXf+hifbOKzsyv
 RdWi+vKquOOHzwKaKm3H7OKCNmCQBvrqjo0Jopicb+hvSAy8iktjxxa50sFwq3kbGED4EyojE
 K3f77sl7N0dM2jD85AFA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Bastian Beranek <bastian.beischer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > 'toggle-frame-tab-bar' already does exactly this - sets the
 > 'tab-bar-lines' parameter to non-zero, and doesn't change it
 > on all other frames.
 >
 > But currently 'tab-bar-show' overrides this user setting,
 > and affects all other frames.

I forgot.  This is inherently broken for all frame parameters and
unlikely to change ever.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 10:06:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 05:06:12 2021
Received: from localhost ([127.0.0.1]:37293 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBalf-00018y-P0
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:06:12 -0500
Received: from mail-wm1-f52.google.com ([209.85.128.52]:36244)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBalc-00018d-L9
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 05:06:09 -0500
Received: by mail-wm1-f52.google.com with SMTP id h67so3931553wmh.1
 for <46299 <at> debbugs.gnu.org>; Mon, 15 Feb 2021 02:06:08 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=U6zxqUtMSMSNVjAwnrPms7Hvu5BGQJsA1Sj/72LKruY=;
 b=beiCWAeFM0tvXFDVBArGnEgVfljdwWc2l1+GDvQUYfa4rZFhiFfryWYhJul8++QouH
 f0SLEItqaIzwevMdxQf8W76I2msNQKaVTsDBZrfOuDv+91CMvJtE7eN5XRx9i5CusqhA
 002JTHa1WuTeNKWiFkSLCy+1r6cNNIkgI8/eJESI4Yy0n3t98ZKpbkyHWk65IUUP9Pm1
 jZHsbtpaA1iUiHzdamXKRf9i57YLOyX4Div+zyseeexPiZpPskp04OoJsXhjuNq4iFk3
 KO+06ZW6bzewnX9tsmcpQY38t3o0fYAmPf33fDB8if7j7DJ//tMTGARcNNhBmE5P/7Ra
 AMiw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=U6zxqUtMSMSNVjAwnrPms7Hvu5BGQJsA1Sj/72LKruY=;
 b=D8Chc/xKVjYbzZ33it4fayQ9yIzhjmWy6R2yC0lj5hvLU0MxPGV5sp+HAeTV2zjG6T
 MCtMv/SjT+ocrDY7Ug0SYWWWvWi3XwwC6R2VjT11DsF/PYA9GEQo3s+IJRefTA9Ptvn6
 hBHLh1jsYYUEbqeiDREud/ftHPFzWeibzWXnxdp6/rsVC+Ultn63YzDA8L1r/tCqTVDN
 8OGkXzPWuLN1XaVqTNQa5lrplLwtRcsAIHXg+G5E/52rD4//+gCGRHZEQYBjkkftDrbD
 oaQ5h+TkFPBkHC7l6LjjC98ZDhb7QJjsAhPMPSOfcj9qUyMFc3X93vEoCuyYZ6jxQQjP
 CmGQ==
X-Gm-Message-State: AOAM531Imue4O2MXLaXtCpMcvv/IK+8hz37UN6rczSgxgPkklXAzvl8x
 EefdILZ6hSg5LkTlce/ohyPByU6M9QUodw==
X-Google-Smtp-Source: ABdhPJx4QD9tkSxEmYa0lTJ+skVciKn6d9BMLYUOLCZPOGRZ3Z/Th0MXxAln3sWa7T9Xdu6BpQd+nA==
X-Received: by 2002:a1c:113:: with SMTP id 19mr13651044wmb.7.1613383562490;
 Mon, 15 Feb 2021 02:06:02 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id f7sm23452343wrm.92.2021.02.15.02.06.01
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 15 Feb 2021 02:06:02 -0800 (PST)
From: Bastian Beranek <bastian.beischer@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
 <871rdjrbcf.fsf@HIDDEN> <87pn12mrsb.fsf@HIDDEN>
Date: Mon, 15 Feb 2021 11:05:41 +0100
In-Reply-To: <87pn12mrsb.fsf@HIDDEN> (Juri Linkov's message of "Sun, 
 14 Feb 2021 20:44:20 +0200")
Message-ID: <87tuqdwsqy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Juri Linkov <juri@HIDDEN> writes:

>>> But how would that cause visual glitches, such as the tab bar
>>> splitting into two lines, menu bar not showing and general visual
>>> issues (lines jumping around etc.). This worries me a bit, because I
>>> don't understand the problem (just worked around it by not running the
>>> (tab-bar-mode -1) (tab-bar-mode 1) sequence. Did you try the recipe I
>>> reported above?
>>
>> Yes, I see the same.  A simpler test case is:
>>
>>   (tab-bar-mode -1)
>>   (tab-bar-mode 1)
>>   (tab-bar-mode -1)
>
> More low-level test case:
>
>   (set-frame-parameter nil 'tab-bar-lines 0)
>   (set-frame-parameter nil 'tab-bar-lines 1)
>   (set-frame-parameter nil 'tab-bar-lines 0)
>
> that breaks the menu bar.  I don't know if this is a bug in display code,
> or it's required to use 'redisplay' in-between.

Interesting. Should this be reported as a separate bug?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 09:50:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 04:50:35 2021
Received: from localhost ([127.0.0.1]:37273 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBaWZ-0000ld-0f
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 04:50:35 -0500
Received: from relay10.mail.gandi.net ([217.70.178.230]:55633)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lBaWX-0000lN-00
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 04:50:33 -0500
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay10.mail.gandi.net (Postfix) with ESMTPSA id C94B124000D;
 Mon, 15 Feb 2021 09:50:24 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN>
 <c7481c5c-d55d-b135-087f-f8ff3cdb2e4b@HIDDEN>
Date: Mon, 15 Feb 2021 11:07:37 +0200
In-Reply-To: <c7481c5c-d55d-b135-087f-f8ff3cdb2e4b@HIDDEN> (martin rudalics's
 message of "Mon, 15 Feb 2021 09:16:40 +0100")
Message-ID: <87ft1x1yxy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Bastian Beranek <bastian.beischer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> What if the user wants to manually enable the tab bar on one frame only
>> without enabling tab-bar-mode?  Currently it's possible with
>>
>>    (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)
>
> As a rule, this should be done by setting the 'tab-bar-lines' parameter
> of that frame to non-zero, leaving it at zero for all other frames.
>
> 'toggle-frame-tab-bar' should stick to that rule.

'toggle-frame-tab-bar' already does exactly this - sets the
'tab-bar-lines' parameter to non-zero, and doesn't change it
on all other frames.

But currently 'tab-bar-show' overrides this user setting,
and affects all other frames.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 15 Feb 2021 08:16:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 15 03:16:50 2021
Received: from localhost ([127.0.0.1]:37217 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBZ3p-0006ji-Sx
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2021 03:16:50 -0500
Received: from mout.gmx.net ([212.227.17.20]:53269)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lBZ3o-0006jT-EE
 for 46299 <at> debbugs.gnu.org; Mon, 15 Feb 2021 03:16:48 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1613377001;
 bh=1qdkcLaclmtUpvWnrunm8iYYnpiRCNhjl5u1f/hb9SI=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=K9KUsG4AIBNw7zIlzX/kOw6Fl0ISE5bkUs3DNeTbFQO9nS0mYclZY+OzLpKU29fLO
 ZqDC3ofVQd9E+wW3mQQ7JiNP2oYCniFxSRDD/WhXnacqta7dyOYNgcpEw7GVeWnhAx
 qJjdZp7vd2/10hqCDQ3YV36WOkoARcmbTlyRCvLk=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.110]) by mail.gmx.net (mrgmx105
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1McY8T-1lk3nQ2N9J-00cyWy; Mon, 15
 Feb 2021 09:16:41 +0100
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
To: Juri Linkov <juri@HIDDEN>, Bastian Beranek <bastian.beischer@HIDDEN>
References: <871rdv4xog.fsf@HIDDEN> <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <c7481c5c-d55d-b135-087f-f8ff3cdb2e4b@HIDDEN>
Date: Mon, 15 Feb 2021 09:16:40 +0100
MIME-Version: 1.0
In-Reply-To: <87im6ulbzz.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:haGiWAlFJFrH+OYn9Ffa4xNBoVWntDw84odB0WzpiEddRiMG0Qc
 AbXxjlD5Co5IUdzuz9juksJ0OPdvnBUJOYZuxA4iFI7I8RiOwvHST0PK61+WwUU0W0hS4N/
 sr2gRw0A8DDg3g2Ojwb8QT9yZZkgV/IVivn3EzobsQ8wqQ7/QW+VRDt+mAlfa/bWcZ0FqKc
 wvGXkTwVzJ7aYlXSSRtHw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:u/IDHA7LixA=:OKrtYqOAclF0ow/wP5FVwA
 cvsCwGR2Lro2Ho2+DA5NF5nchblIMqSm7cUSLzfjRgx7ab1pJcy7cBR1HP87MeVDna26LnDee
 Yd9SIVXZ4xL7hCf4zYqIRF2FYW30WwbzM0U4pNZALQZjRPcacKu27Q2PqGRHzroHI1bkE6u6t
 nnh9vcaLH0JCtOV2mSUhp63fjlstYFgTNRPCWUxY3FiErjcmYGZ2MV1ZyzHTM42/tzPBu3MUI
 CX0GJGqVBfQFOqiKOYtwrJYj7bRklOId9GJ3l4Pa041Mw3+ca8kNxjjKiUqMkiYZLAHtinM3i
 VFyw3uQcWbW7pEhCcEDjfjUc1VDxQm8i1/PeNi1Q4rEJp2mcK/BseV0UTSCi8qHNLGlmMZylZ
 u0YcvfEXCm2zVFHrVSQ8qZlLobg9rppVrPGEDwKiFfQ6kJsbbGtY5q1TKhwl00f1UDPpX6v85
 FPYB1ges4+Sj+uASlnitnYzoxufXQalKpdbqFE1JKqLXRC54X1riuvmNQBNBRVz6In1DSMHuH
 4gOhEjYsZ+0EWMrKz7Vfvw+TjktRTF2wqIki/if+zJSMOsHn7MjkRXQL7fPV/48OEF1Y336V1
 c3Xrzd3FlNUXmF5QF0p9utMylMOwA5uPIW4nolX+NxiQPMJgtNqoqAInMzdlMW34aRXTwI2t2
 ypb2qsnHunIJO+RT76ISnNPIN5RpW8ODVCueKrmklV3eakVMFyusW+6HO0lyur2JSDgOlbWd9
 achx1Pp3lzjrXMHoL/tQ8wrW2OYLY88yEGCdmvIV5MlTbHg0NnQJ6z9kwT8LCMrqIrqyN8/zc
 42+Xs9NVnWLuBW/8JCw6ujuFK2JfpG0xX2LXiwBkCuicZmTBfR2THPgHJwt4puCPLZqMiwTRg
 Fn8gECmK+N7Uhe+iOTJQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > What if the user wants to manually enable the tab bar on one frame only
 > without enabling tab-bar-mode?  Currently it's possible with
 >
 >    (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)

As a rule, this should be done by setting the 'tab-bar-lines' parameter
of that frame to non-zero, leaving it at zero for all other frames.

'toggle-frame-tab-bar' should stick to that rule.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 14 Feb 2021 20:10:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 15:10:53 2021
Received: from localhost ([127.0.0.1]:36811 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBNjI-0005o5-Qy
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 15:10:53 -0500
Received: from relay12.mail.gandi.net ([217.70.178.232]:42421)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lBNjG-0005np-Ri
 for 46299 <at> debbugs.gnu.org; Sun, 14 Feb 2021 15:10:51 -0500
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay12.mail.gandi.net (Postfix) with ESMTPSA id 66353200002;
 Sun, 14 Feb 2021 20:10:42 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 <87im6ulbzz.fsf@HIDDEN>
Date: Sun, 14 Feb 2021 21:28:43 +0200
In-Reply-To: <87im6ulbzz.fsf@HIDDEN> (Juri Linkov's message of "Sun, 
 14 Feb 2021 20:50:40 +0200")
Message-ID: <87blcml8dw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> A good solution would be to add a new choice value to tab-bar-show.
> Something like 'do-not-change-tab-bar-lines', but shorter.
> Then when let-bound, it should do nothing with the tab-bar-lines.

For example, a new value 'ignore'.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 14 Feb 2021 18:53:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 13:53:24 2021
Received: from localhost ([127.0.0.1]:36702 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBMWK-0003ne-4a
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 13:53:24 -0500
Received: from relay11.mail.gandi.net ([217.70.178.231]:39957)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lBMWG-0003mj-45
 for 46299 <at> debbugs.gnu.org; Sun, 14 Feb 2021 13:53:20 -0500
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay11.mail.gandi.net (Postfix) with ESMTPSA id D99C5100007;
 Sun, 14 Feb 2021 18:53:12 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
Date: Sun, 14 Feb 2021 20:50:40 +0200
In-Reply-To: <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
 (Bastian Beranek's message of "Sun, 14 Feb 2021 14:08:55 +0100")
Message-ID: <87im6ulbzz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> Thank you for working on this patch.  Please prepare the ChangeLog
>> commit message, so your patch could be pushed to master.  Then it would be
>> easier to reason about further changes and base them on the pushed version.
>
> please find the patch including the commit message with ChangeLog attached.

Thanks, now your patch is pushed to master.

While using it, I noticed a new problem.
There is this code in 'tab-switcher':

    (let ((tab-bar-new-tab-choice t)
          ;; Don't enable tab-bar-mode if it's disabled
          (tab-bar-show nil))
      (tab-bar-new-tab))

Before your patch, I did nothing with the enabled tab-bar,
but now it disables the tab-bar, and doesn't enable it again later,
because tab-bar-show is let-bound to nil.

A good solution would be to add a new choice value to tab-bar-show.
Something like 'do-not-change-tab-bar-lines', but shorter.
Then when let-bound, it should do nothing with the tab-bar-lines.

Also this is related to another problem:
What if the user wants to manually enable the tab bar on one frame only
without enabling tab-bar-mode?  Currently it's possible with

  (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)

But tab-bar--update-tab-bar-lines will disable it sooner or later.
Customizing to the same value like 'do-not-change-tab-bar-lines'
will solve this problem as well.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 14 Feb 2021 18:53:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 13:53:21 2021
Received: from localhost ([127.0.0.1]:36700 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBMWG-0003nS-P1
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 13:53:21 -0500
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:38225)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lBMWD-0003mf-Kj
 for 46299 <at> debbugs.gnu.org; Sun, 14 Feb 2021 13:53:19 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay7-d.mail.gandi.net (Postfix) with ESMTPSA id 2781620004;
 Sun, 14 Feb 2021 18:53:09 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
 <871rdjrbcf.fsf@HIDDEN>
Date: Sun, 14 Feb 2021 20:44:20 +0200
In-Reply-To: <871rdjrbcf.fsf@HIDDEN> (Juri Linkov's message of "Sat, 
 13 Feb 2021 21:46:00 +0200")
Message-ID: <87pn12mrsb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> But how would that cause visual glitches, such as the tab bar
>> splitting into two lines, menu bar not showing and general visual
>> issues (lines jumping around etc.). This worries me a bit, because I
>> don't understand the problem (just worked around it by not running the
>> (tab-bar-mode -1) (tab-bar-mode 1) sequence. Did you try the recipe I
>> reported above?
>
> Yes, I see the same.  A simpler test case is:
>
>   (tab-bar-mode -1)
>   (tab-bar-mode 1)
>   (tab-bar-mode -1)

More low-level test case:

  (set-frame-parameter nil 'tab-bar-lines 0)
  (set-frame-parameter nil 'tab-bar-lines 1)
  (set-frame-parameter nil 'tab-bar-lines 0)

that breaks the menu bar.  I don't know if this is a bug in display code,
or it's required to use 'redisplay' in-between.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 14 Feb 2021 13:09:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 08:09:19 2021
Received: from localhost ([127.0.0.1]:35575 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBH9L-0007oj-AW
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 08:09:19 -0500
Received: from mail-qk1-f181.google.com ([209.85.222.181]:41402)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lBH9J-0007oV-EX
 for 46299 <at> debbugs.gnu.org; Sun, 14 Feb 2021 08:09:18 -0500
Received: by mail-qk1-f181.google.com with SMTP id q85so4142943qke.8
 for <46299 <at> debbugs.gnu.org>; Sun, 14 Feb 2021 05:09:17 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=ZRi9hGSiXWuLYYYtvmKBLT9RGyQswfUYbA3Fgd3+z5k=;
 b=hEt+ZxpNppXAwqHRFPoimbgyJBmNQxw2JYGvXeLqzN5sTHCEy4Civf9gAU4DxBt2Va
 Q7yg69T1JQechv6ugkl5823nQeI9dohotlknH9cRmdi4r0QHI/pIvGL9KJBhcxDFo7WQ
 Gc5jcCYCymCgpHa0mO5ISML07gcg8sBnkPV4xc2+gSZ+FSd0+21hvoXhcGHBGa9ygQsV
 tWkJAG82uLCvjjMhYAZMvc4abv6/yRFO/bwSa8mAcq/zPzBvlu8oYKUphWCoSVbgri2/
 6Y+04qkqgxUZf/HMlNLYCx6oJ4L4rHAEmEDqLcNQETY5s54Aw9jEa+LbmCrp8i8sJma3
 s7Sw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=ZRi9hGSiXWuLYYYtvmKBLT9RGyQswfUYbA3Fgd3+z5k=;
 b=aACrKnhQhZNBJWQ9w2JZfIbBX4cUxJfecRCGbMCp4pFpaEhRw1e7KoYdZAUO0Dpi7M
 8UfFgItOUedZvPJHGWzp/3WC/tqdU4QSC+GYCUCJTvqiB3lVfc9wWyQSbne9kmnhhUP1
 uVe3O/MzPxvSxNuyUdjMLhrx6UMRdTUZEz2FuR2i2sph2kzNnNih9aoHp7HsOH7Q7eSC
 sMI/ZqKSCFYJmTjICcfW9U8K7F1/Q7qAb+1E/tlYS7tPvLJCmL2v4ZNNhB+hvMqZ0KsA
 7kIXirYncObgfTPTJwYqp4rFbPqBCjKMTTADEBUwO/hAaLvRjOJ/t+WvKvAPiYwDAzWj
 IS5g==
X-Gm-Message-State: AOAM531xDNB5oWR2S/zJqrQOe9LEVNwsXsJrxYgnCd66UdC4Xk6+78k2
 GTLyAXlZtjQm06tU+Wnj+DU/ZVpbG8wOsxdjd8w=
X-Google-Smtp-Source: ABdhPJzynTjOW2EHCkyCYurSBhTwtxP+mfNaByr/7I4xczidpNRTGi3YcJEk3nxgCaVqF9wwlNVGHhlJAtZoEe8MMDQ=
X-Received: by 2002:a37:68d1:: with SMTP id
 d200mr10808450qkc.362.1613308151981; 
 Sun, 14 Feb 2021 05:09:11 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
In-Reply-To: <87ft1zsu75.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Sun, 14 Feb 2021 14:08:55 +0100
Message-ID: <CAK9AuB8ZJaaaZZ4bx9mx79J33DMrNGQKv9VChDT1-xM8PLq8fQ@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000005060a905bb4b9389"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000005060a905bb4b9389
Content-Type: text/plain; charset="UTF-8"

> Thank you for working on this patch.  Please prepare the ChangeLog
> commit message, so your patch could be pushed to master.  Then it would be
> easier to reason about further changes and base them on the pushed version.

Hello Juri,

please find the patch including the commit message with ChangeLog attached.

Cheers
Bastian

--0000000000005060a905bb4b9389
Content-Type: text/x-patch; charset="US-ASCII"; 
	name="0001-Fix-showing-and-hiding-of-tab-bar-on-new-frames-bug-.patch"
Content-Disposition: attachment; 
	filename="0001-Fix-showing-and-hiding-of-tab-bar-on-new-frames-bug-.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kl5607oz0>
X-Attachment-Id: f_kl5607oz0
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--0000000000005060a905bb4b9389--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 13 Feb 2021 20:02:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 15:02:31 2021
Received: from localhost ([127.0.0.1]:35096 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lB17f-0003re-Ci
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:02:31 -0500
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:45299)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lB17d-0003rP-Jl
 for 46299 <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:02:30 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay5-d.mail.gandi.net (Postfix) with ESMTPSA id 86A651C0004;
 Sat, 13 Feb 2021 20:02:20 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
 <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
Date: Sat, 13 Feb 2021 21:46:00 +0200
In-Reply-To: <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
 (Bastian Beranek's message of "Sat, 13 Feb 2021 20:02:26 +0100")
Message-ID: <871rdjrbcf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> But how would that cause visual glitches, such as the tab bar
> splitting into two lines, menu bar not showing and general visual
> issues (lines jumping around etc.). This worries me a bit, because I
> don't understand the problem (just worked around it by not running the
> (tab-bar-mode -1) (tab-bar-mode 1) sequence. Did you try the recipe I
> reported above?

Yes, I see the same.  A simpler test case is:

  (tab-bar-mode -1)
  (tab-bar-mode 1)
  (tab-bar-mode -1)

This means that running (tab-bar-mode -1) (tab-bar-mode 1)
should be avoided when emacs is started, because it disables
the menu bar.  Maybe there is a bug in the display code.
But adding 'redisplay' in the middle fixes the mess
created by enabling/disabling the tab bar:

  (tab-bar-mode -1)
  (tab-bar-mode 1)
  (redisplay)
  (tab-bar-mode -1)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 13 Feb 2021 19:02:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 14:02:50 2021
Received: from localhost ([127.0.0.1]:35063 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lB0Bu-0002Sn-9H
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 14:02:50 -0500
Received: from mail-qv1-f43.google.com ([209.85.219.43]:36075)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lB0Bs-0002SZ-0J
 for 46299 <at> debbugs.gnu.org; Sat, 13 Feb 2021 14:02:48 -0500
Received: by mail-qv1-f43.google.com with SMTP id e9so1427772qvy.3
 for <46299 <at> debbugs.gnu.org>; Sat, 13 Feb 2021 11:02:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=3/0JwZgGRW4dQSDoU7DAwbmvfWT5H68Waj9Y9c8pL4Q=;
 b=oMFc/nN+tGZX/gZrVo+sXV7eQsNR1bEMpOt/bYkmIvalxoPAaD4WsAvbGAjF4IkaDS
 Zq1Y+hVXffBP+XeeVS6pVcteq3jHe8ErlejAodCOv3PLWOSmnYxBjDdTij+mpBQKLHH0
 3Xn1LKvpofOO9k+SkH1XTVmx6J7b9ZH9Ul1sae4lhw3+wqwtxHkVpi6vw4YHn2UrVYaE
 HXAO4CqugjblCM8cx8BXE7zG6NfWpZbkU/vIy6QZp5c/CBwzCoSizXuI5fJjIQgweBJ4
 1erX71tjhsLNGfwoHzag6WOd4f/r8DKZp8kyPsKVwa1K+X3NCgMUMi3U05YeV33LqPQV
 cayA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=3/0JwZgGRW4dQSDoU7DAwbmvfWT5H68Waj9Y9c8pL4Q=;
 b=MlBWmkptfUq4E3qly8bXHnOnC1wz55gRZXZHO4hfCKG81bOX0QT0YoXfYEsOntp2nX
 LbfZqXhtLKyrDkWwOrXhFfPLAn7Uo+Csx9D0wfz9uBqh8RcXSbITHtJDoyssBa8AOH/W
 Gnj592HhkWW4HrvKXvXV71lweu/HMTlOABqOcFJFNdKltE8LeIVPdE2ODo5j3MXtZ7bC
 ra93EV/6QOdPAcFOKKctgxClontv/X5s3PiSo+KhbyPGPDT12YH0PSuHFYUwp8GXROct
 Mttm9WB+1A7mVKUdyHLS4LH8APqkKzQtndjjYtQR8r6+cbFWwlE3emMHESYM2zojk1fY
 OW/A==
X-Gm-Message-State: AOAM532H0PlRoxqBF2qhD9Wfwz/14wiYL/xPPYHKdr5bsrcI7ZjL6VnS
 On3+6DAnRz0OvVqPdQrmkfUH20ljrchh5pcIxZI=
X-Google-Smtp-Source: ABdhPJzK+UeLLxSHiCIcU/Jz6QksyzWByl80C93tXw8n/lkeV1tSMufahediTjCIrCSt2yHDv7cVSFdWqmWLVs6MrdQ=
X-Received: by 2002:a0c:e708:: with SMTP id d8mr8041431qvn.12.1613242962498;
 Sat, 13 Feb 2021 11:02:42 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 <87ft1zsu75.fsf@HIDDEN>
In-Reply-To: <87ft1zsu75.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Sat, 13 Feb 2021 20:02:26 +0100
Message-ID: <CAK9AuB-qo-PsRY-HfmpFA4UFOLrnzce=0DyWScepOTYpW4wmwg@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Feb 13, 2021 at 7:33 PM Juri Linkov <juri@HIDDEN> wrote:
>
> Hey Bastian,
>
> Thank you for working on this patch.  Please prepare the ChangeLog
> commit message, so your patch could be pushed to master.  Then it would be
> easier to reason about further changes and base them on the pushed version.

I will do that and set a proper patch for git am.

>
> > @@ -89,8 +89,9 @@ tab-bar-select-tab-modifiers
> >   :set (lambda (sym val)
> >          (set-default sym val)
> >          ;; Reenable the tab-bar with new keybindings
> > -         (tab-bar-mode -1)
> > -         (tab-bar-mode 1))
> > +         (when tab-bar-mode
> > +           (tab-bar-mode -1)
> > +           (tab-bar-mode 1)))
> >   :group 'tab-bar
> >   :version "27.1")
> >
> > This seems to fix the issue. I can't say I fully understand why
> > though. It must have something to do with running
> > tab-bar--update-tab-bar-lines in early initialization? We could also
> > wrap the call to tab-bar--update-tab-bar-lines.
>
> The problem is that currently the function tab-bar-mode contains:
>
>   (if tab-bar-mode
>       (tab-bar--define-keys)
>     ;; Unset only keys bound by tab-bar
>     (when (eq (global-key-binding [(control tab)]) 'tab-next)
>       (global-unset-key [(control tab)]))
>     ...
>
> If the global-unset-key part would be refactored into a separate
> function, then tab-bar-select-tab-modifiers could call two
> functions sequentially: a new function that undefines old keys,
> then the existing separate function tab-bar--define-keys
> that will define keys with customized modifier.

But how would that cause visual glitches, such as the tab bar
splitting into two lines, menu bar not showing and general visual
issues (lines jumping around etc.). This worries me a bit, because I
don't understand the problem (just worked around it by not running the
(tab-bar-mode -1) (tab-bar-mode 1) sequence. Did you try the recipe I
reported above?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 13 Feb 2021 18:33:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 13:33:11 2021
Received: from localhost ([127.0.0.1]:35039 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAzjD-0001kb-8i
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 13:33:11 -0500
Received: from relay10.mail.gandi.net ([217.70.178.230]:53167)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lAzjB-0001k5-2P
 for 46299 <at> debbugs.gnu.org; Sat, 13 Feb 2021 13:33:09 -0500
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay10.mail.gandi.net (Postfix) with ESMTPSA id 343E1240005;
 Sat, 13 Feb 2021 18:33:00 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
 <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
Date: Sat, 13 Feb 2021 20:23:20 +0200
In-Reply-To: <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
 (Bastian Beranek's message of "Fri, 12 Feb 2021 20:23:26 +0100")
Message-ID: <87ft1zsu75.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hey Bastian,

Thank you for working on this patch.  Please prepare the ChangeLog
commit message, so your patch could be pushed to master.  Then it would be
easier to reason about further changes and base them on the pushed version.

> @@ -89,8 +89,9 @@ tab-bar-select-tab-modifiers
>   :set (lambda (sym val)
>          (set-default sym val)
>          ;; Reenable the tab-bar with new keybindings
> -         (tab-bar-mode -1)
> -         (tab-bar-mode 1))
> +         (when tab-bar-mode
> +           (tab-bar-mode -1)
> +           (tab-bar-mode 1)))
>   :group 'tab-bar
>   :version "27.1")
>
> This seems to fix the issue. I can't say I fully understand why
> though. It must have something to do with running
> tab-bar--update-tab-bar-lines in early initialization? We could also
> wrap the call to tab-bar--update-tab-bar-lines.

The problem is that currently the function tab-bar-mode contains:

  (if tab-bar-mode
      (tab-bar--define-keys)
    ;; Unset only keys bound by tab-bar
    (when (eq (global-key-binding [(control tab)]) 'tab-next)
      (global-unset-key [(control tab)]))
    ...

If the global-unset-key part would be refactored into a separate
function, then tab-bar-select-tab-modifiers could call two
functions sequentially: a new function that undefines old keys,
then the existing separate function tab-bar--define-keys
that will define keys with customized modifier.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 12 Feb 2021 19:23:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 12 14:23:52 2021
Received: from localhost ([127.0.0.1]:33015 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAe2i-0000zt-1g
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2021 14:23:52 -0500
Received: from mail-qt1-f176.google.com ([209.85.160.176]:41039)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lAe2e-0000zd-9d
 for 46299 <at> debbugs.gnu.org; Fri, 12 Feb 2021 14:23:50 -0500
Received: by mail-qt1-f176.google.com with SMTP id z32so428741qtd.8
 for <46299 <at> debbugs.gnu.org>; Fri, 12 Feb 2021 11:23:48 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=jC2jYs3Zuwr+15sInGk7RHUYIgcGxFxewqhtkhqzoaU=;
 b=u7sjUoal5pIbPj7MnxDOLmkeRYTYT08O/FnwENWOdIAXCFpaDNFGeCRVbcWQITlbOw
 RRa3DMPe1SDBFg9ADcAvJLxx89q8u/0nrf+VWfHmIhhcKi4Hz5cD4TNtzekCyb6rJATe
 hVgN8pq9K1WCtYErJNgicOG7psVJdHlsbuA9FHzvZvsMV/gHPQW8BvqCIwetl/3Ac7hc
 ffiw8BCSQKLcazCiDUaDii3aWe+yayOMPWkL7DjdiooQJgjuAHDDVUZ/mCIn9j+bjSjC
 32ccTVui7xLA9ie02+yNeyGhNem49amFqoqJot2q5rw2BGIXZ4kjjHdSBN+mreReJZFw
 kaGQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=jC2jYs3Zuwr+15sInGk7RHUYIgcGxFxewqhtkhqzoaU=;
 b=hKURBQbTRoog8zyNOrvRy2jK7LXgWJXwbiEGaTEnk7r+iQrP1tcFQZ9rzJZ7RGohXZ
 0fAbnt1PKAh2QnTUZtX6HAVJbu5CmY9su30Ge9rhoLXy+YCBINf6fv+xmQVhikF+vTM8
 58SvUEoIw6zmR0KesJDfktKNtf4txvfqLm6Kgr2Ivpgk62FKQ5lWAlw7SIU84gzYrUGu
 +XInWZWJEoWDgYnoPD33k2U3O7fNK+6E07+3U/R49GO+qQatztmK80S1Qj4VUuUgqeHA
 MxJu1ZmXriafhbBbPLFHWoK42N+iENt18Fhevqcke5RyNsKfTtP0KpS0JJ17LMCwzHXs
 CyhA==
X-Gm-Message-State: AOAM5335vGXUIESKoWaRnejGMgWalP2njw1AAqixNNukzWUc39ZodE6U
 Rqy8PSzpWql6e7C7/j60+upQF7JpTFLNrj6yRS0=
X-Google-Smtp-Source: ABdhPJy985wG2QPW4nkHlBhNLYcrCYcuLwKD+7+24ZD5S+duVthnz02J1ZIfUscfkcMo1pMtkWge2Gz4AO0o24ZzUJ8=
X-Received: by 2002:ac8:7383:: with SMTP id t3mr3812729qtp.242.1613157822396; 
 Fri, 12 Feb 2021 11:23:42 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
 <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
In-Reply-To: <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Fri, 12 Feb 2021 20:23:26 +0100
Message-ID: <CAK9AuB_WhhmZHn4NsgebdT6bz_ebWywsFrkyecXYRng4p2yqqQ@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000f8959905bb2892a3"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000f8959905bb2892a3
Content-Type: text/plain; charset="UTF-8"

On Fri, Feb 12, 2021 at 3:47 PM Bastian Beranek
<bastian.beischer@HIDDEN> wrote:
>
> Hey Juri,
>
> just to let you know, that I've found a problem with my patch on
> text-mode frames. If I create multiple tabs one after another they
> start to appear in a second row and visuals begin to glitch.
>
> I'll try to understand why that is happening.

I found out what the problem was. I had customized
tab-bar-select-tab-modifiers in my .emacs and the :set function of
that variable contained (tab-bar-mode -1) followed by (tab-bar-mode
1). For some reason this caused issues (to reproduce this, apply my
v8.patch, create test.el (as below) and start emacs as follows:

$ cat test.el
(customize-set-variable 'tab-bar-select-tab-modifiers '(super))
(customize-set-variable 'tab-bar-show 1)

$ src/emacs -nw -Q -l test.el
and then create two or more tabs (C-x t 2)

I have now modified the set function to:

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 87c9fd719d..4e47ae2c10 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -89,8 +89,9 @@ tab-bar-select-tab-modifiers
  :set (lambda (sym val)
         (set-default sym val)
         ;; Reenable the tab-bar with new keybindings
-         (tab-bar-mode -1)
-         (tab-bar-mode 1))
+         (when tab-bar-mode
+           (tab-bar-mode -1)
+           (tab-bar-mode 1)))
  :group 'tab-bar
  :version "27.1")

This seems to fix the issue. I can't say I fully understand why
though. It must have something to do with running
tab-bar--update-tab-bar-lines in early initialization? We could also
wrap the call to tab-bar--update-tab-bar-lines.

Please find the full v9 patch attached.

Cheers
Bastian

--000000000000f8959905bb2892a3
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v9.patch"
Content-Disposition: attachment; filename="tab-bar_v9.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kl2oh6br0>
X-Attachment-Id: f_kl2oh6br0
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--000000000000f8959905bb2892a3--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 12 Feb 2021 14:47:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 12 09:47:48 2021
Received: from localhost ([127.0.0.1]:60188 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAZjY-0002bR-3V
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2021 09:47:48 -0500
Received: from mail-qt1-f170.google.com ([209.85.160.170]:37608)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lAZjV-0002bD-PB
 for 46299 <at> debbugs.gnu.org; Fri, 12 Feb 2021 09:47:46 -0500
Received: by mail-qt1-f170.google.com with SMTP id v3so6853230qtw.4
 for <46299 <at> debbugs.gnu.org>; Fri, 12 Feb 2021 06:47:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=taEGm7zpRCTrC69yPhYOv+ez94xxuC/KPSTqYwl/aO0=;
 b=d2YXRFPfgCu+qHU5z7MOWzsbk446OAA1g3KUzjhBr7LKRYFgF+Mh9qdKdyQp2mipOg
 LJJGVtZzKQE16HhiMFjM0GZn3Oqw5MxuuKuzxrK122m581FQpi8AWcHSRAY8CblmR9Lq
 4ftbZaAXPTsSzvSG6ti6XcCcPW8h6rho/bjFEUionn/FyU2e+6mHu9THYxUAY3gpycvt
 gr2ucjfn9cEMwhmcyuUhiYavHI/cNWNDiT6flC4rIkNqjgpMmb3kILfdEUeAwW2RXnG7
 QX4tSUOXxWEvdYagSJInHtOm7hypNgFCY1idvjpdfNexYByCNioFvT0mBXdCG13F297A
 3RBg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=taEGm7zpRCTrC69yPhYOv+ez94xxuC/KPSTqYwl/aO0=;
 b=WVIzFgtFfZYtmc9OuzW8JvdnwvKcYtckANznT5JQanxWIEKyQZ/YpqjgYKIQ+tG+TA
 21eSDPi7FubluR7TgbsoZCQ3IOWTYOazWzsCNtd8TB0CIkOcrIHXyM4MFwYZ764WgQcV
 /0V4v/AIO01PxR9pRjQIXIBhoqg1tYhmaSivtc8wEbfF6nmdLTT4ULGcW4bpWyI6xNrB
 wv9fwhn8eVE8rV0P7QAshZuMKT6gc5oRiCTTxOR2SgknAWMekpQP8DXqMZEMhCyqy8nA
 W9zKN9DX1FbZkZr1ma7rTZPIaKs3qvpVRXuMqmndGzRJDx1TbG6XVssnC+tigK7kzQaq
 DZMw==
X-Gm-Message-State: AOAM5301O0lMZVTYFuovYhu4XzcKiROumpJrJzg/KvemicQjyPRFP8bF
 VP+A2S5GFAQKjMqOBlMAxJarf31fwzR7cxfcmmk=
X-Google-Smtp-Source: ABdhPJza29xUel4YuOil11wjd4xVsdG9QOnQQhGwk38d2C2tX8Us4v1tmb3JrId5pDYvPptgcUawRIMRizs0MamTFvA=
X-Received: by 2002:a05:622a:109:: with SMTP id
 u9mr2684306qtw.116.1613141260194; 
 Fri, 12 Feb 2021 06:47:40 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
 <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
In-Reply-To: <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Fri, 12 Feb 2021 15:47:24 +0100
Message-ID: <CAK9AuB-jZYNUxSHw=WPVP54r5so3bdk=5k5CNJ-K_EUsn_B21w@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hey Juri,

just to let you know, that I've found a problem with my patch on
text-mode frames. If I create multiple tabs one after another they
start to appear in a second row and visuals begin to glitch.

I'll try to understand why that is happening.

Bastian




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 12 Feb 2021 10:24:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 12 05:24:52 2021
Received: from localhost ([127.0.0.1]:59975 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAVd6-0002SI-7q
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2021 05:24:52 -0500
Received: from mail-qk1-f182.google.com ([209.85.222.182]:46242)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lAVd1-0002Rz-Kp
 for 46299 <at> debbugs.gnu.org; Fri, 12 Feb 2021 05:24:51 -0500
Received: by mail-qk1-f182.google.com with SMTP id w19so7715986qki.13
 for <46299 <at> debbugs.gnu.org>; Fri, 12 Feb 2021 02:24:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=nK8P2qqZaijrrbNqoGxeQ07KbXpZP+Y+Qb6/R0sDuvs=;
 b=OrCyoWeiCw3/VDPCPYCdjwWWWwvPdYo7jO+rE4TzovQ6XfQxYpSGn+jupXgaE7LAvU
 c6X98Z/hS/2VOdXy3lVDvsZd/iPf9ECnqdsmJxEu2AfqyXvTchpIATNjbWaNw7aQhO+g
 jAjaDqwIJ9SlYiaITunvzQ+2EQXG9wCZeJqgYIZT4kTr1SwIPqeH50cAClt7cMKlSfTQ
 b8X0/3DJhTX4FzmnZ2uwkyFnLRQ4zQIRxjYT69qt2muNES8zyv5iWA78ugfiULSVWuUJ
 /1ZdoL599W+/qLD3/J/akhZxQo+t2AoiUam93p8Fg+6B8Wj3n+mYCkZFD+8ETR2I3vxE
 w51A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=nK8P2qqZaijrrbNqoGxeQ07KbXpZP+Y+Qb6/R0sDuvs=;
 b=FBnPUatcY9GIAWMHmccdCDWwK98Zq9vOpXBSK3fKYTcDafO35xoLyay3SYwgmZCl/v
 QsYVpwoOudCtsmcpJLQkMefVM43au7Udy6UVGR+Xk7dVjF2xqOIXDrztAOe3A0A5WUnP
 BpV6RSak1qE621Kwp7xaw+wxSyLJB1wItNnNBwcLmo2ljmiJbIiYMtgFXYVhE54uTikA
 f8XdLwhRqptX0OGH+EJoQpBm7+AQBAi/OiG8DquC5LUPxxF+S232mXA/aFKyMaGsIyzk
 DL9lLFl7hbAmu3vJm9AGcp0SfPOed2VfdfUcSD/uGPXY24JUCLqsnohW8+WZun10vgpu
 U0FA==
X-Gm-Message-State: AOAM530CkUxJPHGHmE5kbcRgLkYaeqdCTWnJa1kq/TU7qaCicqUxGHIc
 r4XZOtDKL4eIglwf3sAOQX7Pib9V33KevNfhG9I=
X-Google-Smtp-Source: ABdhPJx+yWCvcmMMB87giRVzS5zKrLaruoBmjx2MlP2KnFL7958NOsCJz5z6/b/LP7kf95VfQJ/WrZD5G90g+Zmb03g=
X-Received: by 2002:a37:68d1:: with SMTP id d200mr1903995qkc.362.1613125482111; 
 Fri, 12 Feb 2021 02:24:42 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 <871rdlr4vc.fsf@HIDDEN>
In-Reply-To: <871rdlr4vc.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Fri, 12 Feb 2021 11:24:26 +0100
Message-ID: <CAK9AuB-1U5aQWOoJe0BCpL8SSZrWXOHujnGg=S8FGBZQb4u5kw@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="00000000000056fad805bb210b77"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--00000000000056fad805bb210b77
Content-Type: text/plain; charset="UTF-8"

Hey Juri,

On Fri, Feb 12, 2021 at 10:57 AM Juri Linkov <juri@HIDDEN> wrote:
>
> Hello Bastian,
>
> Everything in your patch v7 is correct now, except one case of
> tab-bar-new-tab-to:
>
> >> Would you agree that here in tab-bar-new-tab-to, the first call of
> >> tab-bar-mode should already do all these calls: tab-bar--update-tab-bar-lines,
> >> tab-bar--load-buttons, tab-bar--define-keys?  So maybe it should be
> >> sufficient just to leave these 2 lines here:
> >>
> >>     (when tab-bar-show
> >>        (tab-bar-mode 1))
>
> I noticed this could be optimized not to call tab-bar-mode again every time
> when tab-bar-mode was already enabled.  Maybe use something like this:
>
>     (when (and (not tab-bar-mode) tab-bar-show)
>       (tab-bar-mode 1))
>

I've adjusted the patch accordingly, but we do need a call to
tab-bar--update-tab-bar-lines whenever a tab is created (because we
need to check if there is more than one tab now, which changes the
display criterion). So I added:

    (when tab-bar-show
      (if (not tab-bar-mode)
          ;; Switch on tab-bar-mode, since a tab was created
          ;; Note: This also updates tab-bar-lines
          (tab-bar-mode 1)
        (tab-bar--update-tab-bar-lines)))


> > Yes I agree that tab-bar--update-tab-bar-lines is not needed. It
> > happens in the line before when tab-bar-show is not nil and doesn't
> > matter otherwise. I have left these two lines, though:
> >
> >     (when tab-bar-mode
> >       (tab-bar--load-buttons)
> >       (tab-bar--define-keys))
>
> I still have doubts whether these lines are needed at all.
>
> > Because I think defining the keys is useful even if tab-bar-show is
> > nil, so you can switch to another tab using the key bindings even if
> > you can't see the tab-bar.
>
> The problem is that tab-bar--define-keys defines only two keys
> C-TAB and S-C-TAB and [modifier-digit] keys to select a tab by its
> displayed number that mostly make sense with the visible tab bar.
>
> So one of the purposes of the nil value of tab-bar-show was to
> allow the users also to disable the C-TAB and digit keys.  Then
> users could use C-TAB bindings from other packages, while still
> using global tab-switching keys such as 'C-x t o', and also to
> select tabs by names using 'C-x t b', whereas selecting by numbers
> makes sense only when the tab bar is visible.
>
> > As for the buttons, I think it makes sense to load them so that in
> > case tab-bar-show is customized to another value afterwards they are
> > available directly.
>
> tab-bar--load-buttons and tab-bar--define-keys are called anyway
> when enabling the tab bar with tab-bar-mode.  So these two functions
> could be called only in tab-bar-mode, but afterwards when
> it's already enabled, there is no need to call them again.

I see now that you are right and I removed those lines.

Cheers
Bastian

--00000000000056fad805bb210b77
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v8.patch"
Content-Disposition: attachment; filename="tab-bar_v8.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kl258obp0>
X-Attachment-Id: f_kl258obp0

ZGlmZiAtLWdpdCBhL2xpc3AvdGFiLWJhci5lbCBiL2xpc3AvdGFiLWJhci5lbAppbmRleCA2NzIw
ZDgyYjQ3Li44N2M5ZmQ3MTlkIDEwMDY0NAotLS0gYS9saXNwL3RhYi1iYXIuZWwKKysrIGIvbGlz
cC90YWItYmFyLmVsCkBAIC0xMzQsMjEgKzEzNCw0NyBAQCB0YWItYmFyLS1sb2FkLWJ1dHRvbnMK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIDphc2NlbnQgY2VudGVy
KSkKICAgICAgICAgICAgICAgICAgICAgICAgICB0YWItYmFyLWNsb3NlLWJ1dHRvbikpKQogCiso
ZGVmdW4gdGFiLWJhci0tdGFiLWJhci1saW5lcy1mb3ItZnJhbWUgKGZyYW1lKQorICAiRGV0ZXJt
aW5lIGFuZCByZXR1cm4gdGhlIHZhbHVlIG9mIGB0YWItYmFyLWxpbmVzJyBmb3IgRlJBTUUuCitS
ZXR1cm4gMCBpZiBgdGFiLWJhci1tb2RlJyBpcyBub3QgZW5hYmxlZC4gIE90aGVyd2lzZSByZXR1
cm4KK2VpdGhlciAxIG9yIDAgZGVwZW5kaW5nIG9uIHRoZSB2YWx1ZSBvZiB0aGUgY3VzdG9taXph
YmxlIHZhcmlhYmxlCitgdGFiLWJhci1zaG93Jywgd2hpY2ggc2VlLiIKKyAgKGNvbmQKKyAgICgo
bm90IHRhYi1iYXItbW9kZSkgMCkKKyAgICgobm90IHRhYi1iYXItc2hvdykgMCkKKyAgICgoZXEg
dGFiLWJhci1zaG93IHQpIDEpCisgICAoKG5hdG51bXAgdGFiLWJhci1zaG93KQorICAgIChpZiAo
PiAobGVuZ3RoIChmdW5jYWxsIHRhYi1iYXItdGFicy1mdW5jdGlvbiBmcmFtZSkpIHRhYi1iYXIt
c2hvdykgMSAwKSkpKQorCisoZGVmdW4gdGFiLWJhci0tdXBkYXRlLXRhYi1iYXItbGluZXMgKCZv
cHRpb25hbCBmcmFtZXMpCisgICJVcGRhdGUgdGhlIGB0YWItYmFyLWxpbmVzJyBwYXJhbWV0ZXIg
aW4gZnJhbWVzLgorVXBkYXRlIHRoZSB0YWItYmFyLWxpbmVzIGZyYW1lIHBhcmFtZXRlci4gSWYg
dGhlIG9wdGlvbmFsCitwYXJhbWV0ZXIgRlJBTUVTIGlzIG9taXR0ZWQsIHVwZGF0ZSBvbmx5IHRo
ZSBjdXJyZW50bHkgc2VsZWN0ZWQKK2ZyYW1lLiAgSWYgaXQgaXMgYHQnLCB1cGRhdGUgYWxsIGZy
YW1lcyBhcyB3ZWxsIGFzIHRoZSBkZWZhdWx0Citmb3IgbmV3IGZyYW1lcy4gIE90aGVyd2lzZSBG
UkFNRVMgc2hvdWxkIGJlIGEgbGlzdCBvZiBmcmFtZXMgdG8KK3VwZGF0ZS4iCisgIChsZXQgKChm
cmFtZS1sc3QgKGNvbmQgKChudWxsIGZyYW1lcykKKyAgICAgICAgICAgICAgICAgICAgICAgICAg
KGxpc3QgKHNlbGVjdGVkLWZyYW1lKSkpCisgICAgICAgICAgICAgICAgICAgICAgICAgKChlcSBm
cmFtZXMgdCkKKyAgICAgICAgICAgICAgICAgICAgICAgICAgKGZyYW1lLWxpc3QpKQorICAgICAg
ICAgICAgICAgICAgICAgICAgICh0IGZyYW1lcykpKSkKKyAgICA7OyBMb29wIG92ZXIgYWxsIGZy
YW1lcyBhbmQgdXBkYXRlIGRlZmF1bHQtZnJhbWUtYWxpc3QKKyAgICAoZG9saXN0IChmcmFtZSBm
cmFtZS1sc3QpCisgICAgICAoc2V0LWZyYW1lLXBhcmFtZXRlciBmcmFtZSAndGFiLWJhci1saW5l
cyAodGFiLWJhci0tdGFiLWJhci1saW5lcy1mb3ItZnJhbWUgZnJhbWUpKSkpCisgICh3aGVuIChl
cSBmcmFtZXMgdCkKKyAgICAoc2V0cSBkZWZhdWx0LWZyYW1lLWFsaXN0CisgICAgICAgICAgKGNv
bnMgKGNvbnMgJ3RhYi1iYXItbGluZXMgKGlmIChhbmQgdGFiLWJhci1tb2RlIChlcSB0YWItYmFy
LXNob3cgdCkpIDEgMCkpCisgICAgICAgICAgICAgICAgKGFzc3EtZGVsZXRlLWFsbCAndGFiLWJh
ci1saW5lcyBkZWZhdWx0LWZyYW1lLWFsaXN0KSkpKSkKKwogKGRlZmluZS1taW5vci1tb2RlIHRh
Yi1iYXItbW9kZQogICAiVG9nZ2xlIHRoZSB0YWIgYmFyIGluIGFsbCBncmFwaGljYWwgZnJhbWVz
IChUYWIgQmFyIG1vZGUpLiIKICAgOmdsb2JhbCB0CiAgIDs7IEl0J3MgZGVmaW5lZCBpbiBDL2N1
cy1zdGFydCwgdGhpcyBzdG9wcyB0aGUgZC1tLW0gbWFjcm8gZGVmaW5pbmcgaXQgYWdhaW4uCiAg
IDp2YXJpYWJsZSB0YWItYmFyLW1vZGUKLSAgKGxldCAoKHZhbCAoaWYgdGFiLWJhci1tb2RlIDEg
MCkpKQotICAgIChkb2xpc3QgKGZyYW1lIChmcmFtZS1saXN0KSkKLSAgICAgIChzZXQtZnJhbWUt
cGFyYW1ldGVyIGZyYW1lICd0YWItYmFyLWxpbmVzIHZhbCkpCi0gICAgOzsgSWYgdGhlIHVzZXIg
aGFzIGdpdmVuIGBkZWZhdWx0LWZyYW1lLWFsaXN0JyBhIGB0YWItYmFyLWxpbmVzJwotICAgIDs7
IHBhcmFtZXRlciwgcmVwbGFjZSBpdC4KLSAgICAoaWYgKGFzc3EgJ3RhYi1iYXItbGluZXMgZGVm
YXVsdC1mcmFtZS1hbGlzdCkKLSAgICAgICAgKHNldHEgZGVmYXVsdC1mcmFtZS1hbGlzdAotICAg
ICAgICAgICAgICAoY29ucyAoY29ucyAndGFiLWJhci1saW5lcyB2YWwpCi0gICAgICAgICAgICAg
ICAgICAgIChhc3NxLWRlbGV0ZS1hbGwgJ3RhYi1iYXItbGluZXMKLSAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICBkZWZhdWx0LWZyYW1lLWFsaXN0KSkpKSkKKworICA7OyBSZWNh
bGN1bGF0ZSB0YWItYmFyLWxpbmVzIGZvciBhbGwgZnJhbWVzCisgICh0YWItYmFyLS11cGRhdGUt
dGFiLWJhci1saW5lcyB0KQorCiAgICh3aGVuIHRhYi1iYXItbW9kZQogICAgICh0YWItYmFyLS1s
b2FkLWJ1dHRvbnMpKQogICAoaWYgdGFiLWJhci1tb2RlCkBAIC0yNTAsMTcgKzI3Niw5IEBAIHRh
Yi1iYXItc2hvdwogICA6aW5pdGlhbGl6ZSAnY3VzdG9tLWluaXRpYWxpemUtZGVmYXVsdAogICA6
c2V0IChsYW1iZGEgKHN5bSB2YWwpCiAgICAgICAgICAoc2V0LWRlZmF1bHQgc3ltIHZhbCkKLSAg
ICAgICAgIDs7IFByZWxvYWQgYnV0dG9uIGltYWdlcwotICAgICAgICAgKHRhYi1iYXItbW9kZSAx
KQotICAgICAgICAgOzsgVGhlbiBoYW5kbGUgZWFjaCBmcmFtZSBpbmRpdmlkdWFsbHkKLSAgICAg
ICAgIChkb2xpc3QgKGZyYW1lIChmcmFtZS1saXN0KSkKLSAgICAgICAgICAgKHNldC1mcmFtZS1w
YXJhbWV0ZXIKLSAgICAgICAgICAgIGZyYW1lICd0YWItYmFyLWxpbmVzCi0gICAgICAgICAgICAo
aWYgKG9yIChlcSB2YWwgdCkKLSAgICAgICAgICAgICAgICAgICAgKGFuZCAobmF0bnVtcCB2YWwp
Ci0gICAgICAgICAgICAgICAgICAgICAgICAgKD4gKGxlbmd0aCAoZnVuY2FsbCB0YWItYmFyLXRh
YnMtZnVuY3Rpb24gZnJhbWUpKQotICAgICAgICAgICAgICAgICAgICAgICAgICAgIHZhbCkpKQot
ICAgICAgICAgICAgICAgIDEgMCkpKSkKKyAgICAgICAgIChpZiB2YWwKKyAgICAgICAgICAgICAo
dGFiLWJhci1tb2RlIDEpCisgICAgICAgICAgICh0YWItYmFyLS11cGRhdGUtdGFiLWJhci1saW5l
cyB0KSkpCiAgIDpncm91cCAndGFiLWJhcgogICA6dmVyc2lvbiAiMjcuMSIpCiAKQEAgLTg1Miwx
NiArODcwLDEyIEBAIHRhYi1iYXItbmV3LXRhYi10bwogICAgICAgKHJ1bi1ob29rLXdpdGgtYXJn
cyAndGFiLWJhci10YWItcG9zdC1vcGVuLWZ1bmN0aW9ucwogICAgICAgICAgICAgICAgICAgICAg
ICAgICAobnRoIHRvLWluZGV4IHRhYnMpKSkKIAotICAgIChjb25kCi0gICAgICgoZXEgdGFiLWJh
ci1zaG93IHQpCi0gICAgICAodGFiLWJhci1tb2RlIDEpKQotICAgICAoKGFuZCAobmF0bnVtcCB0
YWItYmFyLXNob3cpCi0gICAgICAgICAgICg+IChsZW5ndGggKGZ1bmNhbGwgdGFiLWJhci10YWJz
LWZ1bmN0aW9uKSkgdGFiLWJhci1zaG93KQotICAgICAgICAgICAoemVyb3AgKGZyYW1lLXBhcmFt
ZXRlciBuaWwgJ3RhYi1iYXItbGluZXMpKSkKLSAgICAgIChwcm9nbgotICAgICAgICAodGFiLWJh
ci0tbG9hZC1idXR0b25zKQotICAgICAgICAodGFiLWJhci0tZGVmaW5lLWtleXMpCi0gICAgICAg
IChzZXQtZnJhbWUtcGFyYW1ldGVyIG5pbCAndGFiLWJhci1saW5lcyAxKSkpKQorICAgICh3aGVu
IHRhYi1iYXItc2hvdworICAgICAgKGlmIChub3QgdGFiLWJhci1tb2RlKQorICAgICAgICAgIDs7
IFN3aXRjaCBvbiB0YWItYmFyLW1vZGUsIHNpbmNlIGEgdGFiIHdhcyBjcmVhdGVkCisgICAgICAg
ICAgOzsgTm90ZTogVGhpcyBhbHNvIHVwZGF0ZXMgdGFiLWJhci1saW5lcworICAgICAgICAgICh0
YWItYmFyLW1vZGUgMSkKKyAgICAgICAgKHRhYi1iYXItLXVwZGF0ZS10YWItYmFyLWxpbmVzKSkp
CiAKICAgICAoZm9yY2UtbW9kZS1saW5lLXVwZGF0ZSkKICAgICAodW5sZXNzIHRhYi1iYXItbW9k
ZQpAQCAtOTk2LDExICsxMDEwLDggQEAgdGFiLWJhci1jbG9zZS10YWIKICAgICAgICAgICAgICAg
ICB0YWItYmFyLWNsb3NlZC10YWJzKQogICAgICAgICAgIChzZXQtZnJhbWUtcGFyYW1ldGVyIG5p
bCAndGFicyAoZGVscSBjbG9zZS10YWIgdGFicykpKQogCi0gICAgICAgICh3aGVuIChhbmQgKG5v
dCAoemVyb3AgKGZyYW1lLXBhcmFtZXRlciBuaWwgJ3RhYi1iYXItbGluZXMpKSkKLSAgICAgICAg
ICAgICAgICAgICAobmF0bnVtcCB0YWItYmFyLXNob3cpCi0gICAgICAgICAgICAgICAgICAgKDw9
IChsZW5ndGggKGZ1bmNhbGwgdGFiLWJhci10YWJzLWZ1bmN0aW9uKSkKLSAgICAgICAgICAgICAg
ICAgICAgICAgdGFiLWJhci1zaG93KSkKLSAgICAgICAgICAoc2V0LWZyYW1lLXBhcmFtZXRlciBu
aWwgJ3RhYi1iYXItbGluZXMgMCkpCisgICAgICAgIDs7IFJlY2FsY3VsYXRlIHRhYi1iYXItbGlu
ZXMgYW5kIHVwZGF0ZSBmcmFtZXMKKyAgICAgICAgKHRhYi1iYXItLXVwZGF0ZS10YWItYmFyLWxp
bmVzKQogCiAgICAgICAgIChmb3JjZS1tb2RlLWxpbmUtdXBkYXRlKQogICAgICAgICAodW5sZXNz
IHRhYi1iYXItbW9kZQpAQCAtMTAzNiwxMSArMTA0Nyw4IEBAIHRhYi1iYXItY2xvc2Utb3RoZXIt
dGFicwogICAgICAgICAgIChydW4taG9vay13aXRoLWFyZ3MgJ3RhYi1iYXItdGFiLXByZS1jbG9z
ZS1mdW5jdGlvbnMgKG50aCBpbmRleCB0YWJzKSBuaWwpKSkKICAgICAgIChzZXQtZnJhbWUtcGFy
YW1ldGVyIG5pbCAndGFicyAobGlzdCAobnRoIGN1cnJlbnQtaW5kZXggdGFicykpKQogCi0gICAg
ICAod2hlbiAoYW5kIChub3QgKHplcm9wIChmcmFtZS1wYXJhbWV0ZXIgbmlsICd0YWItYmFyLWxp
bmVzKSkpCi0gICAgICAgICAgICAgICAgIChuYXRudW1wIHRhYi1iYXItc2hvdykKLSAgICAgICAg
ICAgICAgICAgKDw9IChsZW5ndGggKGZ1bmNhbGwgdGFiLWJhci10YWJzLWZ1bmN0aW9uKSkKLSAg
ICAgICAgICAgICAgICAgICAgIHRhYi1iYXItc2hvdykpCi0gICAgICAgIChzZXQtZnJhbWUtcGFy
YW1ldGVyIG5pbCAndGFiLWJhci1saW5lcyAwKSkKKyAgICAgIDs7IFJlY2FsY3VsYXRlIHRhYi1i
YXItbGluZXMgYW5kIHVwZGF0ZSBmcmFtZXMKKyAgICAgICh0YWItYmFyLS11cGRhdGUtdGFiLWJh
ci1saW5lcykKIAogICAgICAgKGZvcmNlLW1vZGUtbGluZS11cGRhdGUpCiAgICAgICAodW5sZXNz
IHRhYi1iYXItbW9kZQo=
--00000000000056fad805bb210b77--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 12 Feb 2021 09:57:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 12 04:57:17 2021
Received: from localhost ([127.0.0.1]:59969 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAVCO-0001oQ-U5
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2021 04:57:17 -0500
Received: from relay9-d.mail.gandi.net ([217.70.183.199]:44741)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lAVCM-0001oB-Id
 for 46299 <at> debbugs.gnu.org; Fri, 12 Feb 2021 04:57:15 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay9-d.mail.gandi.net (Postfix) with ESMTPSA id E8F03FF810;
 Fri, 12 Feb 2021 09:57:06 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
Date: Fri, 12 Feb 2021 11:31:19 +0200
In-Reply-To: <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
 (Bastian Beranek's message of "Thu, 11 Feb 2021 13:14:53 +0100")
Message-ID: <871rdlr4vc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hello Bastian,

Everything in your patch v7 is correct now, except one case of
tab-bar-new-tab-to:

>> Would you agree that here in tab-bar-new-tab-to, the first call of
>> tab-bar-mode should already do all these calls: tab-bar--update-tab-bar-lines,
>> tab-bar--load-buttons, tab-bar--define-keys?  So maybe it should be
>> sufficient just to leave these 2 lines here:
>>
>>     (when tab-bar-show
>>        (tab-bar-mode 1))

I noticed this could be optimized not to call tab-bar-mode again every time
when tab-bar-mode was already enabled.  Maybe use something like this:

    (when (and (not tab-bar-mode) tab-bar-show)
      (tab-bar-mode 1))

> Yes I agree that tab-bar--update-tab-bar-lines is not needed. It
> happens in the line before when tab-bar-show is not nil and doesn't
> matter otherwise. I have left these two lines, though:
>
>     (when tab-bar-mode
>       (tab-bar--load-buttons)
>       (tab-bar--define-keys))

I still have doubts whether these lines are needed at all.

> Because I think defining the keys is useful even if tab-bar-show is
> nil, so you can switch to another tab using the key bindings even if
> you can't see the tab-bar.

The problem is that tab-bar--define-keys defines only two keys
C-TAB and S-C-TAB and [modifier-digit] keys to select a tab by its
displayed number that mostly make sense with the visible tab bar.

So one of the purposes of the nil value of tab-bar-show was to
allow the users also to disable the C-TAB and digit keys.  Then
users could use C-TAB bindings from other packages, while still
using global tab-switching keys such as 'C-x t o', and also to
select tabs by names using 'C-x t b', whereas selecting by numbers
makes sense only when the tab bar is visible.

> As for the buttons, I think it makes sense to load them so that in
> case tab-bar-show is customized to another value afterwards they are
> available directly.

tab-bar--load-buttons and tab-bar--define-keys are called anyway
when enabling the tab bar with tab-bar-mode.  So these two functions
could be called only in tab-bar-mode, but afterwards when
it's already enabled, there is no need to call them again.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 11 Feb 2021 17:34:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 11 12:34:53 2021
Received: from localhost ([127.0.0.1]:59229 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAFrh-0007fh-1w
	for submit <at> debbugs.gnu.org; Thu, 11 Feb 2021 12:34:53 -0500
Received: from mail-qt1-f182.google.com ([209.85.160.182]:36309)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lAFrc-0007fS-DK
 for 46299 <at> debbugs.gnu.org; Thu, 11 Feb 2021 12:34:51 -0500
Received: by mail-qt1-f182.google.com with SMTP id o21so4749807qtr.3
 for <46299 <at> debbugs.gnu.org>; Thu, 11 Feb 2021 09:34:48 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=OssLfc0XL6F+dDhH8co+y26Q6Ja8X5mk5WKJHRlTc6k=;
 b=jlV88XXChOm2cFDc1MCqb+BGBJbXpTHBkHat3QsxHDW7vuA5AhPrjxMaxovQZtWk5E
 jdH1J6Ub6CCzqFCt1vf2/KOtMrlFUo3CRx52kntFTWEpev0lkreufLnPspjw+r1PGkx5
 vJklB0h2DX7xCr/XmiCWRWOhPV564nnLktyNwFz/z4JfiNyziAqMzIDXsFRz2rATRwaR
 NGSHGq3QHyNaYVB9ws45NV1yPpofDUfchSeRMVtP5vZdtESjnMoefnitYGpCayWi4cyi
 0l0+MCmgKlu4CrsZXet3ekCl4QmkBtVE7hUJctlrmYLed97Dc1s14NnCDKfkNum9/Cqh
 sDjg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=OssLfc0XL6F+dDhH8co+y26Q6Ja8X5mk5WKJHRlTc6k=;
 b=uPdRK4Au5DfVaNthyIUJ/r2V62idn/8ck6nUVgv2QIN/+EdoaR2SKutrXn7a130r2m
 UIh5gti+RRuy/BoY5E7ShH35A7WJTQz2nPDc9tomoqsQkDdSruzsnoh1ibtUHVy4DCqv
 XKLaFaYlweiblkaXIyh4ZIZ4L9RydkGAoG0W1xc5HNiLdp/ipgAVmPKfLeiYnkdHakT1
 wzfZLKof8w8TpS4yC1E6JfOCyGe/1IJyT6BmSoiTJCmrnw9NqPSclsjY9BVnDUrOgz02
 MNS50YbM8BXZH3dwslcjp9nXxmUP2ey5LWcBnHOtG3r/xEnDrQ6w5kBqL9Rxt1HdbBgH
 Ij7g==
X-Gm-Message-State: AOAM533DzaqTSFjDSEBCr0qyBZq57hC1aW3jOSJaB2E46jwLZgO0+m58
 HnyZMy63oCMnVon+Z0WW7mZhEyARTXQu15yX6tg=
X-Google-Smtp-Source: ABdhPJyLAUmUfJmLKZf0i0sTvIVu3IxOo2WFjZwc95pqOtonVHvxOIDbmKytLoWxj9uwPBU/l1jDjMkwqAT2iehpD98=
X-Received: by 2002:a05:622a:109:: with SMTP id
 u9mr8430337qtw.116.1613064882628; 
 Thu, 11 Feb 2021 09:34:42 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
 <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
In-Reply-To: <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Thu, 11 Feb 2021 18:34:26 +0100
Message-ID: <CAK9AuB8J0ZO0XYme1EHXZ_Tm30H5wBqtyBPtNTFg1VuRj0gWMg@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="00000000000054485205bb12ef7a"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--00000000000054485205bb12ef7a
Content-Type: text/plain; charset="UTF-8"

On Thu, Feb 11, 2021 at 1:14 PM Bastian Beranek
<bastian.beischer@HIDDEN> wrote:
>
> Hello Juri,
>
> I have updated my patch (see v6 attached). Please find my comments inline.
>
> I have also finished the copyright assignment procedure now.
>
> On Wed, Feb 10, 2021 at 7:41 PM Juri Linkov <juri@HIDDEN> wrote:
> > I don't know if Martin will agree, but most frame functions
> > interpret their optional FRAME argument in such a way that
> > if it's nil or omitted, FRAME defaults to the selected frame.
> >
> > For example, 'set-frame-font' documents this:
> >
> >   If FRAMES is nil, apply the font to the selected frame only.
> >   If FRAMES is non-nil, it should be a list of frames to act upon,
> >   or t meaning all existing graphical frames.
> >
> > and uses such implementation:
> >
> >    (let ((frame-lst (cond ((null frames)
> >                            (list (selected-frame)))
> >                           ((eq frames t)
> >                            (frame-list))
> >                           (t frames))))
> >       (dolist (f frame-lst)
>
> That's true and I noticed this inconsistency as well. So thanks for
> the suggestion, I have updated the patch accordingly.
>
> On Wed, Feb 10, 2021 at 7:41 PM Juri Linkov <juri@HIDDEN> wrote:
> >
> > > Hope this is satisfactory, if not please feel free to adjust as you wish.
> >
> > Thanks, please see more comments:
> >
> > > +(defun tab-bar--tab-bar-lines-for-frame (frame)
> > > +  (if (not tab-bar-mode)
> > > +      0
> > > +    (cond
> > > +     ((eq tab-bar-show t) 1)
> > > +     ((natnump tab-bar-show)
> > > +      (if (> (length (funcall tab-bar-tabs-function frame)) tab-bar-show) 1 0))
> > > +     (t 0))))
> >
> > A small optimization:
> >
> >   ((not tab-bar-mode) 0)
> >
> > could be added as the first condition of the same 'cond'.
>
> Thanks! Done.
>
> >
> > >    :set (lambda (sym val)
> > >           (set-default sym val)
> > >           ;; Preload button images
> > > +         ;; Note: tab-bar-mode updates tab-bar-lines as well.
> > > +         (tab-bar-mode 1))
> >
> > Not sure whether the users would want to enable tab-bar-mode
> > unconditionally after customizing tab-bar-show.
> >
> > Maybe when customized tab-bar-show to nil, only call
> > tab-bar--update-tab-bar-lines in all frames?
> > Or maybe simply to disable the tab bar with (tab-bar-mode 0)
> > when customized to nil?
>
> I am not sure either. I think the best is to just leave tab-bar-mode
> as it is to be honest. All this entanglement doesn't seem very clean
> to me. Yes this would mean that the user needs to manually enable
> tab-bar-mode after customizing the variable, but on the other hand
> tab-bar-mode is on by default, so the user must have switched it off
> in his .emacs by choice. So I just added the call the
> tab-bar--update-tab-bar-lines for all frames, because this is
> necessary for sure. On the other hand I don't fully understand the
> comment about 'Preload button images'. I think the images and
> keybindings are loaded when tab-bar-mode is switched on and afterwards
> whenever a new tab is created in tab-bar-new-to, so it seems
> independent of tab-bar-show. When tab-bar-show is customized they are
> either already loaded because tab-bar-mode is on, or if it is not they
> are not required and will be loaded when tab-bar-mode is activated.

I was wrong about the "tab-bar-mode is on by default" part, so maybe I
like your suggestion more. I added:

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 7afbb96212..93573d8a75 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -276,8 +276,9 @@ tab-bar-show
  :initialize 'custom-initialize-default
  :set (lambda (sym val)
         (set-default sym val)
-         ;; Recalculate tab-bar-lines for all frames
-         (tab-bar--update-tab-bar-lines t))
+         (if val
+             (tab-bar-mode 1)
+           (tab-bar--update-tab-bar-lines t)))
  :group 'tab-bar
  :version "27.1")

with respect to v6, v7 is attached.

>
> >
> > > @@ -852,16 +867,15 @@ After the tab is created, the hooks in
> > > +    ;; Switch on tab-bar-mode, since a tab was created
> > > +    (when tab-bar-show
> > >        (tab-bar-mode 1))
> > > +
> > > +    ;; Recalculate tab-bar-lines and update frames
> > > +    (tab-bar--update-tab-bar-lines (selected-frame))
> > > +    (when tab-bar-mode
> > > +      (tab-bar--load-buttons)
> > > +      (tab-bar--define-keys))
> >
> > Would you agree that here in tab-bar-new-tab-to, the first call of
> > tab-bar-mode should already do all these calls: tab-bar--update-tab-bar-lines,
> > tab-bar--load-buttons, tab-bar--define-keys?  So maybe it should be
> > sufficient just to leave these 2 lines here:
> >
> >     (when tab-bar-show
> >        (tab-bar-mode 1))
>
> Yes I agree that tab-bar--update-tab-bar-lines is not needed. It
> happens in the line before when tab-bar-show is not nil and doesn't
> matter otherwise. I have left these two lines, though:
>
>     (when tab-bar-mode
>       (tab-bar--load-buttons)
>       (tab-bar--define-keys))
>
> Because I think defining the keys is useful even if tab-bar-show is
> nil, so you can switch to another tab using the key bindings even if
> you can't see the tab-bar. As for the buttons, I think it makes sense
> to load them so that in case tab-bar-show is customized to another
> value afterwards they are available directly.

--00000000000054485205bb12ef7a
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v7.patch"
Content-Disposition: attachment; filename="tab-bar_v7.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kl155n980>
X-Attachment-Id: f_kl155n980
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==
--00000000000054485205bb12ef7a--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 11 Feb 2021 12:15:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 11 07:15:18 2021
Received: from localhost ([127.0.0.1]:57958 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAAsQ-0001wi-AT
	for submit <at> debbugs.gnu.org; Thu, 11 Feb 2021 07:15:18 -0500
Received: from mail-qk1-f182.google.com ([209.85.222.182]:39450)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1lAAsN-0001wS-FE
 for 46299 <at> debbugs.gnu.org; Thu, 11 Feb 2021 07:15:16 -0500
Received: by mail-qk1-f182.google.com with SMTP id h8so4869825qkk.6
 for <46299 <at> debbugs.gnu.org>; Thu, 11 Feb 2021 04:15:15 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=hIzpnYFFNFdgNgabu/kS0aDGGZbPMkPZW81P9psIKZY=;
 b=R9tqyCc8EBleCTlQx4mSXQHRKz1fN9r3jmV0PFoRoVA7gPovNRFjsuX1hh3dxRCWkD
 Xs9iunb0GBRKT9YQ+F5SltOTUkBFdL6m2rpQRLMieogN/zQsqsz2AGTbkRjSJ1PMIRW9
 1xEwS06z3CaXdWJDsZf3RgEJrS/lnrxr3eLv7ZCNm5lKqbHrg2o23w4b8iDwHWL+crt1
 DzpqK2G7uOmYXL28nxwt/02zYP2kDh+AGujbY3qXGmsy9vX9sjX9BQfcQKa07NEvX8Wi
 3A5I3di+2YTnXddkA7wCvLitkGGttaV7K9vP7Ko3C/8TaXDhautJJ2tUbyV6X5zT1UPg
 szQQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=hIzpnYFFNFdgNgabu/kS0aDGGZbPMkPZW81P9psIKZY=;
 b=ozImhk4ckQmKUBNxUny1HlBo3eYMISpf+nt9i7QEDtJNDHDfJsvfg35K9N4BtPzJyH
 mPwsY6pUU+8TD9SUsjOcku29zzLJpXIPwGcgbS2Etcdq9KxoTpq8pDAT+IMB8qc0CQQ8
 ew6b+OIHNBVlhhkVGfuvQR0wm9/Jk9anODlRiVHAVxgnFZ99qsZpt/qNC8fkH+LRn1Iz
 mdOTSSjxa4xoNHZunbJc4EizZDWurIvV6U4rRCeEcaQycusTfzZPyBnbsdzCOTCSoGYU
 e4zOOgu+XrOU4Me5MjD8kDXWM2Gr3iV8QrewWpknQnhqSuR+t6HUEhnJga+GtZcDkWQF
 W6rQ==
X-Gm-Message-State: AOAM531S0ltOMRm0ticwI3EX/P7LSPzowoaLnS7Lfbec5/yOeD6xxVDz
 i261pl7rpm/zay0nZwdJwWHJrnElE6iyYmytUHn4MwI9m9IPlQ==
X-Google-Smtp-Source: ABdhPJwfC5o5pjEEW5LXrFuHUtqmu0qGS5ne+jAO7oJvL39+OVVeStnOH0P4M+XxRexS7HFFjw5Ej4BHXmO+ObMU7SY=
X-Received: by 2002:a05:620a:881:: with SMTP id
 b1mr8080900qka.149.1613045709824; 
 Thu, 11 Feb 2021 04:15:09 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87tuqjydku.fsf@HIDDEN>
In-Reply-To: <87tuqjydku.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Thu, 11 Feb 2021 13:14:53 +0100
Message-ID: <CAK9AuB-xM+Nd=49Fm4s_3pfapP=RgbKZfn+4jbNT-sT0crWjWg@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000008a89fd05bb0e78f2"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000008a89fd05bb0e78f2
Content-Type: text/plain; charset="UTF-8"

Hello Juri,

I have updated my patch (see v6 attached). Please find my comments inline.

I have also finished the copyright assignment procedure now.

On Wed, Feb 10, 2021 at 7:41 PM Juri Linkov <juri@HIDDEN> wrote:
> I don't know if Martin will agree, but most frame functions
> interpret their optional FRAME argument in such a way that
> if it's nil or omitted, FRAME defaults to the selected frame.
>
> For example, 'set-frame-font' documents this:
>
>   If FRAMES is nil, apply the font to the selected frame only.
>   If FRAMES is non-nil, it should be a list of frames to act upon,
>   or t meaning all existing graphical frames.
>
> and uses such implementation:
>
>    (let ((frame-lst (cond ((null frames)
>                            (list (selected-frame)))
>                           ((eq frames t)
>                            (frame-list))
>                           (t frames))))
>       (dolist (f frame-lst)

That's true and I noticed this inconsistency as well. So thanks for
the suggestion, I have updated the patch accordingly.

On Wed, Feb 10, 2021 at 7:41 PM Juri Linkov <juri@HIDDEN> wrote:
>
> > Hope this is satisfactory, if not please feel free to adjust as you wish.
>
> Thanks, please see more comments:
>
> > +(defun tab-bar--tab-bar-lines-for-frame (frame)
> > +  (if (not tab-bar-mode)
> > +      0
> > +    (cond
> > +     ((eq tab-bar-show t) 1)
> > +     ((natnump tab-bar-show)
> > +      (if (> (length (funcall tab-bar-tabs-function frame)) tab-bar-show) 1 0))
> > +     (t 0))))
>
> A small optimization:
>
>   ((not tab-bar-mode) 0)
>
> could be added as the first condition of the same 'cond'.

Thanks! Done.

>
> >    :set (lambda (sym val)
> >           (set-default sym val)
> >           ;; Preload button images
> > +         ;; Note: tab-bar-mode updates tab-bar-lines as well.
> > +         (tab-bar-mode 1))
>
> Not sure whether the users would want to enable tab-bar-mode
> unconditionally after customizing tab-bar-show.
>
> Maybe when customized tab-bar-show to nil, only call
> tab-bar--update-tab-bar-lines in all frames?
> Or maybe simply to disable the tab bar with (tab-bar-mode 0)
> when customized to nil?

I am not sure either. I think the best is to just leave tab-bar-mode
as it is to be honest. All this entanglement doesn't seem very clean
to me. Yes this would mean that the user needs to manually enable
tab-bar-mode after customizing the variable, but on the other hand
tab-bar-mode is on by default, so the user must have switched it off
in his .emacs by choice. So I just added the call the
tab-bar--update-tab-bar-lines for all frames, because this is
necessary for sure. On the other hand I don't fully understand the
comment about 'Preload button images'. I think the images and
keybindings are loaded when tab-bar-mode is switched on and afterwards
whenever a new tab is created in tab-bar-new-to, so it seems
independent of tab-bar-show. When tab-bar-show is customized they are
either already loaded because tab-bar-mode is on, or if it is not they
are not required and will be loaded when tab-bar-mode is activated.

>
> > @@ -852,16 +867,15 @@ After the tab is created, the hooks in
> > +    ;; Switch on tab-bar-mode, since a tab was created
> > +    (when tab-bar-show
> >        (tab-bar-mode 1))
> > +
> > +    ;; Recalculate tab-bar-lines and update frames
> > +    (tab-bar--update-tab-bar-lines (selected-frame))
> > +    (when tab-bar-mode
> > +      (tab-bar--load-buttons)
> > +      (tab-bar--define-keys))
>
> Would you agree that here in tab-bar-new-tab-to, the first call of
> tab-bar-mode should already do all these calls: tab-bar--update-tab-bar-lines,
> tab-bar--load-buttons, tab-bar--define-keys?  So maybe it should be
> sufficient just to leave these 2 lines here:
>
>     (when tab-bar-show
>        (tab-bar-mode 1))

Yes I agree that tab-bar--update-tab-bar-lines is not needed. It
happens in the line before when tab-bar-show is not nil and doesn't
matter otherwise. I have left these two lines, though:

    (when tab-bar-mode
      (tab-bar--load-buttons)
      (tab-bar--define-keys))

Because I think defining the keys is useful even if tab-bar-show is
nil, so you can switch to another tab using the key bindings even if
you can't see the tab-bar. As for the buttons, I think it makes sense
to load them so that in case tab-bar-show is customized to another
value afterwards they are available directly.

--0000000000008a89fd05bb0e78f2
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v6.patch"
Content-Disposition: attachment; filename="tab-bar_v6.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kl0tl6cl0>
X-Attachment-Id: f_kl0tl6cl0
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--0000000000008a89fd05bb0e78f2--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 10 Feb 2021 18:41:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 10 13:41:55 2021
Received: from localhost ([127.0.0.1]:57223 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9uR0-0003gE-UQ
	for submit <at> debbugs.gnu.org; Wed, 10 Feb 2021 13:41:55 -0500
Received: from relay8-d.mail.gandi.net ([217.70.183.201]:55693)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l9uQy-0003fn-30
 for 46299 <at> debbugs.gnu.org; Wed, 10 Feb 2021 13:41:53 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay8-d.mail.gandi.net (Postfix) with ESMTPSA id 874221BF203;
 Wed, 10 Feb 2021 18:41:43 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
Date: Wed, 10 Feb 2021 20:24:49 +0200
In-Reply-To: <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 (Bastian Beranek's message of "Tue, 9 Feb 2021 12:44:47 +0100")
Message-ID: <87tuqjydku.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Hope this is satisfactory, if not please feel free to adjust as you wish.

Thanks, please see more comments:

> +(defun tab-bar--tab-bar-lines-for-frame (frame)
> +  (if (not tab-bar-mode)
> +      0
> +    (cond
> +     ((eq tab-bar-show t) 1)
> +     ((natnump tab-bar-show)
> +      (if (> (length (funcall tab-bar-tabs-function frame)) tab-bar-show) 1 0))
> +     (t 0))))

A small optimization:

  ((not tab-bar-mode) 0)

could be added as the first condition of the same 'cond'.

>    :set (lambda (sym val)
>           (set-default sym val)
>           ;; Preload button images
> +         ;; Note: tab-bar-mode updates tab-bar-lines as well.
> +         (tab-bar-mode 1))

Not sure whether the users would want to enable tab-bar-mode
unconditionally after customizing tab-bar-show.

Maybe when customized tab-bar-show to nil, only call
tab-bar--update-tab-bar-lines in all frames?
Or maybe simply to disable the tab bar with (tab-bar-mode 0)
when customized to nil?

> @@ -852,16 +867,15 @@ After the tab is created, the hooks in
> +    ;; Switch on tab-bar-mode, since a tab was created
> +    (when tab-bar-show
>        (tab-bar-mode 1))
> +
> +    ;; Recalculate tab-bar-lines and update frames
> +    (tab-bar--update-tab-bar-lines (selected-frame))
> +    (when tab-bar-mode
> +      (tab-bar--load-buttons)
> +      (tab-bar--define-keys))

Would you agree that here in tab-bar-new-tab-to, the first call of
tab-bar-mode should already do all these calls: tab-bar--update-tab-bar-lines,
tab-bar--load-buttons, tab-bar--define-keys?  So maybe it should be
sufficient just to leave these 2 lines here:

    (when tab-bar-show
       (tab-bar-mode 1))




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 10 Feb 2021 18:41:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 10 13:41:51 2021
Received: from localhost ([127.0.0.1]:57220 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9uQx-0003fz-Mj
	for submit <at> debbugs.gnu.org; Wed, 10 Feb 2021 13:41:51 -0500
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:60999)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l9uQv-0003fj-Ez
 for 46299 <at> debbugs.gnu.org; Wed, 10 Feb 2021 13:41:50 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id B225760005;
 Wed, 10 Feb 2021 18:41:41 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
Date: Wed, 10 Feb 2021 20:20:56 +0200
In-Reply-To: <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 (Bastian Beranek's message of "Tue, 9 Feb 2021 09:15:50 +0100")
Message-ID: <87blcr2343.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>>  > +  "Update frame parameter tab-bar-line.
>>  > +When the optional frame parameter is omitted all frames as well
>>  > +as the default for new frames are updated. Otherwise only the
>>  > +given frame is modified."
>>
>> This is confusing wrt our parameter/argument terminology.  Please just
>> say "FRAME" wherever it stands for the function's argument and use
>> "parameter of FRAME" when you talk about the frame parameter.
>
> I'll do my best to update the docstring. Note that I do not contribute
> to emacs often, nor do I regularly code in elisp, so I'm not familiar
> with the conventions and you are encouraged to modify my changes as
> you see fit.

I don't know if Martin will agree, but most frame functions
interpret their optional FRAME argument in such a way that
if it's nil or omitted, FRAME defaults to the selected frame.

For example, 'set-frame-font' documents this:

  If FRAMES is nil, apply the font to the selected frame only.
  If FRAMES is non-nil, it should be a list of frames to act upon,
  or t meaning all existing graphical frames.

and uses such implementation:

   (let ((frame-lst (cond ((null frames)
                           (list (selected-frame)))
                          ((eq frames t)
                           (frame-list))
                          (t frames))))
      (dolist (f frame-lst)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 19:08:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 14:08:43 2021
Received: from localhost ([127.0.0.1]:54658 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9YNP-0002Xp-I3
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 14:08:43 -0500
Received: from eggs.gnu.org ([209.51.188.92]:35040)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1l9YNO-0002Xc-75
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 14:08:42 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53476)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1l9YNE-000342-Ly; Tue, 09 Feb 2021 14:08:33 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1089
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1l9YMy-0001kJ-P7; Tue, 09 Feb 2021 14:08:31 -0500
Date: Tue, 09 Feb 2021 21:08:15 +0200
Message-Id: <83lfbxjbz4.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
In-Reply-To: <CAK9AuB9LmDHrqBJCyPtL2ZBvurHrfJhUfbCb4hPPy3omEZLSpA@HIDDEN>
 (message from Bastian Beranek on Tue, 9 Feb 2021 19:46:14 +0100)
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87lfbx3yls.fsf@HIDDEN>
 <CAK9AuB9LmDHrqBJCyPtL2ZBvurHrfJhUfbCb4hPPy3omEZLSpA@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: rudalics@HIDDEN, larsi@HIDDEN, 46299 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Bastian Beranek <bastian.beischer@HIDDEN>
> Date: Tue, 9 Feb 2021 19:46:14 +0100
> Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
> 
> Eli, Lars, what do you think? Since I already contributed a few
> patches I would guess I need to assign copyright. I am fine with that,
> maybe it's time to do it even if my contribution could be accepted
> without. Could you please send me the form?

Sent off-list.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 19:02:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 14:02:02 2021
Received: from localhost ([127.0.0.1]:54651 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9YGv-0002OT-Nq
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 14:02:02 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33050)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1l9YGt-0002Ne-EM
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 14:01:59 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53214)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1l9YGm-0001IF-Kp; Tue, 09 Feb 2021 14:01:53 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4662
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1l9YGk-0004df-05; Tue, 09 Feb 2021 14:01:51 -0500
Date: Tue, 09 Feb 2021 21:01:48 +0200
Message-Id: <83o8gtjc9v.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-Reply-To: <87lfbx3yls.fsf@HIDDEN> (message from Juri Linkov on
 Tue, 09 Feb 2021 20:06:07 +0200)
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87lfbx3yls.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, bastian.beischer@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Juri Linkov <juri@HIDDEN>
> Date: Tue, 09 Feb 2021 20:06:07 +0200
> Cc: 46299 <at> debbugs.gnu.org
> 
> > Do I need to do the contribution paperworks for this patch? So far I
> > haven't done that.
> 
> I don't know.  Please ask Eli or Lars if your contributions
> fit into the updated rule in https://debbugs.gnu.org/44834#73

They definitely exceed the threshold.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 18:46:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 13:46:40 2021
Received: from localhost ([127.0.0.1]:54612 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9Y24-0001NT-18
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 13:46:40 -0500
Received: from mail-qv1-f51.google.com ([209.85.219.51]:46844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l9Y1z-0001GC-Ly
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 13:46:38 -0500
Received: by mail-qv1-f51.google.com with SMTP id a1so9150177qvd.13
 for <46299 <at> debbugs.gnu.org>; Tue, 09 Feb 2021 10:46:35 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=wr1s2J07NXZGVTW1M890bcFKMasvxI6RRVi9vmcERos=;
 b=dgOKkcyTX+hdiyhT6ZnV8P7MGZJYwLUxusH504CwjwX79oXhXS7Pi+YbW8+ZKRvq2u
 OQjAhqc4WhZ5J11qFilRKz3m4CqZFbTLubEA7v58g9zxlNs+Io+TXp0tU6SfWHeOeTaz
 6i0MwN2Xwtvo22c8WNnLNXxkDpIYLd0HZNwMKl0msJJnJo3GM2tds/hllqbbh22WL3rU
 +AQe/rjmiDEAlx6gj1E7xm8iKtSjtxwEx47FMLZEPhY5Axf6uuTdGk9/4EoN0401apcT
 AtJKcOQe3it6KmOTtZ3APESBusndAsmZ1Hd76lXgrHJ0RxAazJmVNRg9KgDVbiN/vEk+
 5URA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=wr1s2J07NXZGVTW1M890bcFKMasvxI6RRVi9vmcERos=;
 b=ebyiZ7JZDEsiIzUhRGI+LiDf7cuQRKmUxsdjdkCz433SJlcBHJXCvPNycWDucoHnCj
 fj6p1/cw5aERvawAdb9OypNaJff4PqblFH+42lswZXPbsUQX8OQw+LmLHNFx4LnOEhDa
 DriV81gbkU8cx7FOT1Tx1IP5x/EsZ6QsLwLVOuJJqOnw/QxO03wW41OOiKTVfOtHb0Hw
 1ckU6bvjXqA8PQM+PYboVZscUIWxBbwZi5SlCBItocfvvYOwAxhnjtqV8T9CqncSbeEU
 OI2H3KpG2Q+1s/GskL/L+1s41/WO8QPgPS2dMRUnqi25GO7r2LP6V5NWcf6FwmOHStYp
 L9/A==
X-Gm-Message-State: AOAM531tHgFuYFkdLeBp01z5MeXL/+ERaCZ1tMAdDBpup8KuMartFY65
 xzho/pWmXr7xbVQRR9cIdLI146USQxJWab76Y/g=
X-Google-Smtp-Source: ABdhPJz+Lwtn87qIVLUZCh4PSHgxfTZOPMw8O6p4UPedbhNvOlV0JcNg3TonKGX1IURBaFRl6dkOw6mWFbsVXRqfI/c=
X-Received: by 2002:a05:6214:2ce:: with SMTP id
 g14mr7141967qvu.12.1612896390003; 
 Tue, 09 Feb 2021 10:46:30 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 <87lfbx3yls.fsf@HIDDEN>
In-Reply-To: <87lfbx3yls.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Tue, 9 Feb 2021 19:46:14 +0100
Message-ID: <CAK9AuB9LmDHrqBJCyPtL2ZBvurHrfJhUfbCb4hPPy3omEZLSpA@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Tue, Feb 9, 2021 at 7:15 PM Juri Linkov <juri@HIDDEN> wrote:
>
> > I don't think tab-bar-mode can vary from frame to frame?
>
> Indeed, currently tab-bar-mode is global, but not frame-local.
> It's just a convenient way to enable the tab-bar without creating
> a new tab first (when tab-bar-show is t).  Another convenience of
> tab-bar-mode is enabling the C-TAB keybindings for switching tabs.
>
> > Hope this is satisfactory, if not please feel free to adjust as you wish.
>
> Thanks, looks nice, but needs a little more testing with different settings.
>

Thanks. I have been running it myself for a while now and didn't
notice anything, but more testing is always good!

> > Do I need to do the contribution paperworks for this patch? So far I
> > haven't done that.
>
> I don't know.  Please ask Eli or Lars if your contributions
> fit into the updated rule in https://debbugs.gnu.org/44834#73

Eli, Lars, what do you think? Since I already contributed a few
patches I would guess I need to assign copyright. I am fine with that,
maybe it's time to do it even if my contribution could be accepted
without. Could you please send me the form?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 18:15:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 13:15:33 2021
Received: from localhost ([127.0.0.1]:54551 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9XXw-0007Zn-Nl
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 13:15:33 -0500
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:48351)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l9XXv-0007ZH-0f
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 13:15:31 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay7-d.mail.gandi.net (Postfix) with ESMTPSA id 287DE2000A;
 Tue,  9 Feb 2021 18:15:22 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
Date: Tue, 09 Feb 2021 20:06:07 +0200
In-Reply-To: <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
 (Bastian Beranek's message of "Tue, 9 Feb 2021 12:44:47 +0100")
Message-ID: <87lfbx3yls.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: martin rudalics <rudalics@HIDDEN>, 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> I don't think tab-bar-mode can vary from frame to frame?

Indeed, currently tab-bar-mode is global, but not frame-local.
It's just a convenient way to enable the tab-bar without creating
a new tab first (when tab-bar-show is t).  Another convenience of
tab-bar-mode is enabling the C-TAB keybindings for switching tabs.

> Hope this is satisfactory, if not please feel free to adjust as you wish.

Thanks, looks nice, but needs a little more testing with different settings.

> Do I need to do the contribution paperworks for this patch? So far I
> haven't done that.

I don't know.  Please ask Eli or Lars if your contributions
fit into the updated rule in https://debbugs.gnu.org/44834#73




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 17:32:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 12:32:50 2021
Received: from localhost ([127.0.0.1]:54489 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9Wsc-0006W3-04
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 12:32:50 -0500
Received: from mout.gmx.net ([212.227.17.21]:41381)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1l9Wsa-0006Vr-MC
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 12:32:49 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1612891961;
 bh=Ti+VkzbTn4WCgBPhOwXfpDN183gAf9Og2VCZagL/VEQ=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=IpsTpuyYLVuu1lc8WYXeagTNZzBY4bsqbrw1JNvy9wE+mtB+9sBSFgnO+iZeqnZwZ
 UUxS2d4H8UJOsLPSrXHqnvMDupT0llTTjQEhFAx0qXzbNneXujR8pWBEElaMRWtDd8
 R1b/cnSRq4/Z4qABpxu1qScuuhKre/lx6v+qkjyw=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.34]) by mail.gmx.net (mrgmx105
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MkYbu-1lcZpH1h4I-00lz9m; Tue, 09
 Feb 2021 18:32:41 +0100
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
To: Bastian Beranek <bastian.beischer@HIDDEN>
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
 <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <36d11d41-5783-109b-2add-e1724181a184@HIDDEN>
Date: Tue, 9 Feb 2021 18:32:40 +0100
MIME-Version: 1.0
In-Reply-To: <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:vYM5kmMyCAqFCzTG3M9h0inPUZr30GbL2blvnMO2RHqEnHRpiya
 FEr09gHWYo7mxLXATHqj51Y8iCH+HMudH1vi1tkX5TuL//9hBbXK3Xe5ph0lNdeyI0Rat1B
 ZehcoX68g1DlvPveUUCEnWT+zDVdh5dO2BDk87lormjbsQkGVRsK6+3bQZlcgfkEwot+Hm3
 LssCrLWTiVr4G9FOy052w==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:qG22TRws0/g=:B9bM/Z6gFUO93jTbHW7Ru7
 470Kb96BmOExO+LkNuMf00j2uwHP/coWtyvSE+Bb5gO2kPxysRZKUk3Ejq5rqRxhfnoVuuT/y
 qNF89nY31qMpjQ6SDSmmo5UFquVBQ/l7napHrMz0N37UmYuhmDq1+RF4sS+StTrLjkuHG0RUh
 egXY452UrZbo064gSggVrEqQ3ACkQvSfDcFSkJfDedaNqbuqBeQmUBYSp+7+8pPRLBzT98JjX
 ErqM75akLZyi6KWceROimnw/Hs7heR3hP8oa88uHI8OrrTS4oVkgw4j6YnGIHZEWL0QRZ+JRa
 JLDFVRlkFhNYyi31/4z0UViogT1v308j/3bacrzD1VlnoD+eKT0XeFBfoF3K5zfWxQPL47b/N
 HBioAgoEgi8ugj2hpyy16mOrwplwHGKmpObDBg0lAn3uaOZoSvozFpNhJdpShQY8Y8+0x6zmg
 n7gcFdG7QI3OCjGP4Vy+c7yjVl7tacWLiJbqD8FkrpubxIoRrljuy8Hz8XodsOBusyhjS2lcq
 32/rNDdzHh/gBJsl9MOITZ0tjJvctCNpQ3HxwCLuJOg8Q7bm7wXp2zwCyqO0xjWKRmI0jb/Di
 bQ2f2CswvtUH94sxz9AWdneFhKtLXAoJOIVzNI0/4oEa/C25fSKBv2zx06XPUWtTtwPA+gjKi
 MYvcO6O6O6OZa98fVedtE8/VR0ze9+AQc4rMJiw4ZDKhArxO3mIfnURGKv9jmiuQria1LWC52
 e5e3FsQ62pbs/hg8uQ+GAaoLovt+Ov/KUzRL+JGWUeKuy059IkhfdD3ZdBOa5YdwajZ1HpX/A
 7wMaySNZTMPDVsr3BCkuwGV/i8tdJHqXi/GC3mByqdoH0osOO+NgwzYAIbqVqX2k6tV0whTux
 Gq/F5DdOCsOb0P3nSecA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > (defun tab-bar--tab-bar-lines-for-frame (frame)
 >    "Determine and return the value of `tab-bar-lines' for FRAME.
 > Return 0 if `tab-bar-mode' is not enabled.  Otherwise return
 > either 1 or 0 depending on the value of the customizable variable
 > `tab-bar-show', which see."

Fine with me.

 > I don't think tab-bar-mode can vary from frame to frame?

I think only the 'tab-bar-lines' parameter can vary.

 > I also did
 > not add the "Call this function" part, because this is an internal
 > helper function that is only used from
 > "tab-bar--update-tab-bar-lines", just below. It just returns 0 or 1
 > and does not modify anything, the actual frame parameter modification
 > happens in the other function.
 >
 > Hope this is satisfactory, if not please feel free to adjust as you wish.

I leave that to Juri.

 > Do I need to do the contribution paperworks for this patch? So far I
 > haven't done that.

I suppose you need to do that.

Thanks, martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 11:45:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 06:45:12 2021
Received: from localhost ([127.0.0.1]:52797 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9RSB-0002DB-OU
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 06:45:12 -0500
Received: from mail-qt1-f171.google.com ([209.85.160.171]:34404)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l9RS8-0002Cs-Ud
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 06:45:10 -0500
Received: by mail-qt1-f171.google.com with SMTP id c1so12705585qtc.1
 for <46299 <at> debbugs.gnu.org>; Tue, 09 Feb 2021 03:45:08 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=IR5TWJuDtt4jvVMFicA69kFd6Jh00UBIKcIEKSFRm1o=;
 b=NW6rVVsUdWa8d2t6nqlM2DCCoo4QagXKFF05kaSkz76uU46iGZFk5586TQnpQV42lL
 Rxa810TyahROFprLJK2K/OLz9nFFe7iTsdWNYZm80gHhqo8xSGHK+AVYy7qniUDn+I+K
 sUAFkx53UFxRecZbLng43hMs+hB+OhOzWqlItx0WDqHXFugtTFJM1zWno1sCR7Gc/iAd
 QO2utsw8CaF6OXOXx/ETZ98sY7qngt6lU99wY8plCVEvqfI0z7jLirT3ftbwHdzcH926
 hVtqvGFsxBFXgtIMkEu7dV5aSx9E1HNl7WurWeW/tngkT+VXzEKZanAVXDCYCQuwpy5m
 +WwA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=IR5TWJuDtt4jvVMFicA69kFd6Jh00UBIKcIEKSFRm1o=;
 b=FxpZKIkOeXArtp5Ng9MNYhfJLJHg+z4iUN8XTMkSoNANJ58t9FYAZA6kSKfKv7IRmC
 m4bHrKLeX4KlYv39NuSaMDOBvs2n1rTwH2vWvi5hlZcPkiIp6kxJeL/MVXxK7hU5wZy6
 IX1vW5m6gMwM3p19rhLyMb0uiUH6g7unTM32Qj8l0xQ3NSc6I5e5y+xsrid8QXjAl90e
 zvbOfd1WnG9//gc/VNmItJ9z2aZ73YHOaIdOJ0SxM1qtOMoLkQOkJBsud0dCWLYdP3J4
 nhbhKEYMf1HF+7GFJTMTXSzJmN82r9JH8yoVI+VT7CJoFuUrMwMXcdpI75ozGPx18Qcu
 fyZA==
X-Gm-Message-State: AOAM532+KBzQ0fwMmKuA/fNRn2qv77kNQG9pi3L3vGYUiRHm1WLH7P41
 Y+ki3Nvh2ojxnvKCzDpG4xsM+iknEg/soAk4ti0=
X-Google-Smtp-Source: ABdhPJyHngo8l0qRBmJDF1zeQG8HOOi7caOqRuBs/TyTqRVbIPakzyjUTc3Wz9U6OuLH5GzuCJ1mTw9oRQWCUCdHODo=
X-Received: by 2002:ac8:5cc2:: with SMTP id s2mr19349087qta.342.1612871103305; 
 Tue, 09 Feb 2021 03:45:03 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
 <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
In-Reply-To: <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Tue, 9 Feb 2021 12:44:47 +0100
Message-ID: <CAK9AuB__bOsJNWHJ4E4-8dj68r52uRn-xiy=Zn7Yn57etqCP7w@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: martin rudalics <rudalics@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000002e792d05bae5d111"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000002e792d05bae5d111
Content-Type: text/plain; charset="UTF-8"

On Tue, Feb 9, 2021 at 10:45 AM martin rudalics <rudalics@HIDDEN> wrote:
>
>  > +  "Determine the value of tab-bar-lines for FRAME.
>  > +The returned value will either be 1 or 0, meaning whether to show
>  > +the tab-bar or not. If tab-bar-mode is off, the returned value is
>  > +0. Otherwise the result depends on the value of the customizable
>  > +variable `tab-bar-show'."
>
> Please use active voice and always make sure to leave two spaces in
> front of a new sentence.  I would write it as
>
> (defun tab-bar--tab-bar-lines-for-frame (frame)
>    "Return new value of `tab-bar-lines' parameter for specified FRAME.
> Return 0 if `tab-bar-mode' is not enabled on FRAME or ....
> Return 1 if `tab-bar-mode' is enabled on FRAME and the variable
> `tab-bar-show' ...
>
> Call this function when ..."
>
> where the last sentence would describe when and why this function should
> be called, justifying the "new" in the doc-string.  Instead of "new" you
> can also use "adjusted" if the value gets just adjusted or your earlier
> "correct" provided an earlier calculation was "incorrect".

Thanks for your comments. I went with

(defun tab-bar--tab-bar-lines-for-frame (frame)
  "Determine and return the value of `tab-bar-lines' for FRAME.
Return 0 if `tab-bar-mode' is not enabled.  Otherwise return
either 1 or 0 depending on the value of the customizable variable
`tab-bar-show', which see."

Please see the attached v5 of the complete patch.

I don't think tab-bar-mode can vary from frame to frame? I also did
not add the "Call this function" part, because this is an internal
helper function that is only used from
"tab-bar--update-tab-bar-lines", just below. It just returns 0 or 1
and does not modify anything, the actual frame parameter modification
happens in the other function.

Hope this is satisfactory, if not please feel free to adjust as you wish.

Do I need to do the contribution paperworks for this patch? So far I
haven't done that.

Best
Bastian

--0000000000002e792d05bae5d111
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v5.patch"
Content-Disposition: attachment; filename="tab-bar_v5.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kkxxspht0>
X-Attachment-Id: f_kkxxspht0
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--0000000000002e792d05bae5d111--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 09:45:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 04:45:51 2021
Received: from localhost ([127.0.0.1]:52686 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9Pah-0006Jg-DF
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 04:45:51 -0500
Received: from mout.gmx.net ([212.227.15.18]:40455)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1l9Pad-00069M-8g
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 04:45:50 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1612863940;
 bh=bRz+vcRTmGiIRop2CMgiB0Q8/DGxVFR8bXD1Mq5KhGU=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=LbAWW+Hp2WcVRJIB5NYp5431JWX8qp2rBJyXMmDIixTIlKVNz35xC0X7zB/ZdHmbt
 j6l3rihgl6qSf0Qv6tf3O2AqcnOvE2KS4+CFciCWpd7HAcNqh0uH5eCUNSbn4LuCHA
 SorgZ6opnyd/tX5Fz8gvSvwI7rt+jJU1RbM/zXCk=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.34]) by mail.gmx.net (mrgmx004
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1M1poA-1lBbRr44Gu-002G0M; Tue, 09
 Feb 2021 10:45:40 +0100
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
To: Bastian Beranek <bastian.beischer@HIDDEN>
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
 <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <ef2adb55-f4b3-991a-0f3b-014bffd677e4@HIDDEN>
Date: Tue, 9 Feb 2021 10:45:39 +0100
MIME-Version: 1.0
In-Reply-To: <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:vqnD6JqBCfsBz81ShaA8F/jExlR5+b7ce72wX/Vn0jR+h8ioBjF
 uTY9aTggCSC7r42SZvF1cgCsMABudU4HP8b6uoCD9gvlhW8gXt6+Db2AP2iSfPb5teT2NcV
 Qf8DLXN2N8ac58eFZHdj29ZJExdPwTQkPvPves6wqaaZia5kLTve8E/vbiiKnlAJ4R3MX/h
 CV4zgxF8K4eiZGkMo3b/A==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:lm5aXxc/yMI=:31zSP58gcwbkXYozmALVNC
 4bdHRvChmPOlaZYJJpkZuxCgHJ9njHWgaZ7x8TERge2QX7hBSYimNcj/UE2ox8OKi5MA8OH4P
 Kbzf8ZJnydmRPL1gylnPdGV9ywxrPr0Y+Fx7clqRMuLLxiXJ2y2lSl2bLENgc8sXiSK+RKjhW
 YlSu7QR7I1h4d29QytwMVKoQu/u3AGvbBER3+uBMXu/iaFe5f8LnWGVOIMVgYAXXKmk3qX8kp
 kdLI95VPpsm37M0yHWSgxbdyY2rv+DUB/eAnN5dwpNg8g8lGKzfQLTNIRAmWka2w+dhL4KLjK
 pYbnRSbOytyWbBMEBB3udZLVB0/52WikVn/aWjynh6whVk991r8RVLeurCtfPaQQVKN66RdGI
 i6YB50UmMcGTxZ21bUiKWwZC+HZanUVbxD/ph7GL5URCpZ8MmiAuMm34Bb3+3HcecO2a1QddP
 hxGB7fFZOw1MqxuPEo1xnU/X0zgHpDZAtBTIDdN2x6ftJBBqPUaxmmLerQs9DgLZLtLCALOuq
 i1AdgP5YflYWFRizBcNQs7zRM+o9cQo6//wZ/BFQVdOKbUAh75mUoYX9eko55gjE0k7cgMZFR
 jRWBxFju5EIegLBITYiorfn2736kRmOpKqzUX0t49CaSxern1dwglCrNs+WwpyJnLwkPIvuHO
 iS0aGh5HfNtg+iNiO6KdPT6yTm+R19NRv9BR9voN6rY5WCmHkeSrtYdAam7CbpJzDxmRrev8G
 L9nmhjPnEPKUJ756dtJK9/bcMbNPst38a1W8GEGYj4DtkZCdmuM3MW5gfRt6Txt6MJdbHhKgA
 aQoVbWdrEa5Pwnca7Sfq7+8DChP8fL1OQATy24nEohohMNxtXZpt6eppuOb3xn/uZpkW9gQCi
 abkFliKK/p1TdSAPwuBQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > +  "Determine the value of tab-bar-lines for FRAME.
 > +The returned value will either be 1 or 0, meaning whether to show
 > +the tab-bar or not. If tab-bar-mode is off, the returned value is
 > +0. Otherwise the result depends on the value of the customizable
 > +variable `tab-bar-show'."

Please use active voice and always make sure to leave two spaces in
front of a new sentence.  I would write it as

(defun tab-bar--tab-bar-lines-for-frame (frame)
   "Return new value of `tab-bar-lines' parameter for specified FRAME.
Return 0 if `tab-bar-mode' is not enabled on FRAME or ....
Return 1 if `tab-bar-mode' is enabled on FRAME and the variable
`tab-bar-show' ...

Call this function when ..."

where the last sentence would describe when and why this function should
be called, justifying the "new" in the doc-string.  Instead of "new" you
can also use "adjusted" if the value gets just adjusted or your earlier
"correct" provided an earlier calculation was "incorrect".

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 09:23:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 04:23:57 2021
Received: from localhost ([127.0.0.1]:52650 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9PFV-0002oi-GR
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 04:23:57 -0500
Received: from mail-qv1-f48.google.com ([209.85.219.48]:33783)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l9PFT-0002oU-DF
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 04:23:55 -0500
Received: by mail-qv1-f48.google.com with SMTP id 2so8363386qvd.0
 for <46299 <at> debbugs.gnu.org>; Tue, 09 Feb 2021 01:23:55 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=r/XZ0CnftP72/EZb6F2jnxhmq9AlLJp78IvfWEtZqc4=;
 b=R+iKyHqYeiTN3XhxY9SaMCsUJb0VOCXxfSEM+0S21+DN6AbF49/e+YhHKPGIrRoHAB
 MDhQlktH2QhnqnqCbiNTgJEjw7TznYvthzHpIDuBTODhLf24DQOdaQZjxMgv4ldoaiSL
 8NGu5bOp1NLd8QhWCo2RwvFlMZL4ksnVTIm+xBLzh5v8wS46ORoW0FV3twDImgcBwUAe
 AlIxGedf7Dz1NeCyBXISDv4rcwVQ0V/ZxDwdgK+UM+y4MCO8YedNr5mE7KgAE+GtFlBH
 RF+9UQ4igm0l+3UjmFgsU2s2HA407xvNyvfYbUiU14hmIKVzOLkEvLcFPbbv9YlwfGLQ
 yW2A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=r/XZ0CnftP72/EZb6F2jnxhmq9AlLJp78IvfWEtZqc4=;
 b=dktgvQSwp+iNPlGQ0Ui3T0ntfdzkpXVLUsRd4qpT4/rHa/aeYaabKxEuwg5Ic+ub85
 aLq/R6BrASB5ipXzlkyysu5GMw8s3323nDS4ldhDYNimcO4QX+sBokCQBs99d5u80vfo
 hPdwgla2B6HwywECXapQ63SxyRTgsH+zAszaFU3olDtYZsNZ31KJYU/v+880ChsgMnTh
 E6O6AyzxV5diFH1vlCUHPaPeZo6tSj/gtn+odml4SsSzRqxf/Ch9qwjwNVtL48ZkWvof
 IL/FCsAaAINwU0e2+IILrx2l9OnDdOCNB7r31A5N74JhGZZ70QaUiS8pQXv5EIYpZXSO
 KIEA==
X-Gm-Message-State: AOAM532sE2maa2yPIAyYOYSDea3XpVWNPq3jX7N87qN95V3upe+oyQys
 NGUjbbj0Ec1n1G1OFq5EVphlo/1w1kYvKOggIGc=
X-Google-Smtp-Source: ABdhPJwILZhfM2XfnZCBASbuAUH1/QqPUFagSybTEji/CO6xJXhhCkSUKixrkOQRUe5ryIojldE6leMluunMBGjryuI=
X-Received: by 2002:a0c:b49f:: with SMTP id c31mr19980890qve.35.1612862629710; 
 Tue, 09 Feb 2021 01:23:49 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
 <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
In-Reply-To: <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Tue, 9 Feb 2021 10:23:33 +0100
Message-ID: <CAK9AuB8Cu+MU3twKs7iCez=vu2P1RrUz+f-X_aZMwB_8c8qsXg@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: martin rudalics <rudalics@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello Martin,

On Tue, Feb 9, 2021 at 9:58 AM martin rudalics <rudalics@HIDDEN> wrote:
>
>  > I'll do my best to update the docstring. Note that I do not contribute
>  > to emacs often, nor do I regularly code in elisp, so I'm not familiar
>  > with the conventions and you are encouraged to modify my changes as
>  > you see fit.
>
> Don't worry.  These "-lines" frame parameters are a minefield - we just
> should try to clarify things the best possible way while you're working
> on it.

I see.

>
>  > (defun tab-bar--tab-bar-lines-for-frame (frame)
>  > -  "Compute the correct value of tab-bar-lines for the given frame."
>  > +  "Compute the correct value of tab-bar-lines for FRAME."
>
> But what "is" the correct value and why and how would we want to
> "compute" it?

How about this:

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 9666fb2460..1fc8537ccf 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -135,7 +135,11 @@ Possible modifier keys are `control', `meta',
`shift', `hyper', `super' and
                         tab-bar-close-button)))

(defun tab-bar--tab-bar-lines-for-frame (frame)
-  "Compute the correct value of tab-bar-lines for the given frame."
+  "Determine the value of tab-bar-lines for FRAME.
+The returned value will either be 1 or 0, meaning whether to show
+the tab-bar or not. If tab-bar-mode is off, the returned value is
+0. Otherwise the result depends on the value of the customizable
+variable `tab-bar-show'."
  (if (not tab-bar-mode)
      0
    (cond
@@ -145,10 +149,10 @@ Possible modifier keys are `control', `meta',
`shift', `hyper', `super' and
     (t 0))))

(defun tab-bar--update-tab-bar-lines (&optional frame)
-  "Update frame parameter tab-bar-line.
-When the optional frame parameter is omitted all frames as well
-as the default for new frames are updated. Otherwise only the
-given frame is modified."
+  "Update the tab-bar-line parameter in frames.
+When the optional parameter FRAME is omitted all frames as well
+as the default for new frames are updated. Otherwise only FRAME
+is modified."
  (if frame
      ;; Set frame parameters for the given frame
      (set-frame-parameter frame 'tab-bar-lines
(tab-bar--tab-bar-lines-for-frame frame))

>
>  > As far as I understand, tab-bar-lines is always just 1 or 0, meaning
>  > whether to show the tab-bar at all or not. Maybe it would be better to
>  > just rename the parameter? I guess if that is done then it does not
>  > necessarily need further explanation in docstrings.
>
> That ship has sailed long ago.  Neither the 'menu-bar-lines' nor the
> 'tool-bar-lines' parameters convey useful information in this regard and
> 'tab-bar-lines' just follows suit.  Their only practical (and completely
> misguided IMHO) purpose is to show the corresponding bar by setting the
> parameter to a non-zero value and remove it by setting the parameter to
> zero.
>
> Sometimes, as with our native tool bars, their value gives the number of
> frame lines occupied by the bar.  And very occasionally setting the
> parameter to a non-zero value can have strange effects: On a non-toolkit
> build setting menu-bar-lines to 7 will show six blank lines below a
> one-line menu bar which does not wrap anyway.
>
> In either case, we can hardly change the names of these frame parameters
> because they probably appear in too many applications and init files out
> there.  We could state somewhere that these are, in fact, booleans and
> should be set and interpreted in that sense.  Even that is not entirely
> trivial.

Makes sense!

>
> martin
Have a nice day
Bastian




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 08:58:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 03:58:53 2021
Received: from localhost ([127.0.0.1]:52610 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9OrE-0008WJ-8L
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 03:58:53 -0500
Received: from mout.gmx.net ([212.227.15.15]:38125)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1l9OrA-0008W3-JT
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 03:58:50 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1612861121;
 bh=pOjSxXBsIK29yoi9xXs4iEn7iBh8n9dJbpp5zTpeKWA=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=EBf+LSIg/8sLcPJpZmDzWBk4omW1/YxmQQ7Q+kjk6uDW1Rl17FZUh3nSh0cQe7MsY
 l3Zjkm6/ZYhmvVLmMSKtHvBxvX1u+C50JW9dGZllzMFVR6dO1FzSlaALykyXOIAF0W
 f8x3TmUyLy4A5MV+ETcTBT/jHbI5PrYmqjI4Ru2Y=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.34]) by mail.gmx.net (mrgmx004
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MryXH-1lfl4u0ffZ-00nv5f; Tue, 09
 Feb 2021 09:58:41 +0100
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
To: Bastian Beranek <bastian.beischer@HIDDEN>
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
 <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <38b988fd-2ad6-a596-23a0-1d765249f718@HIDDEN>
Date: Tue, 9 Feb 2021 09:58:39 +0100
MIME-Version: 1.0
In-Reply-To: <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:Ys1XIEmNF/UirPWdMIsMzapq6B9bfWm9pzhDADv2x/TNGjofVWZ
 VNPYuQDr/FZ4V/4mJ4HfecBmPooHHSsPDW0S7KMBpGRUWONZ25KFuqK54iT0upqOh94AnDk
 lThTAwCnEkM8ylwDLR804oO9N5u4G0tQiSEt3C5onK9CxDN9foXxQnhn/Xo6sZRSS07gIlZ
 GFB2bZkT/nkNJCOu5YOcA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:7EIeXVr66N8=:wKO4dZyf7YUIL7mW/fhIEj
 HNu1iMK3egyDZAJ+ly84zFmYhK2WwQV4tn+cG0H4QenMbYzeBEg+YMfE9sKt7n5S9mLyAhlHL
 qx12lgC/uygbnfiyaXZ8iUYTwJXw4lcpzGwHJVE0i58S/GtBd7pTwt6h0toU2QEKHc1n7tki+
 fgowlVKM4zV8erMBe1iuUHgybo9mTvryubVOrRnc82t8+dYx9eXJzEqltfXFzw8DCJ9YOQ9h+
 vrn+Xi9ynSiIVi2NsewHM7WKBkly31pyOdPDnkHWlKABEzB8tYtd7FYctO99voOaZT4xlL8AE
 dB9XBsv62YLkuYwUoFzGYX65FwsPSa6BTrUvOb7Wfy+k6O6JZwl9Fi0CBQTn+4SNtVVsFPIY8
 zg8zCfB5YRDuu/ova8ZXBSqIgXozC98QLqtPJwNWyd/pxA/XSpjXnyvyo1vbQ1ahrxFoRAzQK
 Q15lr4Udyb29XLzN/u12C8ag3dKPqYwZWKoa047wSjseKVK42raoqM2MsNvgGyXa3r2+W6vNI
 SsSZUeNBlgnlyLELR57Cr6x9Ik1da8Tdkp8PTXtqk71e+PIWLnzEgfYncTQA9fzLL4KCQ3N27
 oeS+IDb0k4ZGUiMn40F3lkZJdttsLxtNUFEnAwSm48usHlyu5KoxeykXPGB8u+XrcJvolNrOq
 IHtSAYcxpFQsk0ECIVx6XaLrRxxH80Id8OHOBz1wCv7nzDycHx94ksZoEyix0DKESDy0fs1Xx
 0jAogGSRBZ1H6W/ZlY/BdoVPfBrJZJVoVhu+ZEYKH7oj/IMl+4O7kayyNSE7GLnUi4kN+ta5v
 rslWDSeTnpt8EJaNLYsejo6r8cCItBL3LGWmzD8/R7BuHVqmdJaV5PBN9Hajwz/JEBXoXJuhd
 ZbaUcyKQHfMfC0dFT8Tg==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > I'll do my best to update the docstring. Note that I do not contribute
 > to emacs often, nor do I regularly code in elisp, so I'm not familiar
 > with the conventions and you are encouraged to modify my changes as
 > you see fit.

Don't worry.  These "-lines" frame parameters are a minefield - we just
should try to clarify things the best possible way while you're working
on it.

 > (defun tab-bar--tab-bar-lines-for-frame (frame)
 > -  "Compute the correct value of tab-bar-lines for the given frame."
 > +  "Compute the correct value of tab-bar-lines for FRAME."

But what "is" the correct value and why and how would we want to
"compute" it?

 > As far as I understand, tab-bar-lines is always just 1 or 0, meaning
 > whether to show the tab-bar at all or not. Maybe it would be better to
 > just rename the parameter? I guess if that is done then it does not
 > necessarily need further explanation in docstrings.

That ship has sailed long ago.  Neither the 'menu-bar-lines' nor the
'tool-bar-lines' parameters convey useful information in this regard and
'tab-bar-lines' just follows suit.  Their only practical (and completely
misguided IMHO) purpose is to show the corresponding bar by setting the
parameter to a non-zero value and remove it by setting the parameter to
zero.

Sometimes, as with our native tool bars, their value gives the number of
frame lines occupied by the bar.  And very occasionally setting the
parameter to a non-zero value can have strange effects: On a non-toolkit
build setting menu-bar-lines to 7 will show six blank lines below a
one-line menu bar which does not wrap anyway.

In either case, we can hardly change the names of these frame parameters
because they probably appear in too many applications and init files out
there.  We could state somewhere that these are, in fact, booleans and
should be set and interpreted in that sense.  Even that is not entirely
trivial.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 08:16:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 03:16:16 2021
Received: from localhost ([127.0.0.1]:52521 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9OC0-0002OZ-4C
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 03:16:16 -0500
Received: from mail-qk1-f182.google.com ([209.85.222.182]:40044)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l9OBw-0002GE-4J
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 03:16:14 -0500
Received: by mail-qk1-f182.google.com with SMTP id u20so17181806qku.7
 for <46299 <at> debbugs.gnu.org>; Tue, 09 Feb 2021 00:16:12 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=H4bz736zE3S4RaeBm4wfV5lXXhQl24pNDyF7UnFhjZc=;
 b=gcn8E5KgEGnrNyflEGc5VqVBeP0KotftWiXnZ05+AP6xUSFJB5Ha2cKDFv1Eup/Dso
 EuHp6jTzqEHktjERqLf7EBKeZgZvZ781Fo5K0tY10C3WKk96ktwn/yKlssQ8XLf+x76/
 a7LQVGu25sB+3/TJFHYXHY/nWcu8AfVSIxnQRd6n2mwbpIuK1L40GINF1jwWlpfu24BR
 qeuZpvjO9ltNoLWA+H4rfejda4VCkZKZstl0GZy/kNwYA1YB4gpcS25zuUf4uZJ7BVbW
 Y/8D11PkHeIua9Uy/3Omh6YZ+sTpY8H8JBp93V/FI3m3mNHug/mU4k7pRyHLmoFLit9p
 VqMw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=H4bz736zE3S4RaeBm4wfV5lXXhQl24pNDyF7UnFhjZc=;
 b=T8QgoRZR6tzqQ3OwSnWLz60nta8jBIF+gTdQ2fAGtoW2I16PIqpAUMwsCDTepW8urY
 FVL/2XBh9+AEvSipfjIceFpn/4SlmC9p7CptKLjGyGVClW6/QFkCe2Bpz0+73xGHOryf
 21xZTSlPqj0VQhx/KIxTUGK8bs/FdpN1PJfmrzE5H/MBv/C3/A7wa8BPitifIY6g+9ol
 d3HcW3kVp9ZYrUN10GULgCHpY5gbJc6E5WU1TndxhMQXfLGymHXeWEmoeYKCmNEw4TVS
 rbvyJA6ZG/Nvwt7HG4ue7FhOdynDIS4b/lBYzV2EgmW5/1Zz+7omsj4EzoxGiAN2hmy+
 75pQ==
X-Gm-Message-State: AOAM533mfFT85jAavoS+AFvNZ/2rnQk18rGZ4dB69GD921MvU6bBXGqP
 mUpGDkI7B71eskzKY3/XH5YT/chGQIgagK7lahk=
X-Google-Smtp-Source: ABdhPJy6u7LCgH1UrfxsaiSHBlXH7ulh6qjxTCxALhC6CuMjUrzw5WvqL2y8cot7nhqWqa8P61JLMjozVmwD84yRtDU=
X-Received: by 2002:a05:620a:901:: with SMTP id
 v1mr19591318qkv.331.1612858566628; 
 Tue, 09 Feb 2021 00:16:06 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
 <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
In-Reply-To: <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Tue, 9 Feb 2021 09:15:50 +0100
Message-ID: <CAK9AuB9-KMX-C6Er8Dv-X80UTh3Jf1y6jQ7YoTn2v7m5OZvzyA@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: martin rudalics <rudalics@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hey Martin,

On Tue, Feb 9, 2021 at 9:00 AM martin rudalics <rudalics@HIDDEN> wrote:
>
>  > +  "Update frame parameter tab-bar-line.
>  > +When the optional frame parameter is omitted all frames as well
>  > +as the default for new frames are updated. Otherwise only the
>  > +given frame is modified."
>
> This is confusing wrt our parameter/argument terminology.  Please just
> say "FRAME" wherever it stands for the function's argument and use
> "parameter of FRAME" when you talk about the frame parameter.

I'll do my best to update the docstring. Note that I do not contribute
to emacs often, nor do I regularly code in elisp, so I'm not familiar
with the conventions and you are encouraged to modify my changes as
you see fit.

I propose to change the docstring as follows:

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 9666fb2460..2c3d976f28 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -135,7 +135,7 @@ Possible modifier keys are `control', `meta',
`shift', `hyper', `super' and
                         tab-bar-close-button)))

(defun tab-bar--tab-bar-lines-for-frame (frame)
-  "Compute the correct value of tab-bar-lines for the given frame."
+  "Compute the correct value of tab-bar-lines for FRAME."
  (if (not tab-bar-mode)
      0
    (cond
@@ -145,10 +145,10 @@ Possible modifier keys are `control', `meta',
`shift', `hyper', `super' and
     (t 0))))

(defun tab-bar--update-tab-bar-lines (&optional frame)
-  "Update frame parameter tab-bar-line.
-When the optional frame parameter is omitted all frames as well
-as the default for new frames are updated. Otherwise only the
-given frame is modified."
+  "Update tab-bar-line parameter in frames.
+When the optional parameter FRAME is omitted all frames as well
+as the default for new frames are updated. Otherwise only FRAME
+is modified."
  (if frame
      ;; Set frame parameters for the given frame
      (set-frame-parameter frame 'tab-bar-lines
(tab-bar--tab-bar-lines-for-frame frame))

> Also
> please clarify: Does the value of the 'tab-bar-lines' parameter now
> stand for the number of (matrix) rows occupied by the tab bar (for
> example, 2 if the tab bar wraps once) or the number of frame lines
> calculated by dividing the pixel size of the tab bar by the frame's
> default line height?
>
> And finally: Why can't we wrap tab bars at tab boundaries so one tab
> never spans two lines unless it is too long for the frame (in which case
> it should be just truncated IMO).

As far as I understand, tab-bar-lines is always just 1 or 0, meaning
whether to show the tab-bar at all or not. Maybe it would be better to
just rename the parameter? I guess if that is done then it does not
necessarily need further explanation in docstrings.

>
> martin

Bastian




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 9 Feb 2021 08:00:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 09 03:00:55 2021
Received: from localhost ([127.0.0.1]:52464 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9Nx8-0000l1-Pc
	for submit <at> debbugs.gnu.org; Tue, 09 Feb 2021 03:00:55 -0500
Received: from mout.gmx.net ([212.227.15.15]:52509)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1l9Nx6-0000ko-Qz
 for 46299 <at> debbugs.gnu.org; Tue, 09 Feb 2021 03:00:53 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1612857645;
 bh=QOctvSvfAsxMqNeibStTEYONJI7+bo99TQSn442mzE0=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=i2NXOWVzWhspOb/5OUXGBiwTCjAaz0qKybrGi3qRSuWhQtY+6e3NedyZXj2Dz8jEs
 26uHTsr1gkGVq1q9S/RcVwuYiCqH2f3KxVLximr6t9BmpNGnPhvFPr/bvH6mCLMgGa
 6WrBG2MDGJ7N09not48vTp3Nmp+Qozxq3/qcO3XE=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.34]) by mail.gmx.net (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1Ml6qM-1ldGi12o3w-00lZOF; Tue, 09
 Feb 2021 09:00:45 +0100
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
To: Bastian Beranek <bastian.beischer@HIDDEN>, Juri Linkov <juri@HIDDEN>
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
 <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <55ebad56-b440-198a-653e-1660040d5eae@HIDDEN>
Date: Tue, 9 Feb 2021 09:00:44 +0100
MIME-Version: 1.0
In-Reply-To: <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:GSuRN/uSjKg3kUaY9Yv3qpDUX0N8yiVYaB/qFqeYwcKUGNiKupm
 QI6JIAbX6Le+Qvlx16Wu5FupEM8uNqU4wc/87ty0HH6XjCmbq1+oMzyg51k7IGeHbblolmu
 LfgRmxpFPP0si0YdsTL5QF3SOyigSbb5Rtf1nKtMYiWjhAWppkRvLBeywsRAoIJHGZ3xBdj
 iNU8IoV67g3JCCPatWWJA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:bgXzblEONxw=:ugEE7NaEoOAltYh2GU0yn+
 tLASdlpE2wlTNtqQ9tbxa139k7SQ40iyJqX3t31ayY0CFE4VJ/I8qpi6obbB0NJPKECzMEJMe
 RPj6i+aBjelA0ismPr8RfU/V3yOje1iygbbSH9BnbQyWyYCPUWPopvSfVUOsXnmcdQzQrIhNu
 J7jcvumtORN2rYSjGOgBGhli4KsHPwKGINiJv2zpzhsV+QjVd/UNzMDZAjYqjyZQz8ja4Uk2y
 b/koF+UUMSiiV6iZ3W/bHhSai4fqZq1IMPAGZhkkWnCCc4+sV9PJy2L2GkmBShu0fPQ8KypMa
 JNABVU/43TK+zZkeGNjkoBXyj1I+B/6Gz+2H45KDQPfLqgOijCK5Xd/TLl0rf91bl9JPiBe10
 hAi02CozUEz8pZWZn0tlFINbYtsoS35V0JiHL03OF/94HsvRuSegWd3p3qyaeWE83A1xZdZLE
 VzVCP2BKEdNuMjy05xFL6vjIzGCZSFsOTD3jCY42wTmQfybOCbWihdCpbXLcskCsvESVp0drD
 Qc4YITkHyGbyCj1Qa8NaO2r6GFvZP41JHRPY1wz7I4CkgoQq4fvWtzalcz5A3vNxk6Z5XmcGm
 f8CYuY1R5Xfm5P3umPonzNvHYuSAAw44jcwKTDi4iNIfIPR0CZIgAkmi+rF7vaCshX7j/T23T
 gP83hJi9GZJvLEcxCSjsIyixQZ64z5KnGTN/VOQ6zMtzC4EnL2I10+Q2qITVFN1Laocej5pI6
 QP7KRrCO6A1LmLU5sN5a1CHR/kD36b+Zf085Ou15nbCOHYvyaF7NNyWtekl8CsBGhm3ctBlpm
 64knCJ8oXNy3mzOrvFSb/JZLe1y0JNjPYDxUi+JfNFTKNs5eEWYBoPkv0vgl3Gc+vSndSSDyG
 ShIZye8Sr4d7e1oWGCZg==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > +  "Update frame parameter tab-bar-line.
 > +When the optional frame parameter is omitted all frames as well
 > +as the default for new frames are updated. Otherwise only the
 > +given frame is modified."

This is confusing wrt our parameter/argument terminology.  Please just
say "FRAME" wherever it stands for the function's argument and use
"parameter of FRAME" when you talk about the frame parameter.  Also
please clarify: Does the value of the 'tab-bar-lines' parameter now
stand for the number of (matrix) rows occupied by the tab bar (for
example, 2 if the tab bar wraps once) or the number of frame lines
calculated by dividing the pixel size of the tab bar by the frame's
default line height?

And finally: Why can't we wrap tab bars at tab boundaries so one tab
never spans two lines unless it is too long for the frame (in which case
it should be just truncated IMO).

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 8 Feb 2021 19:05:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 08 14:05:37 2021
Received: from localhost ([127.0.0.1]:51940 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9Bqd-0007at-23
	for submit <at> debbugs.gnu.org; Mon, 08 Feb 2021 14:05:37 -0500
Received: from mail-qk1-f170.google.com ([209.85.222.170]:46352)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l9Bqb-0007aY-0N
 for 46299 <at> debbugs.gnu.org; Mon, 08 Feb 2021 14:05:22 -0500
Received: by mail-qk1-f170.google.com with SMTP id 19so5388382qkc.13
 for <46299 <at> debbugs.gnu.org>; Mon, 08 Feb 2021 11:05:21 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=387UIQfR50DTHAgcms9s6md9qemSu9vjQEPJaiGAu+A=;
 b=jHDYrTr+nwkJGToG8wQwas1vatuo7fNTc0gMnPBTYy04ualvaWgywO0jPpr2Go551S
 sOq7hW1k++BbBboKnXkZc61FUMtpzghPXY7p9bAMCk/RxTrMRcmCXOqB45oT8m3BSc23
 +J1OiS1AgkgFQXUAqPXTkSQPRnCNhRZAI4gndvyArCmYlDXieZrOwSfeIdXI5EKKmWJf
 Svt8J7YgKHlhg9TdIL2iFqB3WZk2JIez4PQsDtkmZ+LVjgRhZ6qwU8hL2jRw4jGreUhS
 UPHfZELw8m8/wk3P7UCC6oi/yGGu/HkZtovCqxpWeVocmjg3PKBQwcqcpW55a/OoJv60
 j6LQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=387UIQfR50DTHAgcms9s6md9qemSu9vjQEPJaiGAu+A=;
 b=eyITwDTpKoUGnhEK+z2zgCjwwu0HuYVgkXTho8DCUS2yOOPuP96lkMQckUwGEzQPf8
 PVn/3j+Vl12Fh6zrrSGAxcXmDXVmPQpL0Tlm/6WPd+3MDzY658auN03Ls1SXAIGtvM3m
 ddWWulCULiyKWkNpeFCPCUZ/N5JncWqp8vZZ3nVH6c/VKHcPt2mf3cbitALN4UUB1wxX
 0vb5PnRCTZjQAyZAaFGspkBWfXnDmAiTnVOm+UKXy4ze92yzKS3L8IQjn4gU2fMS41XZ
 IWmxPxm18db1THrjvb1tKxs13+bAOwsQ53FmBmZZlsxaTMi0IHyBNcQCbbp0uxplzhSN
 i8Fg==
X-Gm-Message-State: AOAM532SSRK3b8Z4LrAjVjAjXXq5GTKKatQIXOTPGXYaMy0ANdcneooZ
 McybfQNrF9+WBekcy0brmpuAJsEe7I3x+JYnUFxW1iDW0n1bQw==
X-Google-Smtp-Source: ABdhPJxFfFInueyCdKMMCDTv7lojQOfMhNSQebih2Mzat/7eBtTQjECWvZv8PvUJv6xMaSDygBulD937MetO/Bs/DME=
X-Received: by 2002:a05:620a:881:: with SMTP id
 b1mr18747311qka.149.1612811115398; 
 Mon, 08 Feb 2021 11:05:15 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 <87v9b2ifrz.fsf@HIDDEN>
In-Reply-To: <87v9b2ifrz.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Mon, 8 Feb 2021 20:04:59 +0100
Message-ID: <CAK9AuB8r3=gMYoi8+WOSc5izqocKoZZO9Haf5VGiy79Sjp5cqg@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000009fab7a05bad7d998"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000009fab7a05bad7d998
Content-Type: text/plain; charset="UTF-8"

Hello Juri,

On Mon, Feb 8, 2021 at 7:23 PM Juri Linkov <juri@HIDDEN> wrote:
>
> Hello Bastian,
>
> > I have tried to clean up my patch a bit more, please see the attached version 3.
>
> Thanks, everything looks right, except one thing that you removed
> the most important rule:
>
> > -    (cond
> > -     ((eq tab-bar-show t)
> > -      (tab-bar-mode 1))
>
> This is the core reason of existence of tab-bar-show separate from tab-bar-mode:
> when the user creates a new tab, the tab-bar should be activated,
> unless the user has customized tab-bar-show to nil.
>
> Actually, a more proper condition should be:
>
>   (when tab-bar-show
>     (tab-bar-mode 1))
>
> and then after that you can use the remaining code:
>
> > +    ;; Recalculate tab-bar-lines and update frames
> > +    (tab-bar--update-tab-bar-lines (selected-frame))
> > +    (when tab-bar-mode
> > +      (tab-bar--load-buttons)
> > +      (tab-bar--define-keys))
>
> In tab-bar-close-other-tabs:
>
> > +      ;; Recalculate tab-bar-lines and update frames
> > +      (tab-bar--update-tab-bar-lines)
>
> It could affect only the selected frame too, i.e.:
> (tab-bar--update-tab-bar-lines (selected-frame))

Thank you for your comments. I have updated the patch according to
your suggestions. If it looks fine to you now, could you install it
for me?

Best
Bastian

--0000000000009fab7a05bad7d998
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v4.patch"
Content-Disposition: attachment; filename="tab-bar_v4.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kkwy2d680>
X-Attachment-Id: f_kkwy2d680
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--0000000000009fab7a05bad7d998--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 8 Feb 2021 18:23:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 08 13:23:35 2021
Received: from localhost ([127.0.0.1]:51895 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9BCA-0006XJ-3x
	for submit <at> debbugs.gnu.org; Mon, 08 Feb 2021 13:23:34 -0500
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:52685)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l9BC5-0006Wd-U1
 for 46299 <at> debbugs.gnu.org; Mon, 08 Feb 2021 13:23:31 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id CD2686000D;
 Mon,  8 Feb 2021 18:23:22 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
 <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
Date: Mon, 08 Feb 2021 20:19:12 +0200
In-Reply-To: <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
 (Bastian Beranek's message of "Mon, 8 Feb 2021 18:50:40 +0100")
Message-ID: <87v9b2ifrz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hello Bastian,

> I have tried to clean up my patch a bit more, please see the attached version 3.

Thanks, everything looks right, except one thing that you removed
the most important rule:

> -    (cond
> -     ((eq tab-bar-show t)
> -      (tab-bar-mode 1))

This is the core reason of existence of tab-bar-show separate from tab-bar-mode:
when the user creates a new tab, the tab-bar should be activated,
unless the user has customized tab-bar-show to nil.

Actually, a more proper condition should be:

  (when tab-bar-show
    (tab-bar-mode 1))

and then after that you can use the remaining code:

> +    ;; Recalculate tab-bar-lines and update frames
> +    (tab-bar--update-tab-bar-lines (selected-frame))
> +    (when tab-bar-mode
> +      (tab-bar--load-buttons)
> +      (tab-bar--define-keys))

In tab-bar-close-other-tabs:

> +      ;; Recalculate tab-bar-lines and update frames
> +      (tab-bar--update-tab-bar-lines)

It could affect only the selected frame too, i.e.:
(tab-bar--update-tab-bar-lines (selected-frame))




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 8 Feb 2021 17:51:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 08 12:51:07 2021
Received: from localhost ([127.0.0.1]:51868 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l9Agk-0005iM-W4
	for submit <at> debbugs.gnu.org; Mon, 08 Feb 2021 12:51:07 -0500
Received: from mail-qt1-f176.google.com ([209.85.160.176]:37902)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l9Agg-0005hp-Ke
 for 46299 <at> debbugs.gnu.org; Mon, 08 Feb 2021 12:51:05 -0500
Received: by mail-qt1-f176.google.com with SMTP id x3so9026843qti.5
 for <46299 <at> debbugs.gnu.org>; Mon, 08 Feb 2021 09:51:02 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=XtGM/hb85yU4UcBVn2im7qQgQazjz7sLSqq3BuQXxB0=;
 b=d8VItIs3I0AXelW1lVgazbx5JhPf7AZIUOOW36jl9ANfOECqZtHwZcT//Ls6+ejAiG
 DFpRmUR7NBm5VwPg4xjKYBfpGs9yTjUBI5jHwpZVV3MDvraO57/8A9eWQKatpTAC+7Uh
 EmZLuN+hTgiMftUXm2WLUWVrGgtRHXRWPG8MquYBWCR5JbKmqg1ECNTD63nR3anXM0NO
 TfSrnJ6QPb2crSHnL2SV25T2vdeqUz0tRoLDSuBsvFkve5gGNmtwihrb9Nk54gZX48DC
 UavX6R9Tc/h6Ug/DWaYfiA7qmlR3ap/0S8sKxt6gMb6p/el2QQM+fjZofwQJ7jfdN1is
 n5qA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=XtGM/hb85yU4UcBVn2im7qQgQazjz7sLSqq3BuQXxB0=;
 b=hDVc3Z8KaoJkfdzLxZkiE4EtUojPx2EqUUwowUmS8ver00XVWS06yK0Xy5NQf8Vsxr
 tSJakefEr3l7UJArN6ScelVtYq0PpwcZ9EhTR7utFdFc/PrLpSmVjIrqVTREzRyKE1tN
 ghkg7GgJoycXc6czvVFraDw8PMIumyHz3YzFsnDNnBdUVXt7nXChcxZtok3MB4JuDgho
 RKyCG/gIFWacbzex+Nfml4Kex0M0cgHoqvfEMXpl6XPNxG5/rYu07tN9Bnk5QlO6+m2L
 7GZkaAVe6R/XufW6uW/fxid1Xt25qW21NgCnnk0f3lyOMDWIO+T5RpWdDLisLDLfyjUD
 0T0g==
X-Gm-Message-State: AOAM532ShbCdyWaAHMwZSzHxpmXx4Zyce5u7sA7tAqpLHBTdBbsqzh7o
 oGMH16XN422J06BHh9E7EO20p7yxh1vsDTxD4oM=
X-Google-Smtp-Source: ABdhPJxfPZSd/34Sbz7t9EIpHFq2qJRTwYEWFRQI59CHnozS/zhfkTz4Uw0t8cs/3TBWqkK9zmFkVdTL5Nni0GRzCIQ=
X-Received: by 2002:ac8:5cc2:: with SMTP id s2mr16190160qta.342.1612806656973; 
 Mon, 08 Feb 2021 09:50:56 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
 <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
In-Reply-To: <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Mon, 8 Feb 2021 18:50:40 +0100
Message-ID: <CAK9AuB_poj9OARv7Gso9_3+U-Trf+dq50U-ZOtXKJn_KdPt0=w@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000e18db705bad6cf02"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000e18db705bad6cf02
Content-Type: text/plain; charset="UTF-8"

Hello Juri,

I have tried to clean up my patch a bit more, please see the attached version 3.

Best
Bastian

--000000000000e18db705bad6cf02
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v3.patch"
Content-Disposition: attachment; filename="tab-bar_v3.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kkwveetm0>
X-Attachment-Id: f_kkwveetm0
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--000000000000e18db705bad6cf02--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 7 Feb 2021 23:03:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 07 18:03:50 2021
Received: from localhost ([127.0.0.1]:49171 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l8t5p-0002I2-Vk
	for submit <at> debbugs.gnu.org; Sun, 07 Feb 2021 18:03:50 -0500
Received: from mail-qk1-f176.google.com ([209.85.222.176]:41548)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l8t5n-0002Hp-VL
 for 46299 <at> debbugs.gnu.org; Sun, 07 Feb 2021 18:03:49 -0500
Received: by mail-qk1-f176.google.com with SMTP id q85so453317qke.8
 for <46299 <at> debbugs.gnu.org>; Sun, 07 Feb 2021 15:03:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=LVeBFB4BFQC1Ziy1GFFUggNbp0pbWI/LtPRgZUeIbro=;
 b=IqpB5VbXbXKb8r3O3/Hq1F1wCVoI+4fGaog5uQByKk7UOisKpHajeC+BNYBUnFPWce
 FO4pcpA38L9gXuYeqGMIxj2GQVLJlVHajWtufvPw7TT4xj3s6mryqFIZuYn1Hx09w3NJ
 T7ySM5HalznUaoURXf2gi4az4UFn++pJ2l21vYhHhqqdMgShxwNRkd0GFQp/NG6tgtx2
 qhpstZyPAaJWVVubIz3X5HmjcyetEQ/KWG2EJq9oLrXQcFNcJ8Aw+L2APOZPR9Y2plQ5
 detfvquMy3kh+8uiNMZPoKvV0COU4cX4zph+jz3RcGxLx56cQUXtVzwsVXoKePPd+ycF
 5/oQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=LVeBFB4BFQC1Ziy1GFFUggNbp0pbWI/LtPRgZUeIbro=;
 b=AukToNntojlF8v/1zobap6ym6Smq+G4E+1TGXBkfDTZR7wMMAUjLqaLkNTig+jusYY
 XGkWFMx3oFQcQLWl3oqJHhaW8znWAflZs+ln5zqrScnE6JkFWvkJXUe4RV9fU2t4fEd3
 u7L9fkRkxPLEkajx2HECPNIQWqGlMk3Pma/E3yEiTFvL/Q40YRSdy1/Wfu1H444ADOME
 uNqojDXcNEH9td+vzk55P6xwh9Dr+g+5JaltKk3knPUrNY5SJEHYdVC/XryenNEo/fEs
 ubDJe7MjUmmD9KfTI26hdK6M4ECCoxlVKM2R3c5FFq50qykUjXq2B9dFajwecUA3uFmj
 kYfg==
X-Gm-Message-State: AOAM533V0VLg5C5yeAe+BD53k7JvszQJkNL9JobfzK9vEC4q11klgA3z
 DrnD/fmeb4E84CQCOMNxVmRNupoSLUvFHoUCwkXhrNkWuyk=
X-Google-Smtp-Source: ABdhPJyAHsJ1N5xWhD2OKPcZUIfxu+EjWiKuarugyzVMI0M30qEypvG0SujG3uN8H10frYcsRcm1gsIRsz9Zqa+zPLw=
X-Received: by 2002:a05:620a:1096:: with SMTP id
 g22mr14710066qkk.316.1612739022453; 
 Sun, 07 Feb 2021 15:03:42 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 <87a6sfu0fi.fsf@HIDDEN>
In-Reply-To: <87a6sfu0fi.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Mon, 8 Feb 2021 00:03:26 +0100
Message-ID: <CAK9AuB-Hxj4R514g-CvGRfOGiSTfmK6z3g4icpDYAHMBvb_M1Q@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000008d00d805bac7107f"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000008d00d805bac7107f
Content-Type: text/plain; charset="UTF-8"

Hello Juri,

On Sun, Feb 7, 2021 at 8:48 PM Juri Linkov <juri@HIDDEN> wrote:
>
> > I added code to make the frame setting of tab-bar-lines as well as the
> > default-frame-alist value dependent on tab-bar-show to the
> > tab-bar-mode function.
> > I think with this the part to which sets frame parameters in
> > tab-bar-show :set is not needed because (tab-bar-mode 1) is called
> > anyway, which already does everything.
> >
> > What do you think about the attached patch?
>
> I think your earlier idea was better - to have a dynamic function which
> counts the numbers of tabs and adapts the number of tab-bar-lines
> according to the value of tab-bar-show.
>
> Then such a function could be called from many places:
> - tab-bar-mode
> - tab-bar-show :set
> - from the end of tab-bar-new-tab-to
> - from the end of tab-bar-close-tab
> - from the end of tab-bar-close-other-tabs
>
> to sync the actual tabs with the value of tab-bar-show.

Makes sense! How about the attached?

Cheers
Bastian

--0000000000008d00d805bac7107f
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar_v2.patch"
Content-Disposition: attachment; filename="tab-bar_v2.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kkvr5t730>
X-Attachment-Id: f_kkvr5t730
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--0000000000008d00d805bac7107f--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 7 Feb 2021 19:49:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 07 14:49:03 2021
Received: from localhost ([127.0.0.1]:48893 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l8q3K-0001i3-NQ
	for submit <at> debbugs.gnu.org; Sun, 07 Feb 2021 14:49:03 -0500
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:49781)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l8q3H-0001gx-DD
 for 46299 <at> debbugs.gnu.org; Sun, 07 Feb 2021 14:49:00 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay5-d.mail.gandi.net (Postfix) with ESMTPSA id 30BE11C0009;
 Sun,  7 Feb 2021 19:48:52 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beranek <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
 <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
Date: Sun, 07 Feb 2021 21:05:12 +0200
In-Reply-To: <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
 (Bastian Beranek's message of "Sat, 6 Feb 2021 13:16:54 +0100")
Message-ID: <87a6sfu0fi.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> I added code to make the frame setting of tab-bar-lines as well as the
> default-frame-alist value dependent on tab-bar-show to the
> tab-bar-mode function.
> I think with this the part to which sets frame parameters in
> tab-bar-show :set is not needed because (tab-bar-mode 1) is called
> anyway, which already does everything.
>
> What do you think about the attached patch?

I think your earlier idea was better - to have a dynamic function which
counts the numbers of tabs and adapts the number of tab-bar-lines
according to the value of tab-bar-show.

Then such a function could be called from many places:
- tab-bar-mode
- tab-bar-show :set
- from the end of tab-bar-new-tab-to
- from the end of tab-bar-close-tab
- from the end of tab-bar-close-other-tabs

to sync the actual tabs with the value of tab-bar-show.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 6 Feb 2021 12:17:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 06 07:17:17 2021
Received: from localhost ([127.0.0.1]:45361 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l8MWb-0005C7-Hb
	for submit <at> debbugs.gnu.org; Sat, 06 Feb 2021 07:17:17 -0500
Received: from mail-qt1-f181.google.com ([209.85.160.181]:43957)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l8MWZ-00056N-Mf
 for 46299 <at> debbugs.gnu.org; Sat, 06 Feb 2021 07:17:16 -0500
Received: by mail-qt1-f181.google.com with SMTP id s11so3276720qtq.10
 for <46299 <at> debbugs.gnu.org>; Sat, 06 Feb 2021 04:17:15 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=Efvgmxbis/8QmD18F3qfW8OSUvtwCZ/k4B2ND/f58lE=;
 b=KtHbHNl3vSRKFwuDz1XpmqCcs+eMsPsGFtHtd7OYHTLH8E626GfQwcOK0w1lU7ayUo
 G3aTt8xhL2/pGXE+P8zJ9NSZYJSXgNeUyyBWlccSZiUYcwQt+GGU5q0s5NqxkLRZ/VFc
 aZiG+mD9y45wuE2QfI5sGv552pnUdAnSnP7fwdD2RE6MRKgPvVeFvzj2HwQxnLNfan80
 8s+e+U94UsvKuoC2wVfJRj+S1Ga2bs3BiF51O5m4AYBFYXOwyAN6SvOlIjtnT24Gyino
 8eKc5SESwz8pzyTUyAS9ImtsOH8l5biZ49uAj2k4Kc9cxNa2IHXU9CCz9o4Ojel1an5u
 iDJA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=Efvgmxbis/8QmD18F3qfW8OSUvtwCZ/k4B2ND/f58lE=;
 b=pjK3zHKInLupv47Xt7DA6lZ937KPBvQD5VzGDx3rmfw1ZNn38F7lTQ6Ee60kwjtwj9
 ZLxpOaueyeWugtlYeRhLUFuXF79GBzoakqHaC8ceFXtypgW/HKUWaRKw9KjMoc5Ne1Cb
 nCOjfYLDuIktNhKPQrzNuFGzPR1tt2hntzxLvQnv7Zk+J8+ORDLj4U6JfdEKXs07uhsO
 v5vrfKi6fmPpvTPg1KGsG8ZMi8n6dxTXcpsw7RMVnx9HJmSAJW48hHKjcCzPHOUXSPQQ
 aEfrWp36/3ENzDKkG/Y68tdvnGKcwOqHSW/9PJKZAUMcy2gxRQNqfqM+ZxOakeaDw/r9
 nYKg==
X-Gm-Message-State: AOAM530AAfLn2dJkJCNK10BWLMnGuKrn7HZ6BFCRBFqU4FHVK+ug42pP
 X6Rl7N1Yx4/J8Wu5UYyY/KqhrlrXfHlRk/WZxNQcvLdfVqo=
X-Google-Smtp-Source: ABdhPJzKaBNF8PZPH0MpKcQEvss/25SkmtRca1WINGpdE8SuGcEjreeBJ0xoktXpfSzVdcA3lmmrcZlrmqrEjNZKf9I=
X-Received: by 2002:ac8:6a01:: with SMTP id t1mr8547680qtr.105.1612613830125; 
 Sat, 06 Feb 2021 04:17:10 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
 <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
In-Reply-To: <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Sat, 6 Feb 2021 13:16:54 +0100
Message-ID: <CAK9AuB-J8U8Q4YCLjvmHmcEz06bZP3GxKEToTnWgqxtm8QdFzA@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000814cba05baa9ea71"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000814cba05baa9ea71
Content-Type: text/plain; charset="UTF-8"

Hello Juri,

I added code to make the frame setting of tab-bar-lines as well as the
default-frame-alist value dependent on tab-bar-show to the
tab-bar-mode function.
I think with this the part to which sets frame parameters in
tab-bar-show :set is not needed because (tab-bar-mode 1) is called
anyway, which already does everything.

What do you think about the attached patch?

Cheers
Bastian

On Fri, Feb 5, 2021 at 3:11 PM Bastian Beranek
<bastian.beischer@HIDDEN> wrote:
>
> Hello Juri,
>
> I now installed your patch and I don't think it is complete yet.
>
> 1) Is the :set function actually used the next time emacs starts after
> customizations have been written to .emacs and variables are
> initialized to customized values using (custom-set-variables ...)? I
> don't think it is, right?
>
> 2) Switching tab-bar-mode on and off seems to overwrite the
> tab-bar-lines information in default-frame-alist:
>
>     ;; If the user has given `default-frame-alist' a `tab-bar-lines'
>     ;; parameter, replace it.
>     (if (assq 'tab-bar-lines default-frame-alist)
>         (setq default-frame-alist
>               (cons (cons 'tab-bar-lines val)
>                     (assq-delete-all 'tab-bar-lines
>                                      default-frame-alist)))))
>
> This code should depend on the value of tab-bar-show, right?
>
> Cheers
> Bastian

--000000000000814cba05baa9ea71
Content-Type: text/x-patch; charset="US-ASCII"; name="tab-bar.patch"
Content-Disposition: attachment; filename="tab-bar.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kktokkn50>
X-Attachment-Id: f_kktokkn50
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--000000000000814cba05baa9ea71--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 5 Feb 2021 14:12:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 09:12:03 2021
Received: from localhost ([127.0.0.1]:43234 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l81q7-0000gg-0A
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 09:12:03 -0500
Received: from mail-qk1-f169.google.com ([209.85.222.169]:34662)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l81q5-0000gB-8i
 for 46299 <at> debbugs.gnu.org; Fri, 05 Feb 2021 09:12:01 -0500
Received: by mail-qk1-f169.google.com with SMTP id t63so6976019qkc.1
 for <46299 <at> debbugs.gnu.org>; Fri, 05 Feb 2021 06:12:01 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=izbPOiPWMnF1wfobEBUmK2JfkjS44Vc2egd/Nh0T4hY=;
 b=KzcXoF3HZLH5sp1DjBgmGB+ERjhaKArUefdpC7BQgls7Zs4KxK/WJIAL2v7Xd7b8nT
 JZ1tnz1gwkjAOtiXKKxXIeUE0TWvU7GArtYOOiwISxr4jNtw0soQiUXDBJi/BNSS3Hot
 tyNcbc/z+xDkr723VBMQZrYB13WJuOMqnHRg/EDEev7VBnEURV8G+nZV5Ue+Mv2evXQH
 knDHhb227ooE5CrUQPvIEx2zHGuc1UkGfbbfEsZEFjrdPAqIBYthAE3832eh4/YkJYMK
 KYcEg6+hM/FZmX6ax1eVsbSG+FqasojeXkK7x05mv51Fn51MCc455E2V0n4eVNP+T82x
 RLxA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=izbPOiPWMnF1wfobEBUmK2JfkjS44Vc2egd/Nh0T4hY=;
 b=NzHzzUW/JyRzSOjx/U5oN+h79dzdWth6gwiRNDCrp6yC3EjgTUOefxujYjqTCTiB54
 d84IgGwa3fEFfQhPoFwE99XuNU0vyGNZammOXKuo6giLZJ5Jpr1ey8XDybgkvvtMXfWG
 G/qM8tv/r2WqyPNVcK23YEXFvXW9Dil0u5Tj2+9fviMpklfGBCnXLZXrPMgx515K9iw5
 YOVKBsJNxV8/PKgZ1Ayo6Fl18toDn9mhpQiJL9z2qZkHlx+vsw8up9GNOPMokj4kGRxb
 mcv7QAelj6+h/ZjWzUB+fZos7y3aBhA31k5B+XFnKfPxfQ94SSvAMOZIJgVI3h/9cunn
 Kccg==
X-Gm-Message-State: AOAM533+QSPZpDxICuEkQ4RR4nTjHgyt8si97VwLakjM3/IXvFmmxPD/
 4+LdZK/uCk8PQ966BGItLizLrNg28dTyQZA1eRETjJwTzVLqxg==
X-Google-Smtp-Source: ABdhPJyaoY8hdcNWu4bcmizZ22tpYz+jfewSDL0VM63RBXe2HZ105KytxOqL/w88PS05pkLJHqcd06sHTil8IMxsBNY=
X-Received: by 2002:a05:620a:1096:: with SMTP id
 g22mr4521978qkk.316.1612534315701; 
 Fri, 05 Feb 2021 06:11:55 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
 <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
In-Reply-To: <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Fri, 5 Feb 2021 15:11:39 +0100
Message-ID: <CAK9AuB9KfD_b_g2k7HO9gTyXt0==Uje081CmzXLGbT95rCY_0Q@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello Juri,

I now installed your patch and I don't think it is complete yet.

1) Is the :set function actually used the next time emacs starts after
customizations have been written to .emacs and variables are
initialized to customized values using (custom-set-variables ...)? I
don't think it is, right?

2) Switching tab-bar-mode on and off seems to overwrite the
tab-bar-lines information in default-frame-alist:

    ;; If the user has given `default-frame-alist' a `tab-bar-lines'
    ;; parameter, replace it.
    (if (assq 'tab-bar-lines default-frame-alist)
        (setq default-frame-alist
              (cons (cons 'tab-bar-lines val)
                    (assq-delete-all 'tab-bar-lines
                                     default-frame-alist)))))

This code should depend on the value of tab-bar-show, right?

Cheers
Bastian




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 5 Feb 2021 10:10:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 05:10:29 2021
Received: from localhost ([127.0.0.1]:42911 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l7y4K-00036y-67
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 05:10:29 -0500
Received: from mail-qt1-f179.google.com ([209.85.160.179]:34741)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l7y4E-00036i-Rc
 for 46299 <at> debbugs.gnu.org; Fri, 05 Feb 2021 05:10:26 -0500
Received: by mail-qt1-f179.google.com with SMTP id c1so4590774qtc.1
 for <46299 <at> debbugs.gnu.org>; Fri, 05 Feb 2021 02:10:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=zvLUPhVckzm7fcrkOPhfvxIgyibWksw4NF8pSFOB1oY=;
 b=JNwY4QpEFqqIYl8Zu0m5Bt6OXPc60ePHFvaVwBZgx+HgPc+FjE7D4Wt1zDnH0yxB95
 ZMc8bAC6L+xxxJ4gkEaHr8Er6t7FdyxDYvZ4z5rHq97ki4tY8AFwlsRM/iSj5SZCp/0D
 7Q7X8k7Wv3v/zfffcVsCQIS6QvXHAGrxif1lL/hn0pTlMBVvBBh8IeK4HR6h8vkLkHCH
 c3GajKE4LyEvInfcS99Tw8M9f2CDGgddv0jG4fnIcG/aOLSK7WVMqXaU+t7y8dW8UtEN
 InoyLI0DRFT/ekd6Hwkn2BXvHdOZdstvnTgNqz32on+efGsqlZRsyg7QoAGzDGpwlnFq
 Mpdg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=zvLUPhVckzm7fcrkOPhfvxIgyibWksw4NF8pSFOB1oY=;
 b=g/BDghBIOMc1Ai7JOw1QrWoFVs4wliVfD6kcb6CjnNwd7YZgzhyDP7ywZ+78q++AgF
 BIC+YVL+O6z0/sDbkBFo8TsiggMCvlHmR+NGBhuEE7xGoEQUxcisAos/yh65ICz8Bm0n
 N33ir/+WeBLWafOEIrlb1L05L5qQ12DOsPGfJYfo/zqvM9O1qxGY+ndIvNbrH8NyzXUt
 m74Y/V3KeDYoAXLI4nlux4ZJTokTqcQwdE3VjloyqiunpTOPZ/JRif3xoLsIRJsusjna
 0GJNe/DYBPs2CNpUKdojMv501Aq5Oup8onvLroI1fy87ZWwWXpNw28FHamCST6N8/qZK
 3JOA==
X-Gm-Message-State: AOAM533E6fMvZPuDSOwrTVg4bfgAcwBMl4rj4q3H3Vk5M/Y3ON1cNaQ4
 TttfuqUfoGKn7miHthZZEbMuyls1KAYM479VlVlXwO3lOzGTvg==
X-Google-Smtp-Source: ABdhPJxO6zKwUm+enyb5DhVmem6bnvZTn4r9RX/vx+khohTNyr18dCZygyFIuSrwTRGE2I3sNLBaqVEJNhz8HgBrD2s=
X-Received: by 2002:ac8:698a:: with SMTP id o10mr3447248qtq.242.1612519817080; 
 Fri, 05 Feb 2021 02:10:17 -0800 (PST)
MIME-Version: 1.0
References: <871rdv4xog.fsf@HIDDEN> <87k0rmnbqs.fsf@HIDDEN>
In-Reply-To: <87k0rmnbqs.fsf@HIDDEN>
From: Bastian Beranek <bastian.beischer@HIDDEN>
Date: Fri, 5 Feb 2021 11:10:01 +0100
Message-ID: <CAK9AuB8wUT19NV+nptd+29+j2ZhYXoo13jh7tDv-0=DeOkXZkw@HIDDEN>
Subject: Re: bug#46299: 28.0.50;
 Value of tab-bar-show not respected in new frames.
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hey Juri,

On Fri, Feb 5, 2021 at 10:22 AM Juri Linkov <juri@HIDDEN> wrote:
>
> > I noticed that with the latest master branch setting tab-bar-show
> > to "1" does not work work for new frames. On those the tabs are shown
> > even if tab-bar-show is set to 1.
>
> Thanks for finding a case that is still unhandled.
>
> > I suppose a hook is needed which applies the correct setting
> > to the new frame?
>
> Generally, Emacs core packages should avoid adding own code
> to hooks, because hooks are intended mostly for users, such as
> for example, configuring to enable tab-bar selectively:
>
>   (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)
>
> Fortunately, frames provide a better way to set their default values
> with default-frame-alist, that tab-bar-mode already modifies.

Oh I see. Yes that would also work. Although I would say that in
general it should be more robust to have a dynamic function which
counts the numbers of tabs and adapts the number of tab-bar-lines
according to the value of tab-bar show. Is it guaranteed that new
frames only have one tab?

> So doing something similar fixes the problem:

That patch looks fine, except that my bug report translates equally to
the case when tab-bar-show is nil, so (eq val 1) should be adapted to
catch both "1" and "nil".

Thanks for your help!
Bastian




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at 46299 <at> debbugs.gnu.org:


Received: (at 46299) by debbugs.gnu.org; 5 Feb 2021 09:22:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 04:22:36 2021
Received: from localhost ([127.0.0.1]:42800 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l7xJz-0003q6-QF
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 04:22:36 -0500
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:44503)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l7xJv-0003pd-My
 for 46299 <at> debbugs.gnu.org; Fri, 05 Feb 2021 04:22:34 -0500
X-Originating-IP: 91.129.108.204
Received: from mail.gandi.net (m91-129-108-204.cust.tele2.ee [91.129.108.204])
 (Authenticated sender: juri@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id 255AC60012;
 Fri,  5 Feb 2021 09:22:23 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Bastian Beischer <bastian.beischer@HIDDEN>
Subject: Re: bug#46299: 28.0.50; Value of tab-bar-show not respected in new
 frames.
Organization: LINKOV.NET
References: <871rdv4xog.fsf@HIDDEN>
Date: Fri, 05 Feb 2021 10:54:03 +0200
In-Reply-To: <871rdv4xog.fsf@HIDDEN> (Bastian Beischer's message of "Thu,
 04 Feb 2021 17:14:55 +0100")
Message-ID: <87k0rmnbqs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46299
Cc: 46299 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

> I noticed that with the latest master branch setting tab-bar-show
> to "1" does not work work for new frames. On those the tabs are shown
> even if tab-bar-show is set to 1.

Thanks for finding a case that is still unhandled.

> I suppose a hook is needed which applies the correct setting
> to the new frame?

Generally, Emacs core packages should avoid adding own code
to hooks, because hooks are intended mostly for users, such as
for example, configuring to enable tab-bar selectively:

  (add-hook 'after-make-frame-functions 'toggle-frame-tab-bar)

Fortunately, frames provide a better way to set their default values
with default-frame-alist, that tab-bar-mode already modifies.
So doing something similar fixes the problem:


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=tab-bar-show-default-frame-alist.patch

diff --git a/lisp/tab-bar.el b/lisp/tab-bar.el
index 6720d82b47..0cf74a7833 100644
--- a/lisp/tab-bar.el
+++ b/lisp/tab-bar.el
@@ -252,6 +252,12 @@ tab-bar-show
          (set-default sym val)
          ;; Preload button images
          (tab-bar-mode 1)
+         ;; New frames have only one tab, so hide it by default
+         (when (eq val 1)
+           (setq default-frame-alist
+              (cons (cons 'tab-bar-lines 0)
+                    (assq-delete-all 'tab-bar-lines
+                                     default-frame-alist))))
          ;; Then handle each frame individually
          (dolist (frame (frame-list))
            (set-frame-parameter

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 4 Feb 2021 16:15:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 04 11:15:20 2021
Received: from localhost ([127.0.0.1]:42084 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l7hHs-00060I-0h
	for submit <at> debbugs.gnu.org; Thu, 04 Feb 2021 11:15:20 -0500
Received: from lists.gnu.org ([209.51.188.17]:57218)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bastian.beischer@HIDDEN>) id 1l7hHo-000606-55
 for submit <at> debbugs.gnu.org; Thu, 04 Feb 2021 11:15:18 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:32884)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <bastian.beischer@HIDDEN>)
 id 1l7hHn-00077E-Lv
 for bug-gnu-emacs@HIDDEN; Thu, 04 Feb 2021 11:15:15 -0500
Received: from mail-ed1-x529.google.com ([2a00:1450:4864:20::529]:41895)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <bastian.beischer@HIDDEN>)
 id 1l7hHi-0001PM-EC
 for bug-gnu-emacs@HIDDEN; Thu, 04 Feb 2021 11:15:15 -0500
Received: by mail-ed1-x529.google.com with SMTP id s5so4827766edw.8
 for <bug-gnu-emacs@HIDDEN>; Thu, 04 Feb 2021 08:15:09 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=0I9jR1373uFlOeJEqWNgVmDLoXQ/XaaLa0Qlx13lBU4=;
 b=Y+KEiwbnWnYDsgVgHnB20KWGPPJL9RtUAbPNWFq7Ah1d56Tf4W2Qk1sjYWKdTyNHQ0
 2PwVDJqG7gltYKYd3haNP4/JWahFRp+nDSunwrgPTGCOYjV079x7dpzq/YqfTnkvKhsV
 mDTgzcNO2gjkt/GRksjAKRI1EhBEAz08zzyAVMz0rfKWDGD/kSOYn11w+TozMYdSmI/9
 g6Syvjiot1P4FdtL9yyIvDst6IVAE4BaCAItC0C1P+Fie8SLYG9ruuKASNLEmKG+SSwp
 uGNS6ZanGZsCQtJMmQavc3E2FTZ6W6214jpgsgpG6ADAJcub9sJ1nfh7AjEwHleS2sOx
 X26g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=0I9jR1373uFlOeJEqWNgVmDLoXQ/XaaLa0Qlx13lBU4=;
 b=l6uERxxnCFGE6isPf4dDeaJSDticmfjLtfQvxdqqZH6mTcG+I++HeXhVaAj5kn/Z1U
 9jmHK57H+/MZXlfn8aCkGYBtYkv6wDYVBHKPnrWL8K73+O7o67VaP05lzz7aUunxmjqw
 7V3mss/mS/SymrdbEBUPSpbnN2JRVKapOCeNiiFa6yhQ9X8zD83MpSBEXGml8oqtM74N
 JREoh69LsVHrTHVZAS/3bLp9RWt1PxWxT74HqQSunAwAt03jrYo1gs07XwmybEJDLhEz
 +lVnKgNHmhr/VQi9e1GrId+rmP+lGQJlOBYP3GdKt7zLWcqsxuCo/74+nHM8tdlvqk+g
 pjJA==
X-Gm-Message-State: AOAM533X5WmAESJbwMEYmOB/1FNnCIMlGSIjisO9rgVnRY7tZYZcgDEf
 n/6FPe3U02fc/lL8s5Jgv0p3m4gL6YlGJA==
X-Google-Smtp-Source: ABdhPJwmMUMW/MIP1gbS96bYpZCA7l797hqEU1nhP1vb7TOOx3ksrKaU+ojGjSuwwMDd0iinb/82qA==
X-Received: by 2002:aa7:cd0a:: with SMTP id b10mr8491537edw.153.1612455307606; 
 Thu, 04 Feb 2021 08:15:07 -0800 (PST)
Received: from bastian-desktop.gmail.com (b2b-130-180-23-226.unitymedia.biz.
 [130.180.23.226])
 by smtp.gmail.com with ESMTPSA id j27sm2654333ejb.102.2021.02.04.08.15.06
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 04 Feb 2021 08:15:06 -0800 (PST)
From: Bastian Beischer <bastian.beischer@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; Value of tab-bar-show not respected in new frames.
Date: Thu, 04 Feb 2021 17:14:55 +0100
Message-ID: <871rdv4xog.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=2a00:1450:4864:20::529;
 envelope-from=bastian.beischer@HIDDEN; helo=mail-ed1-x529.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


I noticed that with the latest master branch setting tab-bar-show
to "1" does not work work for new frames. On those the tabs are shown
even if tab-bar-show is set to 1. I suppose a hook is needed which
applies the correct setting to the new frame?

This can be reproduced by:

1) "emacs -Q"
   (no tab bar yet)

2) M-x tab-bar-mode
   (tab bar appears in the current frame with one tab)

3) M-x customize-variable tab-bar-show ->
   Set to "When more than one tab".
   (tab bar disappears in the current frame)

4) C-x 5 2
   (tab bar visible in the new frame with one tab)


In GNU Emacs 28.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version 3.24.24)
 of 2021-02-03 built on bastian-desktop
Repository revision: 20e48b6fd6cade60e468140a66127d326abfb8ff
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12010000
System Description: Arch Linux

Configured using:
 'configure --prefix=/usr --sysconfdir=/etc --libexecdir=/usr/lib
 --localstatedir=/var --mandir=/usr/share/man --with-gameuser=:games
 --with-sound=alsa --with-modules --without-gconf --without-gsettings
 --enable-link-time-optimization --with-x-toolkit=gtk3 --without-xaw3d
 --without-cairo --without-compress-install 'CFLAGS=-march=native -O2
 -pipe -fno-plt -flto -fuse-linker-plugin -flto -fuse-linker-plugin'
 CPPFLAGS=-D_FORTIFY_SOURCE=2
 LDFLAGS=-Wl,-O1,--sort-common,--as-needed,-z,relro,-z,now'

Configured features:
ACL DBUS FREETYPE GIF GLIB GMP GNUTLS GPM HARFBUZZ JPEG JSON LCMS2
LIBOTF LIBSYSTEMD LIBXML2 M17N_FLT MODULES NOTIFY INOTIFY PDUMPER PNG
RSVG SOUND THREADS TIFF TOOLKIT_SCROLL_BARS X11 XDBE XFT XIM XPM GTK3
ZLIB

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  recentf-mode: t
  whitespace-mode: t
  subword-mode: t
  helm-fuzzier-mode: t
  async-bytecomp-package-mode: t
  helm-flx-mode: t
  projectile-mode: t
  yas-global-mode: t
  yas-minor-mode: t
  company-mode: t
  global-git-commit-mode: t
  magit-auto-revert-mode: t
  flx-ido-mode: t
  ido-everywhere: t
  shell-dirtrack-mode: t
  show-paren-mode: t
  global-hi-lock-mode: t
  hi-lock-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  prettify-symbols-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t
  hs-minor-mode: t

Load-path shadows:
/home/beischer/.emacs.d/elpa/cmake-mode-20210104.1831/cmake-mode hides /usr/share/emacs/site-lisp/cmake-mode
~/.emacs.d/lisp/buff-menu+ hides /usr/share/emacs/site-lisp/various/buff-menu+
~/.emacs.d/lisp/my-term hides /usr/share/emacs/site-lisp/various/my-term
~/.emacs.d/lisp/buff-menu hides /usr/share/emacs/site-lisp/various/buff-menu
~/.emacs.d/lisp/qt-pro hides /usr/share/emacs/site-lisp/various/qt-pro
~/.emacs.d/lisp/buff-menu hides /usr/share/emacs/28.0.50/lisp/buff-menu

Features:
(shadow sort mail-extr emacsbug sendmail recentf help-fns radix-tree
magit-extras bug-reference eterm-256color xterm-color mule-util log-view
vc-mtn vc-hg vc-bzr vc-src vc-sccs vc-svn vc-rcs vc vc-dispatcher
misearch multi-isearch mm-archive gnutls url-cache debbugs-gnu debbugs
soap-client url-http url-auth url-gw rng-xsd rng-dt rng-util xsd-regexp
xml winner helm-ring helm-elisp helm-files helm-buffers helm-occur
helm-tags helm-locate helm-grep helm-regexp helm-eval edebug backtrace
helm-info helm-types helm-utils helm-help ido-completing-read+ memoize
cus-edit minibuf-eldef whitespace cap-words superword subword
company-oddmuse company-keywords company-etags etags fileloop generator
company-gtags company-dabbrev-code company-dabbrev company-files
company-clang company-capf company-cmake company-semantic
company-template company-bbdb company-edbi edbi sql view company-jedi
jedi-core python-environment epc ctable concurrent deferred
tree-sitter-langs tree-sitter-langs-build tar-mode arc-mode archive-mode
pp tree-sitter-hl tree-sitter tree-sitter-load tree-sitter-cli tsc
tsc-dyn tsc-dyn-get dired-aux tsc-obsolete ccls ccls-member-hierarchy
ccls-inheritance-hierarchy ccls-call-hierarchy ccls-tree ccls-code-lens
ccls-semantic-highlight ccls-common lsp-ui lsp-ui-flycheck lsp-ui-doc
goto-addr lsp-ui-imenu lsp-ui-peek lsp-ui-sideline flycheck lsp-ui-util
lsp-mode lsp-protocol xref project tree-widget wid-edit spinner
network-stream nsm markdown-mode lv inline ht ewoc dash-functional
bindat cmake-project helm-fuzzier helm async-bytecomp
helm-global-bindings helm-easymenu helm-source eieio-compat
helm-multi-match helm-lib async helm-flx tempo xml-parse doxymacs f s
tramp-cache projectile ibuf-ext ibuffer ibuffer-loaddefs dropdown-list
yasnippet-snippets yasnippet my-term vterm face-remap term disp-table
ehelp vterm-module term/xterm xterm cmake-mode rst qt-pro pastebin
ams-meeting calc-mouse calc-yank calc-ext calc calc-loaddefs calc-macs
realgud realgud-zshdb realgud:zshdb-track-mode realgud:zshdb-core
realgud:zshdb-init realgud-trepan3k realgud:trepan3k-track-mode
realgud:trepan3k-core realgud:trepan3k-init realgud-trepan2
realgud:trepan2-track-mode realgud:trepan2-core realgud:trepan2-init
realgud-trepanpl realgud:trepanpl-track-mode realgud:trepanpl-core
realgud:trepanpl-init realgud-trepanjs realgud:trepanjs-track-mode
realgud:trepanjs-core realgud:trepanjs-init realgud-lang-js
realgud-trepan realgud:trepan-track-mode realgud:trepan-core
realgud:trepan-init realgud-remake realgud:remake-track-mode
realgud:remake-core realgud:remake-init realgud-rdebug
realgud-rdebug-track-mode realgud-rdebug-core realgud-rdebug-init
realgud-lang-ruby realgud-perldb realgud:perldb-track-mode
realgud:perldb-core realgud:perldb-init realgud-lang-perl realgud-pdb
realgud:pdb-track-mode realgud:pdb-core realgud:pdb-init
realgud-lang-python python tramp-sh realgud-kshdb
realgud:kshdb-track-mode realgud:kshdb-core realgud:kshdb-init
realgud-gub realgud:gub-track-mode realgud:gub-core realgud:gub-init
realgud-gdb realgud:gdb-track-mode realgud:gdb-init realgud:gdb-core
realgud-bashdb realgud:bashdb-track-mode realgud:bashdb-core
realgud:bashdb-init realgud-lang-posix-shell realgud:run
realgud-locals-mode realgud-breakpoint-mode realgud-backtrack-mode
realgud-track-mode realgud-backtrace-mode realgud-attach
realgud-lang-java realgud-track realgud-shortkey realgud-menu
realgud-eval realgud-cmds realgud-send realgud-window realgud-utils
eshell realgud-init realgud-file realgud-core realgud-reset
realgud-buffer-helper realgud-buffer-breakpoint realgud-buffer-backtrace
realgud-locals realgud-buffer-locals realgud-buffer-command
realgud-buffer-info realgud-lochist org ob ob-tangle ob-ref ob-lob
ob-table ob-exp org-macro org-footnote org-src ob-comint org-pcomplete
org-list org-faces org-entities noutline outline org-version
ob-emacs-lisp ob-core ob-eval org-table ol org-keys org-compat org-macs
org-loaddefs find-func cal-menu calendar cal-loaddefs realgud-bp
realgud-bp-image-data realgud-lang esh-mode esh-cmd esh-ext esh-opt
esh-proc esh-io esh-arg esh-module esh-groups esh-util realgud-loc
realgud-buffer-source realgud-key key realgud-follow realgud-fringe
realgud-helper loc-changes realgud-regexp realgud-custom load-relative
ivy delsel ivy-faces ivy-overlay colir color company hide-lines
buff-menu+ magit-topgit magit-submodule magit-obsolete magit-popup
magit-blame magit-stash magit-reflog magit-bisect magit-push magit-pull
magit-fetch magit-clone magit-remote magit-commit magit-sequence
magit-notes magit-worktree magit-tag magit-merge magit-branch
magit-reset magit-files magit-refs magit-status magit magit-repos
magit-apply magit-wip magit-log magit-diff smerge-mode diff git-commit
log-edit message rmc puny rfc822 mml mml-sec epa epg epg-config
gnus-util rmail rmail-loaddefs mm-decode mm-bodies mm-encode mail-parse
rfc2231 rfc2047 rfc2045 mm-util ietf-drums mail-prsvr mailabbrev
mail-utils gmm-utils mailheader pcvs-util add-log magit-core
magit-autorevert autorevert filenotify magit-margin magit-transient
magit-process with-editor server magit-mode transient cl-extra help-mode
magit-git magit-section derived benchmark magit-utils pcase which-func
imenu vc-git diff-mode easy-mmode crm dash hideshow flx-ido advice flx
ido dired-x dired dired-loaddefs cc-mode cc-fonts cc-guess cc-menus
cc-cmds cc-styles cc-align cc-engine cc-vars cc-defs flymake-proc
flymake warnings thingatpt vc-cvs finder-inf edmacro kmacro
emacs-x-theme tramp tramp-loaddefs trampver tramp-integration files-x
tramp-compat shell pcomplete parse-time iso8601 time-date ls-lisp
format-spec paren grep compile text-property-search comint ansi-color
ring linum hi-lock cus-start cus-load tex-site rx
realgud-recursive-autoloads info package easymenu browse-url url
url-proxy url-privacy url-expand url-methods url-history url-cookie
url-domsuf url-util mailcap url-handlers url-parse auth-source cl-seq
eieio eieio-core cl-macs eieio-loaddefs password-cache json subr-x map
url-vars seq byte-opt gv bytecomp byte-compile cconv cl-loaddefs cl-lib
iso-transl tooltip eldoc electric uniquify ediff-hook vc-hooks
lisp-float-type mwheel term/x-win x-win term/common-win x-dnd tool-bar
dnd fontset image regexp-opt fringe tabulated-list replace newcomment
text-mode elisp-mode lisp-mode prog-mode register page tab-bar menu-bar
rfn-eshadow isearch timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core term/tty-colors frame minibuffer cl-generic
cham georgian utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao
korean japanese eucjp-ms cp51932 hebrew greek romanian slovak czech
european ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray
cl-preloaded nadvice button loaddefs faces cus-face macroexp files
window text-properties overlay sha1 md5 base64 format env code-pages
mule custom widget hashtable-print-readable backquote threads dbusbind
inotify lcms2 dynamic-setting font-render-setting move-toolbar gtk
x-toolkit x multi-tty make-network-process emacs)

Memory information:
((conses 16 1238442 1372937)
 (symbols 48 61528 25)
 (strings 32 264002 435110)
 (string-bytes 1 7786784)
 (vectors 16 91754)
 (vector-slots 8 1303782 321774)
 (floats 8 4099 2219)
 (intervals 56 26046 11337)
 (buffers 984 25))




Acknowledgement sent to Bastian Beischer <bastian.beischer@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#46299; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 24 Feb 2021 19:00:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.